SystemOrganization addCategory: #'OrbeonBPMWebBackoffice'!

WABasicBpmChartComposite subclass: #WABpmApplicationChartComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmApplicationChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:05'!
drawProcessInstanceDistributionAndBarChart
	| text |

	report := BpmProcessDefinition reportProcessInstancesQuantityDistributionFor: self getApplicationName.
	report name: ('Process Instances per Process Definition' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Total Process Instances: ' translateFor: self session user), report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.
	canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'.

	report svgContents: canvas contents.! !

!WABpmApplicationChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:05'!
drawProcessInstanceDistributionAndDonutChart
	| text |

	report := BpmProcessDefinition reportProcessInstancesQuantityDistributionFor: self getApplicationName.
	report name: ('Process Instances per Process Definition' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' Total Process Instances: ' translateFor: self session user), report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.
	canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.

	report svgContents: canvas contents.! !

!WABpmApplicationChartComposite methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:07'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'application_charts.html'! !

!WABpmApplicationChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/04/2016 04:55'!
renderChartTypeComboOn: html

	^self renderChartTypeComboOn: html withCharts: #('Bar Chart' 'Donut Chart')! !

!WABpmApplicationChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/04/2016 04:57'!
renderDistributionComboOn: html

	^self renderDistributionComboOn: html withDistribution: #('Process Instances')! !

!WABpmApplicationChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 05:25'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Draw Chart' translateFor: self session user).
			self renderApplicationComboOn: html. 
			self renderDistributionComboOn: html.
			self renderChartTypeComboOn: html.
			self renderShowChartButtonOn: html.
		].
	].! !

!WABpmApplicationChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/01/2016 08:00'!
showChart

	self isProcessInstanceDistributionAndBarChart ifTrue: [^self drawProcessInstanceDistributionAndBarChart].
	self isProcessInstanceDistributionAndDonutChart ifTrue: [^self drawProcessInstanceDistributionAndDonutChart].! !

WABasicBpmChartComposite subclass: #WABpmGlobalChartComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:05'!
drawProcessDefinitionDistributionAndBarChart
	| text |

	report := BpmProcessDefinition reportProcessDefinitionsQuantityDistribution.
	report name: ('Process Definitions by Application' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name,(' | Total Process Definitions: ' translateFor: self session user), report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.
	canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'.

	report svgContents: canvas contents.! !

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:05'!
drawProcessDefinitionDistributionAndDonutChart
	| text |

	report := BpmProcessDefinition reportProcessDefinitionsQuantityDistribution.
	report name: ('Process Definitions by Application' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Total Process Definitions: ' translateFor: self session user), report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.
	canvas drawDonutQuantity: report rootDistribution at: 10@10 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.

	report svgContents: canvas contents.! !

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:05'!
drawProcessInstanceDistributionAndBarChart
	| text |

	report := BpmProcessDefinition reportProcessInstancesQuantityDistribution.
	report name: ('Process Instances by Application' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name,(' | Total Process Instances: ' translateFor: self session user), report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.
	canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'.

	report svgContents: canvas contents.! !

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:05'!
drawProcessInstanceDistributionAndDonutChart
	| text |

	report := BpmProcessDefinition reportProcessInstancesQuantityDistribution.
	report name: ('Process Instances by Application' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Total Process Instances: ' translateFor: self session user), report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.
	canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.

	report svgContents: canvas contents.! !

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:07'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'global_charts.html'! !

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/04/2016 04:55'!
renderChartTypeComboOn: html

	^self renderChartTypeComboOn: html withCharts: #('Bar Chart' 'Donut Chart')! !

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/04/2016 04:57'!
renderDistributionComboOn: html

	^self renderDistributionComboOn: html withDistribution: #('Process Definition' 'Process Instances')! !

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/18/2016 07:11'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Draw Chart' translateFor: self session user).

			self renderDistributionComboOn: html.
			self renderChartTypeComboOn: html.

			self renderShowChartButtonOn: html.
		]
	]! !

!WABpmGlobalChartComposite methodsFor: 'other' stamp: 'BrunoBB 10/31/2016 11:06'!
showChart

	self isProcessDefinitionDistributionAndBarChart ifTrue: [^self drawProcessDefinitionDistributionAndBarChart].
	self isProcessDefinitionDistributionAndDonutChart ifTrue: [^self drawProcessDefinitionDistributionAndDonutChart].

	self isProcessInstanceDistributionAndBarChart ifTrue: [^self drawProcessInstanceDistributionAndBarChart].
	self isProcessInstanceDistributionAndDonutChart ifTrue: [^self drawProcessInstanceDistributionAndDonutChart].! !

WABasicBpmChartComposite subclass: #WABpmProcessChartComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmProcessChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:05'!
drawCreationDayDistributionChart
	| text version |

	version := self isAllVersionSelected ifTrue: [nil] ifFalse: [Number fromString: self getVersion].
	self analyzeQueryBlockIfFail: [:analyzer | ^self queryBlockFailedWith: analyzer].

	report := BpmProcessDefinition reportCreationDayFor: self getProcessName in: self  getApplicationName version: version from: self getStartDate to: self getEndDate satisfying: self queryBlock.
	report name: ('Creation of Processes in Calendar' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.
	text := report name, (' | Total Process Instances: ' translateFor: self session user) , report getTotalValue printString.

	canvas drawText: text at: 20@20 textSizePx: '18px'.

	canvas 
		drawWorkingDays: report rootDistribution
		at: 60@80 
		from: self getStartDate
		to: self getEndDate 
		width: 20 
		color: 'green' 
		dayHasContent: (self searchValueAt: 'dayHasContent' ifAbsent: [true]).

	report svgContents: canvas contents.! !

!WABpmProcessChartComposite methodsFor: 'other' stamp: 'BrunoBB 01/14/2017 09:51'!
drawFieldValueDistribution
	| definition text |

	definition := self getSelectedProcessDefinitions ifEmpty: [^self] ifNotEmpty: [:collection | collection last].
	report := definition reportValueDistributionFor: self getFieldName in: self getFormName from: self getStartDate to: self getEndDate satisfying: self queryBlock.
	self analyzeQueryBlockIfFail: [:analyzer | ^self queryBlockFailedWith: analyzer].
	report name: ('Processes Distribution by Field Value' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Total Process Instances: ' translateFor: self session user) , report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmProcessChartComposite methodsFor: 'other' stamp: 'BrunoBB 01/14/2017 09:52'!
drawFieldValueDoubleDistribution
	| definition text |

	definition := self getSelectedProcessDefinitions ifEmpty: [^self] ifNotEmpty: [:collection | collection last].
	report := definition reportValueDistributionForFieldName: self getFieldName secondaryField: self getFieldName2 in: self getFormName satisfying: self queryBlock.
	self analyzeQueryBlockIfFail: [:analyzer | ^self queryBlockFailedWith: analyzer].
	report name: ('Processes Distribution by Two Field Value' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Total Process Instances: ' translateFor: self session user) , report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isDoubleBarChart ifTrue: [canvas drawJoin: report getFirstSubDistribution
					verticalBarGraph: report rootDistribution 
					at: 15@15 
					maxHeight: 150 
					width: 30
					transform: 'translate(50,300) scale(1.5, 1.5)'].

	self isDoubleDonutChart ifTrue: [canvas drawDoubleDonutQuantity: report rootDistribution 
					subQuantities: report getFirstSubDistribution
					at: 10@10 
					radius: 100 
					subRadiusRatio: 1.4 
					backcolor: 'lightgray' 
					transform:  'translate(200,200)']. 

	report svgContents: canvas contents.! !

!WABpmProcessChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:06'!
drawProcessesAverageDistribution
	| text |

	report := BpmProcessDefinition reportProcessAverageTimeDistributionFor: self getProcessName in: self getApplicationName.
	report name: ('Process Average Time' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Global Average Time: ' translateFor: self session user) , (report printAverageTimeFor: self session user).

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmProcessChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:06'!
drawProcessInstanceDistributionAndBarChart
	| text |

	report := BpmProcessDefinition reportProcessInstancesQuantityDistributionFor: self getProcessName in: self getApplicationName.
	report name: ('Process Distribution by Version' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Total Process Instances: ' translateFor: self session user) , report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.
	canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'.

	report svgContents: canvas contents.! !

!WABpmProcessChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:06'!
drawProcessInstanceDistributionAndDonutChart
	| text |

	report := BpmProcessDefinition reportProcessInstancesQuantityDistributionFor: self getProcessName in: self getApplicationName.
	report name: ('Process Distribution by Version' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Total Process Instances: ' translateFor: self session user), report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.
	canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.

	report svgContents: canvas contents.! !

!WABpmProcessChartComposite methodsFor: 'other' stamp: 'BrunoBB 01/14/2017 09:53'!
drawTasksAverageDistribution
	| definition text |

	definition := self getSelectedProcessDefinitions ifEmpty: [^self] ifNotEmpty: [:collection | collection last].
	report := definition reportAverageTimeDistributionForAllTasksFor: self session user from: self getStartDate to: self getEndDate satisfying: self queryBlock.
	self analyzeQueryBlockIfFail: [:analyzer | ^self queryBlockFailedWith: analyzer].
	report name: ('Average Time by Process Tasks' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Average Time per Task: ' translateFor: self session user) , (report printAverageTimeFor: self session user).

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmProcessChartComposite methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:07'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'processes_charts.html'! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/06/2016 07:14'!
renderChartTypeComboOn: html
	| chartTypes |

	chartTypes := #('Bar Chart' 'Donut Chart').
	self isCreationDayDistribution ifTrue: [chartTypes := #('Day Calendar')].
	self isFieldValueDistribution ifTrue: [chartTypes := #('Bar Chart' 'Double Bar Chart' 'Donut Chart' 'Double Donut Chart')].
	
	^self renderChartTypeComboOn: html withCharts: chartTypes! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:11'!
renderChartTypeComboOn: html withCharts: chartsNames
	| chartTypes |

	chartTypes := chartsNames collect: [:each | each translateFor: self session user]. 

	^self renderGenericActiveComboOn: html withList: chartTypes forVariable: 'chart-type' label: ('Chart Type' translateFor: self session user)! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/07/2016 03:16'!
renderDistributionComboOn: html
	| distributionNames |

	distributionNames := (self isAllVersionSelected ifTrue: [#('Creation Day' 'Field Value' 'Processes Average Time' 'Process Instances')] ifFalse: [#('Creation Day' 'Field Value' 'Tasks Average Time')])
									collect: [:each | each translateFor: self session user].

	^self renderActiveDistributionComboOn: html withDistribution: distributionNames! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/06/2016 07:35'!
renderFormFieldCombo2On: html
	|  fieldNames |

	fieldNames := self getProcessFieldList.
	html div class: 'top-search-div'; with: [
		html label 
			attributeAt: 'for' put: 'form-fields-2';
			with: ('Field' translateFor: self session user).

		html select "Field Definition List" 
			attributeAt: 'id' put: 'form-fields-2';
			class: 'width-200px';
			list: fieldNames;
			callback: [:value | self addSearchValue: value named: 'field-name-2'];
			selected: (self searchValueAt: 'field-name-2' ifAbsent: [fieldNames ifNotEmpty: [fieldNames first].]).
	].! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/06/2016 07:36'!
renderFormFieldComboOn: html
	|  fieldNames |

	fieldNames := self getProcessFieldList.
	html div class: 'top-search-div'; with: [
		html label 
			attributeAt: 'for' put: 'form-fields';
			with: ('Field' translateFor: self session user).

		html select "Field Definition List" 
			attributeAt: 'id' put: 'form-fields';
			class: 'width-200px';
			list: fieldNames;
			onChange: 'submit()';
			callback: [:value | self addSearchValue: value named: 'field-name'];
			selected: (self searchValueAt: 'field-name' ifAbsent: [fieldNames ifNotEmpty: [fieldNames first].]).
	].

	(self isDoubleDonutChart or: [self isDoubleBarChart]) ifTrue: [self renderFormFieldCombo2On: html]! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/19/2016 06:12'!
renderProcessDefinitionComboOn: html
	| definitionNames |

	definitionNames := (BpmProcessDefinition cacheAt: self getApplicationName ifAbsent: [^self]) keys asSortedCollection.

	self renderGenericActiveComboOn: html withList: definitionNames forVariable: 'process-name' label: ('Process' translateFor: self session user).

	(self hasSearchValueAt: 'process-name') ifFalse: [self addSearchValue: definitionNames first named: 'process-name'].! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/05/2016 11:49'!
renderProcessFormsComboOn: html
	| forms |

	html div class: 'top-search-div'; with: [
		html label 
			attributeAt: 'for' put: 'process-forms';
			with: ('Forms' translateFor: self session user).

		forms := self getProcessFormsList.
		html select "Field Definition List" 
			attributeAt: 'id' put: 'process-forms';
			class: 'width-200px';
			list: forms;
			onChange: 'submit()';
			callback: [:value | self addSearchValue: value named: 'form-name'];
			selected: (self searchValueAt: 'form-name' ifAbsent: [forms ifNotEmpty: [forms first]]).
	].

	forms ifEmpty: [^self].

	self renderFormFieldComboOn: html.! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/04/2016 04:44'!
renderProcessVersionsComboOn: html
	| procVersions versions |

	procVersions := BpmProcessDefinition getAllProcessesNamed: self getProcessName in: self getApplicationName.

	versions := procVersions collect: [:each | each version printString].

	self renderGenericActiveComboOn: html withList: (#('All') , versions) forVariable: 'version' label: ('Version' translateFor: self session user).

	(self hasSearchValueAt: 'version') ifFalse: [self addSearchValue: 'All' named: 'version'].! !

!WABpmProcessChartComposite methodsFor: 'render' stamp: 'BrunoBB 11/12/2016 07:05'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Draw Chart' translateFor: self session user).
			self renderApplicationComboOn: html.
			self getApplicationName notNil
			ifTrue: [
				self renderProcessDefinitionComboOn: html.
				self getProcessName notNil 
				ifTrue: [
					self renderProcessVersionsComboOn: html.
					self renderDistributionComboOn: html.
					self renderChartTypeComboOn: html.
					self renderShowChartButtonOn: html.
					(self isCreationDayDistribution or: [self isFieldValueDistribution or:[self isTasksAverageTimeDistribution]])
					ifTrue: [
						self isFieldValueDistribution ifTrue: [self renderProcessFormsComboOn: html]. 
						self renderStartEndDatesOn: html.
						self renderQueryConditionOn: html.
					].
				].
			].
		].
	].! !

!WABpmProcessChartComposite methodsFor: 'draw svg' stamp: 'BrunoBB 11/07/2016 07:11'!
showChart

	(self isProcessInstanceDistributionAndBarChart and: [self isAllVersionSelected]) ifTrue: [^self drawProcessInstanceDistributionAndBarChart].
	(self isProcessInstanceDistributionAndDonutChart and: [self isAllVersionSelected]) ifTrue: [^self drawProcessInstanceDistributionAndDonutChart].

	self isCreationDayDistribution ifTrue: [^self drawCreationDayDistributionChart].

	(self isFieldValueDistribution and: [self isDoubleChart not]) ifTrue: [^self drawFieldValueDistribution].

	(self isFieldValueDistribution and: [self isDoubleChart]) ifTrue: [^self drawFieldValueDoubleDistribution].

	self isProcessesAverageTimeDistribution ifTrue: [^self drawProcessesAverageDistribution].

	self isTasksAverageTimeDistribution ifTrue: [^self drawTasksAverageDistribution].! !

WABasicBpmChartComposite subclass: #WABpmRoleChartComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:06'!
drawAverageTimeForRoleTasksChart
	| text |

	report := self getSelectedRole reportAverageTimeDistributionForAllTasks.
	report name: ('Role Average Time by Task' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Average Time per Task: ' translateFor: self session user) , (report printAverageTimeFor: self session user).

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:06'!
drawNumberOfUsersInRoleChart
	| text |

	report := BpmFrontOfficeRole reportNumberOfUsersDistributionFor: self getApplicationName.
	report name: ('Number of Users per Role' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Number of Users: ' translateFor: self session user) , report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:06'!
drawNumberTasksForRoleInApplicationChart
	| text |

	report := BpmFrontOfficeRole reportNumberOfTasksDistributionFor: self getApplicationName.
	report name: ('Number of Tasks per Role' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Number of Tasks: ' translateFor: self session user) , report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:06'!
drawUnassignedTaskChart
	| text |

	report := BpmFrontOfficeRole reportNumberOfUnassignedTasksFor: self getApplicationName.
	report name: ('Free Tasks per Role' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (' | Unassigned Tasks: ' translateFor: self session user) , report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 09:09'!
getSelectedRole

	^BpmFrontOfficeRole getRoleNamed: self getRoleName in: self getApplicationName! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:08'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'roles_charts.html'! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 08:13'!
renderChartTypeComboOn: html
	| chartTypes |

	chartTypes := #('Bar Chart' 'Donut Chart').
	
	^self renderChartTypeComboOn: html withCharts: chartTypes! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 14:54'!
renderDistributionComboOn: html
	| distributionNames |

	distributionNames := self isAllRolesSelected ifTrue: [#('Number of Tasks' 'Number of Users' 'Unassigned Tasks')] ifFalse: [#('Tasks Average Time')].

	self renderDistributionComboOn: html withDistribution: distributionNames.! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 08:13'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Draw Chart' translateFor: self session user).
			self renderApplicationComboOn: html.
			self getApplicationName ifNil: [^self].
			self renderRolesComboOn: html.
			self renderDistributionComboOn: html.
			self renderChartTypeComboOn: html.
			self renderShowChartButtonOn: html.
		].
	].! !

!WABpmRoleChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 14:55'!
showChart

	(self isNumberOfTasksDistributionSelection and: [self isAllRolesSelected]) ifTrue: [^self drawNumberTasksForRoleInApplicationChart].
	(self isUnassignedTasksDistribution and: [self isAllRolesSelected]) ifTrue: [^self drawUnassignedTaskChart].
	(self isNumberOfUsersDistribution and: [self isAllRolesSelected]) ifTrue: [^self drawNumberOfUsersInRoleChart].

	(self isTasksAverageTimeDistribution and: [self isAllRolesSelected not]) ifTrue: [^self drawAverageTimeForRoleTasksChart].! !

WABasicBpmChartComposite subclass: #WABpmUserChartComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:07'!
drawAverageTaskTimeChart
	| text |

	report := self getSelectedUser reportAverageTimePerTask.
	report name: (' Average Time per Tasks: ' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, (report printAverageTimeFor: self session user).

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:07'!
drawCurrentTaskTypeQuantityChart
	| text |

	report := self getSelectedUser reportCurrentTaskQuantity.
	report name: (' Current Tasks: ' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:07'!
drawFinishedTaskTypeQuantityChart
	| text |

	report := self getSelectedUser reportFinishedTaskQuantity.
	report name: (' Number of Tasks: ' translateFor: self session user);
		creator: self session user. 

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:07'!
drawTaskTypeQuantityChart
	| text |

	report := self getSelectedUser reportFinishedTaskQuantity.
	report name: (' Number of Tasks: ' translateFor: self session user);
		creator: self session user.

	canvas := self svgCanvasClass newWidth: '100%' height: '100%'.

	text := report name, report getTotalValue printString.

	canvas drawText: text at: 10@30 textSizePx: '18px'.

	self isBarChart ifTrue: [canvas drawVerticalBarGraph: report rootDistribution at: 10@10 maxHeight: 270 width: 40 transform: 'translate(20,330)'].
	self isDonutChart ifTrue: [canvas drawDonutQuantity: report rootDistribution at: 10@20 radius: 120 width: 60 backcolor: '#BCBCBC' transform: 'translate(150,170)'.]. 

	report svgContents: canvas contents.! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 13:58'!
getSelectedUser

	^BpmUser getUserNamed: self getBpmUserName! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:08'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'user_charts.html'! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/23/2016 08:10'!
isCurrentTaskTypeQuantityDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Current Tasks by Type' translateFor: self session user)! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/23/2016 08:10'!
isFinishedTaskTypeQuantityDistribution

	^(self searchValueAt: 'distribution' ifAbsent: [nil]) = ('Finished Tasks by Type' translateFor: self session user)! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 06:10'!
renderBpmUsersComboOn: html

	^self renderGenericActiveComboOn: html 
			withList: ((self session user getVisibleUsers asSortedCollection: [:a :b | a username <= b username]) collect: [:each | each username])
			forVariable: 'bpm-user' 
			label: ('User' translateFor: self session user)! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 13:55'!
renderChartTypeComboOn: html

	^self renderChartTypeComboOn: html withCharts: #('Bar Chart' 'Donut Chart')! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/23/2016 08:09'!
renderDistributionComboOn: html

	^self renderDistributionComboOn: html withDistribution: #('Average Time per Task' 'Current Tasks by Type' 'Finished Tasks by Type')! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/08/2016 13:36'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Draw Chart' translateFor: self session user).
			self renderBpmUsersComboOn: html.
			self getBpmUserName ifNil: [^self].
			self renderDistributionComboOn: html.
			self renderChartTypeComboOn: html.
			self renderShowChartButtonOn: html.
		].
	].! !

!WABpmUserChartComposite methodsFor: 'other' stamp: 'BrunoBB 11/09/2016 09:20'!
showChart

	self isFinishedTaskTypeQuantityDistribution ifTrue: [self drawFinishedTaskTypeQuantityChart].

	self isCurrentTaskTypeQuantityDistribution ifTrue: [self drawCurrentTaskTypeQuantityChart].

	self isAverageTaskTimeDistribution ifTrue: [self drawAverageTaskTimeChart].! !

SewafChildComponent subclass: #WABizagiImportReport
	instanceVariableNames: 'warnings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 17:23'!
createDescriptionColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 			
					html text: each description]
			title: 'Description')! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 10/10/2015 15:01'!
createSolutionColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 			
					html text: each solution]
			title: 'Solution')! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 17:23'!
createTitleColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 			
					html text: each title]
			title: 'Title')! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 17:22'!
createTypeColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 			
					html text: each type]
			title: 'Type')! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 03/12/2015 17:21'!
initialize

	super initialize.

	warnings := OrderedCollection new.! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 07/21/2015 14:45'!
renderContentOn: html

	html div id: 'imported-xpdl-report'; class: 'unique-centered-table unique-centered-table-width70'; with: [
		html render: self reportTable.
	].

	html anchor callback: [self answer: true.];
		with: [html image  url: (SEWAFIconLibrary / #arrowback432Png); altText: 'Back to Import Processes'; title: 'Back to Import Processes'].! !

!WABizagiImportReport methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 12:48'!
reportTable

	^(SewafSelectTableReport summary: 'Warnings')
		rows: warnings; "get collection elements"
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: (OrderedCollection new 
						add: self createTypeColumn;
						add: self createTitleColumn;
						add: self createDescriptionColumn;
						add: self createSolutionColumn;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!WABizagiImportReport methodsFor: 'Accessing' stamp: 'BrunoBB 03/12/2015 17:42'!
warnings

   "Return the value of the instance variable 'warnings'."
   ^warnings! !

!WABizagiImportReport methodsFor: 'Updating' stamp: 'BrunoBB 03/12/2015 17:42'!
warnings: newValue

   "Modify the value of the instance variable 'warnings'."
   warnings := newValue! !

SewafPopupComponent subclass: #WANewApplicationPopupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WANewApplicationPopupComponent methodsFor: 'other' stamp: 'BrunoBB 02/16/2017 12:40'!
createApplication
	| appClass appName |

	appName := self componentValueAt: 'appName'.
	(appName isNil or: [appName isEmpty]) ifTrue: [^self].

	appClass := (self componentValueAt: 'isOrbeon') 
		ifNil: [^self]
		ifNotNil: [:aBoolean | aBoolean ifTrue: [OrbeonApplication] ifFalse: [BpmApplication]].

	(appClass newNamed: appName) addToCache.! !

!WANewApplicationPopupComponent methodsFor: 'other' stamp: 'BrunoBB 02/16/2017 12:42'!
renderOn: html

	html div "class: 'jquery-dialog-yes-no';" with: [
		html form with: [
			html fieldSet with: [
				html legend: 'New Application'.
				html label for: 'app-name'; with: ('Application Name' translateFor: self session user).
				html textInput id: 'app-name'; callback: [:value | self addValue: value named: 'appName']. 
				html div class: 'top-search-div margin-top-20px width-120px'; with: [
					html checkbox attributeAt: 'id' put: 'appType'; callback: [:value | self addValue: value named: 'isOrbeon'].
					html label attributeAt: 'for' put: 'appType'; with: ('Is Orbeon ?' translateFor: self session user).
				].
				html submitButton 
					callback: [self createApplication];
					with: ('Create' translateFor: self session user).
			]
		]
	]! !

SewafPopupComponent subclass: #WANewRolePopupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WANewRolePopupComponent methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 08:20'!
createNewRole
	| roleClass newRole roleName appName application |

	appName := (self componentValueAt: 'application') ifNil: [^self] ifNotNil: [:value | value].

	application := self getApplicationManagerClass getAnyApplicationNamed: appName ifNone: [^self].

	roleClass := (self componentValueAt: 'isBackoffice') ifTrue: [BpmBackofficeRole] ifFalse: [BpmFrontOfficeRole].

	roleName := (self componentValueAt: 'rolename' ifAbsent: [^self]) ifNotEmpty: [:value | value] ifEmpty: [^self].

	newRole := roleClass createNewOrGetExisting: roleName in: appName.

	newRole isAdmin: (self componentValueAt: 'isAdmin').

	"the role has been added because #addToCacheInAppName: has answer the same role"
	parent updateRole: newRole.! !

!WANewRolePopupComponent methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 07:32'!
renderApplicationComboOn: html

	html label attributeAt: 'for' put: 'application'; with: ('Application' translateFor: self session user).
	html select 
		attributeAt: 'id' put: 'application';
		list: #(' '), (self session user getBackofficeApplications collect: [:each | each getApplicationNameForCombo]) asSortedCollection; 
		callback: [:value | | selectedApplication | 
			selectedApplication :=  (value size > 9) 
				ifTrue: [self getApplicationManagerClass getAnyApplicationNamed: (value allButLast: 9)]
				ifFalse: [nil].
			self addValue: selectedApplication applicationName named: 'application'.
		]";
		selected: (selectedApplication ifNotNil: [selectedApplication getApplicationNameForCombo] ifNil: [''])".! !

!WANewRolePopupComponent methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 08:24'!
renderOn: html

	html form with: [
		html fieldSet with: [
			html legend class: ''; 
				with: ('Create Role' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'rolname'; with: ('Role Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'rolename'; callback: [:value | self addValue: value named: 'rolename'].
			].
			html div class: 'top-search-div'; with: [
				self renderApplicationComboOn: html].
			html div class: 'top-search-div'; style: 'width: 235px; margin-top: 18px;'; with: [
				html checkbox attributeAt: 'id' put: 'isadmin'; callback: [:value | self addValue: value named: 'isAdmin'].
				html label attributeAt: 'for' put: 'isadmin'; with: ('Is Admin ?' translateFor: self session user).
				html checkbox attributeAt: 'id' put: 'isbackoffice'; callback: [:value | self addValue: value named: 'isBackoffice'].
				html label attributeAt: 'for' put: 'isbackoffice'; with: ('Is Backoffice ?' translateFor: self session user).
			].
			html div class: 'top-search-div'; with: [
				html submitButton 
					style: 'margin-top: 25px;';
					callback: [self createNewRole]; 
					with: ('Create Role' translateFor: self session user)]
		]
	]! !

SewafPopupComponent subclass: #WANewUserPopupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WANewUserPopupComponent methodsFor: 'other' stamp: 'BrunoBB 02/16/2017 13:47'!
createNewUser
	| user userName pwd |

	userName := self componentValueAt: 'username'.
	(userName isNil or: [userName isEmpty]) ifTrue: [^self].
	pwd := self componentValueAt: 'password'. 

	user := BpmUser getExistingOrNewUserNamed: userName password: pwd.

	parent updateListWith: user! !

!WANewUserPopupComponent methodsFor: 'other' stamp: 'BrunoBB 02/16/2017 13:26'!
renderOn: html

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Create User' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'username'; with: ('User Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'username'; callback: [:value | self addValue: value named: 'username'].
			].
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'password'; with: ('Password' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'password'; callback: [:value | self addValue: value named: 'password'].
			].
			html div class: 'top-search-filters-one'; with: [
				html submitButton 
					style: 'margin-top: 25px;';
					callback: [self createNewUser]; 
					with: ('Create User' translateFor: self session user)]
		]
	]! !

SewafLateralListComposite subclass: #WABpmApplicationBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmApplicationBrowser methodsFor: 'xpdl download' stamp: 'BrunoBB 01/13/2017 12:23'!
downloadProcessMap: procName
	| bpmProcDefinition |

	bpmProcDefinition := BpmProcessDefinition getLatestProcessDefinitionNamed: procName in: selectedLateralItem applicationName.

	bpmProcDefinition hasSubProcesses
	ifTrue: [self downloadZipProcessMapOf: bpmProcDefinition] 
	ifFalse: [self downloadProcessMapOf: bpmProcDefinition].! !

!WABpmApplicationBrowser methodsFor: 'xpdl download' stamp: 'BrunoBB 01/13/2017 12:33'!
downloadProcessMapOf: aBpmProcessDefinition

	self requestContext respond: [:response | 
        response document: ((aBpmProcessDefinition getProcessMapStream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmProcessDefinition processName, '.xpdl'); 
                                        yourself)].! !

!WABpmApplicationBrowser methodsFor: 'xpdl download' stamp: 'BrunoBB 01/13/2017 12:52'!
downloadZipProcessMapOf: aBpmProcessDefinition
	| fileName stream |

	stream := aBpmProcessDefinition getProcessMapStream.
	fileName := stream gsfile name.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/octet-stream'; 
                                        fileName: fileName; 
                                        yourself)].! !

!WABpmApplicationBrowser methodsFor: 'xpdl download' stamp: 'BrunoBB 01/13/2017 07:32'!
exportProcessDefinitionAs: procName
	| selectedOption stream bpmProcDefinition |

	selectedOption := (self componentValueAt: 'exportProcess') "the jqdialog set this value"ifNil: [^self] ifNotNil: [:value | value].

	(selectedOption = #xpdl) ifTrue: [^self downloadProcessMap: procName].

	(selectedOption = #svg) ifFalse: [^self].

	stream := PrintStream on: String new.

	bpmProcDefinition := BpmProcessDefinition getLatestProcessDefinitionNamed: procName in: selectedLateralItem applicationName.
	stream nextPutAll: 
		(self xmlHeader, String lf,
		((BizagiSvgConverter convert: bpmProcDefinition xmlString) generateSVGFor: bpmProcDefinition)).

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'image/svg+xml'; 
                                        fileName: (procName, '.svg'); 
                                        yourself)].! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 12:23'!
getCurrentCollection

	searchApplied 
	ifFalse: [^lateralCollection := self session user getBackofficeApplications 
												asSortedCollection: [:a :b | a applicationName <= b applicationName]].

	^searchResult! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 10:16'!
getIconNameFormItem

	^#boxesbrown32Png! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 10:17'!
getTextForItem: aLateralListItem

	^aLateralListItem applicationName! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:06'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'manage-applications.html'! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 10:41'!
initialize

	super initialize.

	searchAvailable := false.

	self setShowToElementNamed: 'search-area'.

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: self session user lateralListPagingSize;
		navigationCssClass: 'batch-div-lateral-top'.! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 10:41'!
removeApplication

	(self componentValueAt: 'removeApp') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].

	selectedLateralItem removeFromCache.

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	batchedList  remove: selectedLateralItem.

	selectedLateralItem := nil.

	self removeValueNamed: 'removeApp'! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 08:25'!
renderAddApplicationOn: html
   | jQueryId |

	jQueryId := self renderJQueryPopupCompositeOn: html width: 350 height: 200 composite: WANewApplicationPopupComponent title: 'Create Application' domainObject: nil arguments: #().

	html div class: 'float-right margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #add24Png); 
												title: ('Add Application' translateFor: self session user); 
												altText: ('Add Application' translateFor: self session user) ]
	]! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 10:22'!
renderDeleteApplicationOn: html
   | jQueryId |

	jQueryId := self renderJQueryConfirmationDialogOn: html forActionNamed: 'removeApp' actionMethod: #removeApplication.

	html div class: 'float-left margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #remove24Png); 
												title: ('Remove Application' translateFor: self session user); 
												altText: ('Remove Application' translateFor: self session user) ]
	]! !

!WABpmApplicationBrowser methodsFor: 'xpdl download' stamp: 'BrunoBB 01/13/2017 07:21'!
renderDownloadProcessMapOn: html for: procName
	| jQueryId options |

	options := Array with: #('Export XPDL' #xpdl) with: #('View SVG' #svg).

	jQueryId := self renderJQuerySelectOptionDialogOn: html buttonsNames: options forActionNamed: 'exportProcess' actionMethod: #exportProcessDefinitionAs: arguments: (Array with: procName) extent: 420@120.

	html anchor 
		class: 'cursor-pointer';
		"callback: [self downloadProcessMap]; "
		onClick: (html jQuery id: jQueryId) dialog open;
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 02/16/2017 09:06'!
renderItemComponentOn: html
	| point |

	selectedLateralItem ifNil: [^self].

	selectedLateralItem canDelete ifTrue: [self renderDeleteApplicationOn: html].
	self renderAddApplicationOn: html.  

	point := 10@10.
	(BpmProcessDefinition getAllProcessNamesIn: selectedLateralItem applicationName) do: [:procName |
		self renderProcessWithLinkOn: html at: point name: procName.
	].! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 12:03'!
renderItemDescriptionAditionalDataOn: html

	html span: [html strong: ('Type:' translateFor: self session user)]. 
	html output: selectedLateralItem printType.! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 01/13/2017 06:08'!
renderItemDescriptionSecondaryDataOn: html
	| procsSize formsSize |

	procsSize := selectedLateralItem getNumberOfProcessesDefinition.
	formsSize := selectedLateralItem getNumberOfFormsDefinition.

	html span with: [html strong: ('Number of Processes Definition:' translateFor: self session user)].
	html output: procsSize printString.

	html span with: [html strong: ('Number of Forms Definition:' translateFor: self session user)].
	html output: formsSize printString.

	(procsSize = 0) ifTrue: [^self].
 
	html span with: [html strong: ('Average of Forms in a Process:' translateFor: self session user)].
	html output: ((formsSize/procsSize) asScaledDecimal: 1)  printString.! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 10:18'!
renderItemDescriptionTitleOn: html

	html output:  selectedLateralItem applicationName.! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 12:02'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem printType].! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 01/09/2017 06:14'!
renderNewAppFormOn: html

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Create Application' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'appName'; with: ('Application Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'appName'; callback: [:value | self addValue: value named: 'appName'].
			].
			html div class: 'top-search-div margin-top-20px width-120px'; with: [
				html checkbox attributeAt: 'id' put: 'appType'; callback: [:value | self addValue: value named: 'isOrbeon'].
				html label attributeAt: 'for' put: 'appType'; with: ('Is Orbeon ?' translateFor: self session user).
			].
			html div class: 'top-search-filters-one'; with: [
				html submitButton 
					style: 'margin-top: 25px;';
					callback: [self createNewApplication]; 
					with: ('Create Application' translateFor: self session user)]
		]
	]! !

!WABpmApplicationBrowser methodsFor: 'xpdl download' stamp: 'BrunoBB 02/13/2017 15:32'!
renderProcessWithLinkOn: html at: aPoint name: procName
	| canvas |

	canvas := JASVGIBpmCanvas newWidth: '200px' height: '72px'.
	canvas cancelDefaultGroupTranslation.

	(procName size > 28) 
	ifTrue: [canvas drawSubProcessActivityNamed: procName at: aPoint extent: 180@60 textSizePx: '12px'.] 
	ifFalse: [canvas drawSubProcessActivityNamed: procName at: aPoint extent: 180@60].

	html div class: 'float-left'; with: [ 
		html div with: [html html: canvas contents].
		html div class: 'float-right margin-right-10px'; with: [ | versionsInfo |
			versionsInfo :=  (BpmProcessDefinition  getLatestProcessDefinitionNamed: procName in: selectedLateralItem applicationName) version
									ifNil: ['v1'] ifNotNil: [:ver | 'v',ver printString]. 
			html output: versionsInfo.	
			self renderDownloadProcessMapOn: html for: procName.
		].
	].! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 01/09/2017 06:36'!
renderSearchApplicationOn: html

	html form with: [ 
		html fieldSet with: [
			html legend class: 'top-search-legend'; with: ('Search Appication' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'appId'; with: ('Application Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'appId'; 
						callback: [:value | self addSearchValue: value named: 'appName'];
						value: (self searchValueAt: 'appName')].
			html div class: 'top-search-filters-two'; with: [self renderSearchSubmitButtonOn: html].
		].
	]! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 04/14/2017 16:04'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html div id: 'searchUserForm'; with: [self renderSearchApplicationOn: html].! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 11:12'!
renderSearchSubmitButtonOn: html

	html submitButton 
		style: 'margin-top: 35px;';
		callback: [self searchMatchingApplications]; 
		with: ('Search' translateFor: self session user).! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 01/25/2017 04:54'!
searchMatchingApplications
	| appName |

	appName := self searchValueAt: 'appName' ifAbsent: [''].

	searchApplied := true.

	^searchResult := self session user getBackofficeApplications select: [:each | (appName, '*') match: each applicationName]! !

!WABpmApplicationBrowser methodsFor: 'other' stamp: 'BrunoBB 01/13/2017 13:23'!
xmlHeader

	^'<?xml version="1.0" encoding="utf-8"?>'! !

SewafLateralListComposite subclass: #WABpmApplicationBrowser2
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmApplicationBrowser2 methodsFor: 'xpdl download' stamp: 'BrunoBB 02/17/2017 13:50'!
downloadProcessMap: procName
	| bpmProcDefinition |

	bpmProcDefinition := BpmProcessDefinition getLatestProcessDefinitionNamed: procName in: selectedLateralItem applicationName.

	bpmProcDefinition hasSubProcesses
	ifTrue: [self downloadZipProcessMapOf: bpmProcDefinition] 
	ifFalse: [self downloadProcessMapOf: bpmProcDefinition].! !

!WABpmApplicationBrowser2 methodsFor: 'xpdl download' stamp: 'BrunoBB 02/17/2017 13:50'!
downloadProcessMapOf: aBpmProcessDefinition

	self requestContext respond: [:response | 
        response document: ((aBpmProcessDefinition getProcessMapStream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmProcessDefinition processName, '.xpdl'); 
                                        yourself)].! !

!WABpmApplicationBrowser2 methodsFor: 'xpdl download' stamp: 'BrunoBB 02/17/2017 13:50'!
downloadZipProcessMapOf: aBpmProcessDefinition
	| fileName stream |

	stream := aBpmProcessDefinition getProcessMapStream.
	fileName := stream gsfile name.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/octet-stream'; 
                                        fileName: fileName; 
                                        yourself)].! !

!WABpmApplicationBrowser2 methodsFor: 'xpdl download' stamp: 'BrunoBB 02/17/2017 13:50'!
exportProcessDefinitionAs: procName
	| selectedOption stream bpmProcDefinition |

	selectedOption := (self componentValueAt: 'exportProcess') "the jqdialog set this value"ifNil: [^self] ifNotNil: [:value | value].

	(selectedOption = #xpdl) ifTrue: [^self downloadProcessMap: procName].

	(selectedOption = #svg) ifFalse: [^self].

	stream := PrintStream on: String new.

	bpmProcDefinition := BpmProcessDefinition getLatestProcessDefinitionNamed: procName in: selectedLateralItem applicationName.
	stream nextPutAll: 
		(self xmlHeader, String lf,
		((BizagiSvgConverter convert: bpmProcDefinition xmlString) generateSVGFor: bpmProcDefinition)).

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'image/svg+xml'; 
                                        fileName: (procName, '.svg'); 
                                        yourself)].! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
getCurrentCollection

	searchApplied 
	ifFalse: [^lateralCollection := self session user getBackofficeApplications 
												asSortedCollection: [:a :b | a applicationName <= b applicationName]].

	^searchResult! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
getIconNameFormItem

	^#boxesbrown32Png! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
getTextForItem: aLateralListItem

	^aLateralListItem applicationName! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:07'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'manage-applications.html'! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
initialize

	super initialize.

	searchAvailable := false.

	self setShowToElementNamed: 'search-area'.

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: self session user lateralListPagingSize;
		navigationCssClass: 'batch-div-lateral-top'.! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
removeApplication

	(self componentValueAt: 'removeApp') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].

	selectedLateralItem removeFromCache.

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	batchedList  remove: selectedLateralItem.

	selectedLateralItem := nil.

	self removeValueNamed: 'removeApp'! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderAddApplicationOn: html
   | jQueryId |

	jQueryId := self renderJQueryPopupCompositeOn: html width: 350 height: 200 composite: WANewApplicationPopupComponent title: 'Create Application' domainObject: nil arguments: #().

	html div class: 'float-right margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #add24Png); 
												title: ('Add Application' translateFor: self session user); 
												altText: ('Add Application' translateFor: self session user) ]
	]! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderDeleteApplicationOn: html
   | jQueryId |

	jQueryId := self renderJQueryConfirmationDialogOn: html forActionNamed: 'removeApp' actionMethod: #removeApplication.

	html div class: 'float-left margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #remove24Png); 
												title: ('Remove Application' translateFor: self session user); 
												altText: ('Remove Application' translateFor: self session user) ]
	]! !

!WABpmApplicationBrowser2 methodsFor: 'xpdl download' stamp: 'BrunoBB 02/17/2017 13:50'!
renderDownloadProcessMapOn: html for: procName
	| jQueryId options |

	options := Array with: #('Export XPDL' #xpdl) with: #('View SVG' #svg).

	jQueryId := self renderJQuerySelectOptionDialogOn: html buttonsNames: options forActionNamed: 'exportProcess' actionMethod: #exportProcessDefinitionAs: arguments: (Array with: procName) extent: 420@120.

	html anchor 
		class: 'cursor-pointer';
		"callback: [self downloadProcessMap]; "
		onClick: (html jQuery id: jQueryId) dialog open;
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderItemComponentOn: html
	| point |

	selectedLateralItem ifNil: [^self].

	selectedLateralItem canDelete ifTrue: [self renderDeleteApplicationOn: html].
	self renderAddApplicationOn: html.  

	point := 10@10.
	(BpmProcessDefinition getAllProcessNamesIn: selectedLateralItem applicationName) do: [:procName |
		self renderProcessWithLinkOn: html at: point name: procName.
	].! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderItemDescriptionAditionalDataOn: html

	html span: [html strong: ('Type:' translateFor: self session user)]. 
	html output: selectedLateralItem printType.! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderItemDescriptionSecondaryDataOn: html
	| procsSize formsSize |

	procsSize := selectedLateralItem getNumberOfProcessesDefinition.
	formsSize := selectedLateralItem getNumberOfFormsDefinition.

	html span with: [html strong: ('Number of Processes Definition:' translateFor: self session user)].
	html output: procsSize printString.

	html span with: [html strong: ('Number of Forms Definition:' translateFor: self session user)].
	html output: formsSize printString.

	(procsSize = 0) ifTrue: [^self].
 
	html span with: [html strong: ('Average of Forms in a Process:' translateFor: self session user)].
	html output: ((formsSize/procsSize) asScaledDecimal: 1)  printString.! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderItemDescriptionTitleOn: html

	html output:  selectedLateralItem applicationName.! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem printType].! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderNewAppFormOn: html

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Create Application' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'appName'; with: ('Application Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'appName'; callback: [:value | self addValue: value named: 'appName'].
			].
			html div class: 'top-search-div margin-top-20px width-120px'; with: [
				html checkbox attributeAt: 'id' put: 'appType'; callback: [:value | self addValue: value named: 'isOrbeon'].
				html label attributeAt: 'for' put: 'appType'; with: ('Is Orbeon ?' translateFor: self session user).
			].
			html div class: 'top-search-filters-one'; with: [
				html submitButton 
					style: 'margin-top: 25px;';
					callback: [self createNewApplication]; 
					with: ('Create Application' translateFor: self session user)]
		]
	]! !

!WABpmApplicationBrowser2 methodsFor: 'xpdl download' stamp: 'BrunoBB 02/17/2017 13:50'!
renderProcessWithLinkOn: html at: aPoint name: procName
	| canvas |

	canvas := JASVGIBpmCanvas newWidth: '200px' height: '72px'.
	canvas cancelDefaultGroupTranslation.

	(procName size > 28) 
	ifTrue: [canvas drawSubProcessActivityNamed: procName at: aPoint extent: 180@60 textSizePx: '12px'.] 
	ifFalse: [canvas drawSubProcessActivityNamed: procName at: aPoint extent: 180@60].

	html div class: 'float-left'; with: [ 
		html div with: [html html: canvas contents].
		html div class: 'float-right margin-right-10px'; with: [ | versionsInfo |
			versionsInfo :=  (BpmProcessDefinition  getLatestProcessDefinitionNamed: procName in: selectedLateralItem applicationName) version
									ifNil: ['v1'] ifNotNil: [:ver | 'v',ver printString]. 
			html output: versionsInfo.	
			self renderDownloadProcessMapOn: html for: procName.
		].
	].! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderSearchApplicationOn: html

	html form with: [ 
		html fieldSet with: [
			html legend class: 'top-search-legend'; with: ('Search Appication' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'appId'; with: ('Application Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'appId'; 
						callback: [:value | self addSearchValue: value named: 'appName'];
						value: (self searchValueAt: 'appName')].
			html div class: 'top-search-filters-two'; with: [self renderSearchSubmitButtonOn: html].
		].
	]! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html div id: 'searchUserForm'; with: [self renderSearchApplicationOn: html].! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
renderSearchSubmitButtonOn: html

	html submitButton 
		style: 'margin-top: 35px;';
		callback: [self searchMatchingApplications]; 
		with: ('Search' translateFor: self session user).! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
searchMatchingApplications
	| appName |

	appName := self searchValueAt: 'appName' ifAbsent: [''].

	searchApplied := true.

	^searchResult := self session user getBackofficeApplications select: [:each | (appName, '*') match: each applicationName]! !

!WABpmApplicationBrowser2 methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 13:50'!
xmlHeader

	^'<?xml version="1.0" encoding="utf-8"?>'! !

SewafLateralListComposite subclass: #WABpmCalendarManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/15/2017 07:44'!
addCalendar
	| calendarName |

	calendarName := self componentValueAt: 'prompt' ifAbsent: [^self].

	(BpmExceptionCalendar new name: calendarName) addToCache.! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/13/2017 12:12'!
addOfficeHours

	0 to: 7 do: [:index| | startTime endTime |
		startTime := Time fromString: (index printString, ':00').
		endTime := Time fromString: (index printString, ':59:59').
		(selectedLateralItem timeIntervalExistFrom: startTime to: endTime) ifFalse: [selectedLateralItem addExceptionTimeFrom: startTime to: endTime].
	].

	17 to: 23 do: [:index| | startTime endTime |
		startTime := Time fromString: (index printString, ':00').
		endTime := Time fromString: (index printString, ':59:59').
		(selectedLateralItem timeIntervalExistFrom: startTime to: endTime) ifFalse: [selectedLateralItem addExceptionTimeFrom: startTime to: endTime].
	].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/15/2017 14:18'!
addRemoveDay: date

	(selectedLateralItem isExceptionDay: date)
	ifTrue: [selectedLateralItem removeExceptionDay: date]
	ifFalse: [selectedLateralItem	addExceptionDay: date ]! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/15/2017 12:59'!
addRemoveHour: time
	| endTime |

	endTime := time addTime: (Time fromString: '00:59:59').

	(selectedLateralItem timeIntervalExistFrom: time to: endTime)
	ifTrue: [selectedLateralItem removeExceptionTimeFrom: time to: endTime]
	ifFalse: [selectedLateralItem addExceptionTimeFrom: time to: endTime].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 09:09'!
addSaturdays

	selectedLateralItem addAllSaturdayOf: Date today year! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 09:38'!
addSelectedDay

	(self componentValueAt: 'startDate') ifNil: [^self].

	selectedLateralItem addExceptionDay: (Date fromString: (self componentValueAt: 'startDate'))! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/13/2017 12:12'!
addSelectedHour
	| startTime endTime |

	(self componentValueAt: 'hour') ifNil: [^self].

	startTime := Time fromString: (self componentValueAt: 'hour').
	endTime := startTime addTime: (Time fromString: '00:59:59').

	selectedLateralItem addExceptionTimeFrom: startTime to: endTime! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 09:08'!
addSundays

	selectedLateralItem addAllSundayOf: Date today year! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:31'!
getCurrentCollection

	searchApplied 
	ifFalse: [^lateralCollection := BpmExceptionCalendar cache
												asSortedCollection: [:a :b | a name <= b name]].

	^searchResult! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/13/2017 11:43'!
getDayHours

	^#('00:00' '01:00' '02:00' '03:00' '04:00' '05:00' '06:00' '07:00' '08:00' '09:00' '10:00' '11:00' '12:00' '13:00' '14:00' '15:00' '16:00' '17:00' '18:00' '19:00' '20:00' '21:00' '22:00' '23:00')! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 17:03'!
getIconNameFormItem

	^#calendaricon32Png! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:22'!
getTextForItem: aLateralListItem

	^aLateralListItem name! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:07'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'manage-calendars.html'! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 13:12'!
initialize

	super initialize.

	searchAvailable := false.

	self setShowToElementNamed: 'search-area'.

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: self session user lateralListPagingSize;
		navigationCssClass: 'batch-div-lateral-top'.

	self addValue: false named: 'hoursPane'.! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 17:14'!
removeCalendar

	(self componentValueAt: 'removeCalendar') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].
	
	selectedLateralItem removeFromCache.

	lateralCollection remove: selectedLateralItem ifAbsent: [].
	batchedList  remove: selectedLateralItem.

	selectedLateralItem := nil.

	self removeValueNamed: 'removeCalendar'! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/13/2017 12:13'!
removeOfficeHours

	0 to: 7 do: [:index| | startTime endTime |
		startTime := Time fromString: (index printString, ':00').
		endTime := Time fromString: (index printString, ':59:59').
		(selectedLateralItem timeIntervalExistFrom: startTime to: endTime) ifTrue: [selectedLateralItem removeExceptionTimeFrom: startTime to: endTime].
	].

	17 to: 23 do: [:index| | startTime endTime |
		startTime := Time fromString: (index printString, ':00').
		endTime := Time fromString: (index printString, ':59:59').
		(selectedLateralItem timeIntervalExistFrom: startTime to: endTime) ifTrue: [selectedLateralItem removeExceptionTimeFrom: startTime to: endTime].
	].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 09:09'!
removeSaturdays

	selectedLateralItem removeAllSaturdayOf: Date today year! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 10:50'!
removeSelectedDay

	(self componentValueAt: 'startDate') ifNil: [^self].

	selectedLateralItem removeExceptionDay: (Date fromString: (self componentValueAt: 'startDate'))! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/13/2017 11:40'!
removeSelectedHour
	| startTime endTime |

	(self componentValueAt: 'hour') ifNil: [^self].

	startTime := Time fromString: (self componentValueAt: 'hour').
	endTime := startTime addSeconds: ((60*60) - 1).

	selectedLateralItem removeExceptionTimeFrom: startTime to: endTime! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 09:10'!
removeSundays

	selectedLateralItem removeAllSundayOf: Date today year! !

!WABpmCalendarManager methodsFor: 'jquery' stamp: 'BrunoBB 02/15/2017 07:38'!
renderAddCalendarOn: html
   | jQueryId |

	jQueryId := self renderJQueryPromptDialogOn: html title: 'Calendar' information: 'Add New Calendar' prompt: 'Calendar Name' buttonLabel: 'Add' forActionNamed: #addCalendar  arguments: #().

	html div class: 'float-right margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #add24Png); 
												title: ('Add Calendar' translateFor: self session user); 
												altText: ('Add Calendar' translateFor: self session user) ]
	]! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/15/2017 14:16'!
renderCalendarDaysOn: html
	| year notWorkingDays |

	notWorkingDays := Dictionary new.
	year := Date today year.

	selectedLateralItem days do: [:each | notWorkingDays at: each dayOfYear put: 100].

	html div class: 'float-left'; 
		with: [html svgCanvas
					attributeAt: 'width' put: '820px';
					attributeAt: 'height' put: '200px';
					with: [html drawCalendar: notWorkingDays 
									at: 10@10 
									from: (Date fromString: '01/01/', year printString) 
									to: (Date fromString: '06/30/', year printString) 
									width: 18 
									color: 'darkred' 
									dayHasContent: true
									parent: self
									actionMethod: #addRemoveDay:].
				].

	html div class: 'float-left'; 
		with: [html svgCanvas
					attributeAt: 'width' put: '820px';
					attributeAt: 'height' put: '200px';
					with: [html drawCalendar: notWorkingDays 
									at: 10@10 
									from: (Date fromString: '07/01/', year printString) 
									to: (Date fromString: '12/31/', year printString) 
									width: 18 
									color: 'darkred' 
									dayHasContent: true
									parent: self
									actionMethod: #addRemoveDay:].
				].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/15/2017 13:16'!
renderCalendarHoursOn: html

	html div class: 'float-left'; 
		with: [html svgCanvas
					attributeAt: 'width' put: '1200px';
					attributeAt: 'height' put: '600px';
					with: [html drawHourCalendar: selectedLateralItem at: 20@20 width: 50 color: 'red' dayHasContent: true parent: self actionMethod: #addRemoveHour:].
				].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/15/2017 13:00'!
renderCalendarHoursOperationsOn: html

	html div class: 'float-left'; with: [
		html anchor class: 'margin-left-5px';
				callback: [self addValue: false named: 'hoursPane']; 
				with: [html image url: (SEWAFIconLibrary / #calendaricon32Png);
										title: ('Set Days' translateFor: self session user);
										altText: ('Set Days' translateFor: self session user)].
	].
	html div with: [
		html div class: 'float-left centered-unique-form'; with: [
			html form with: [
				html fieldSet with: [
					html legend with: [html strong: ('Global Operations' translateFor: self session user)].
						html submitButton callback: [self addOfficeHours]; with: ('Add Office Hours' translateFor: self session user).
						html submitButton callback: [self removeOfficeHours]; with: ('Remove Office Hours' translateFor: self session user).
				]
			]
		].
	].
"	html div class: 'float-left centered-unique-form'; with: [
		html form with: [
			html fieldSet with: [
				html legend with: [html strong: ('Add Hours' translateFor: self session user)].
					html label attributeAt: 'for' put: 'startDate'; with: ('Select Hour' translateFor: self session user).
					self renderGenericActiveComboOn: html withList: (#(''), self getDayHours) in: componentValues forVariable: 'hour' label: ('Hour' translateFor: self session user).
					html submitButton callback: [self addSelectedHour]; with: ('Add' translateFor: self session user).
					html submitButton callback: [self removeSelectedHour]; with: ('Remove' translateFor: self session user).
			]
		]
	].
"! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'brunobb 11/05/2017 13:01'!
renderCalendarOperationsOn: html

	html div class: 'float-left'; with: [
		html anchor class: 'margin-left-5px';
				callback: [self addValue: true named: 'hoursPane']; 
				with: [html image url: (SEWAFIconLibrary / #clock32Png);
										title: ('Set Hours' translateFor: self session user);
										altText: ('Set Hours' translateFor: self session user)].
	].
	html div class: 'float-left'; with: [
		html div class: 'margin-left-10px float-left centered-unique-form'; with: [
			html form with: [
				html fieldSet with: [
					html legend with: [html strong: ('Global Operations' translateFor: self session user)].
						html label with: ('Select Operation' translateFor: self session user).
						html submitButton callback: [self addSundays]; with: ('Add Sundays' translateFor: self session user).
						html submitButton callback: [self removeSundays]; with: ('Remove Sundays' translateFor: self session user).	
						html submitButton callback: [self addSaturdays]; with: ('Add Saturdays' translateFor: self session user).
						html submitButton callback: [self removeSaturdays]; with: ('Remove Saturdays' translateFor: self session user).
				]
			]
		].
		html div class: 'margin-left-10px float-left  centered-unique-form'; with: [
			html form with: [
				html fieldSet with: [
					html legend with: [html strong: ('Add Days' translateFor: self session user)].
						html label attributeAt: 'for' put: 'startDate'; with: ('Select Date' translateFor: self session user).
						html textInput 
							class: 'width-100px';
							attributeAt: 'id' put: 'startDate';
							value: ((self componentValueAt: 'startDate') ifNil: [Date today] ifNotNil: [:value | value]);
							callback: [ :value | self addValue: value named: 'startDate'];
							script: (html jQuery new datepicker onSelect: (html jQuery ajax serializeThis)).
						html submitButton callback: [self addSelectedDay]; with: ('Add' translateFor: self session user).
						html submitButton callback: [self removeSelectedDay]; with: ('Remove' translateFor: self session user).
				]
			]
		].
	].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/13/2017 15:07'!
renderCompleteItemOn: html

	selectedLateralItem ifNil: [^self].

	html div id: 'item-customized-component'; class: 'margin-top-10px ';
		with: [self renderItemComponentOn: html.].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/15/2017 07:14'!
renderDeleteCalendarOn: html
   | jQueryId |

	jQueryId := self renderJQueryConfirmationDialogOn: html forActionNamed: 'removeCalendar' actionMethod: #removeCalendar.

	html div class: 'float-right margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #remove24Png); 
												title: ('Remove Calendar' translateFor: self session user); 
												altText: ('Remove Calendar' translateFor: self session user) ]
	]! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'brunobb 11/05/2017 12:54'!
renderItemComponentOn: html

	selectedLateralItem ifNil: [^self].

	(selectedLateralItem name = 'Default') ifFalse: [self renderDeleteCalendarOn: html]. "Default calendar can not be removed"
	self renderAddCalendarOn: html.

	html div class: 'float-left'; with: [
		(self componentValueAt: 'hoursPane') 
		ifFalse: [html div with: [
			self renderCalendarOperationsOn: html.
			self renderCalendarDaysOn: html.]]
		ifTrue: [html div with: [
			self renderCalendarHoursOperationsOn: html.
			self renderCalendarHoursOn: html]].
	].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:28'!
renderItemDescriptionAditionalDataOn: html

	html span: [html strong: ('Calendar Name:' translateFor: self session user)].
	html output: selectedLateralItem name.! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:29'!
renderItemDescriptionSecondaryDataOn: html

	selectedLateralItem ifNil: [^self].
"
	html span with: [html strong: ('Version:' translateFor: self session user)].
	html output: selectedLateralItem version.
"! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:31'!
renderItemDescriptionTitleOn: html

	html output:  selectedLateralItem name.! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:29'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem name].! !

!WABpmCalendarManager methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:21'!
renderSearchAreaOn: html! !

SewafLateralListComposite subclass: #WABpmChartRepositoryComposite
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 07:15'!
getApplicationName

	^self searchValueAt: 'application' ifAbsent: [nil]! !

!WABpmChartRepositoryComposite methodsFor: 'subclass responsibility' stamp: 'BrunoBB 11/19/2016 07:47'!
getCurrentCollection

	searchApplied ifFalse: [^lateralCollection].

	^searchResult! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:45'!
getFormName

	^self searchValueAt: 'form-name' ifAbsent: [nil]! !

!WABpmChartRepositoryComposite methodsFor: 'subclass responsibility' stamp: 'BrunoBB 11/19/2016 07:47'!
getIconNameFormItem

	^#customreports32Png! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:35'!
getProcessFormsList
	| forms |

	forms := OrderedCollection new.

	self getSelectedProcessDefinitions do: [:procDef | forms addAll: procDef getOrderedTasksNames].

	^forms asSet asSortedCollection! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 03:26'!
getProcessName

	^self searchValueAt: 'process-name' ifAbsent: [nil]! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:34'!
getSelectedProcessDefinitions
	| versions |

	versions := BpmProcessDefinition getAllProcessesNamed: self getProcessName in: self getApplicationName.

	^versions select: [:each | each version printString = self getVersion]! !

!WABpmChartRepositoryComposite methodsFor: 'subclass responsibility' stamp: 'BrunoBB 11/19/2016 07:48'!
getTextForItem: aLateralListItem

	^aLateralListItem name! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 07:31'!
getUserName

	^self searchValueAt: 'user-name' ifAbsent: [nil]! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:35'!
getVersion

	^self searchValueAt: 'version' ifAbsent: [nil]! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 05:53'!
initialize

	super initialize.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 07:08'!
isApplicationComboAvailable

	^self isGlobalReportSelected not and: [self isUserReportSelected not]! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:54'!
isApplicationReportSelected

	^(self searchValueAt: 'report-type' ifAbsent: [^true]) = ('Application Report' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 03:49'!
isFieldComboAvailable

	^self isFieldReportSelected or: [self isRecursiveFieldReportSelected]! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:00'!
isFieldReportSelected

	^(self searchValueAt: 'report-type' ifAbsent: [^false]) = ('Field Report' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 07:19'!
isGlobalReportSelected

	^(self searchValueAt: 'report-type' ifAbsent: [^true]) = ('Global Report' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 03:48'!
isProcessDefinitionComboAvailable

	^self isProcessReportSelected or: [self isFieldReportSelected or: [self isRecursiveFieldReportSelected]]! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:54'!
isProcessReportSelected

	^(self searchValueAt: 'report-type' ifAbsent: [^true]) = ('Process Report' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:00'!
isRecursiveFieldReportSelected

	^(self searchValueAt: 'report-type' ifAbsent: [^false]) = ('Recursive Field Report' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:55'!
isRoleReportSelected

	^(self searchValueAt: 'report-type' ifAbsent: [^true]) = ('Role Report' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 07:26'!
isUserComboAvailable

	^self isUserReportSelected! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 07:35'!
isUserReportSelected

	^(self searchValueAt: 'report-type' ifAbsent: [^false]) = ('User Report' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'subclass responsibility' stamp: 'BrunoBB 11/19/2016 08:24'!
removeSelectedReport

	(self componentValueAt: 'deleteReport' ifAbsent: [^self]) 
	ifFalse: [^self].

	selectedLateralItem removeFromCache.
	self getCurrentCollection remove: selectedLateralItem ifAbsent: [].
	selectedLateralItem := nil! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 07:24'!
renderApplicationComboOn: html

	^self renderGenericActiveComboOn: html 
			withList: (#(''), (self session user getBackofficeApplications collect: [:each | each applicationName]) asSortedCollection) 
			forVariable: 'application' 
			label: ('Application' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'subclass responsibility' stamp: 'BrunoBB 11/19/2016 07:59'!
renderItemComponentOn: html

	selectedLateralItem ifNil: [^self].

	html div id: 'bpm-report-graph';
		with: [html html: selectedLateralItem svgContents].! !

!WABpmChartRepositoryComposite methodsFor: 'subclass responsibility' stamp: 'BrunoBB 11/21/2016 03:42'!
renderItemDescriptionAditionalDataOn: html

	html span: [html strong: ('Created Time:' translateFor: self session user)].
	html output: selectedLateralItem createdTime.
	html span: [html strong: ('Report Creator:' translateFor: self session user)].
	html output: selectedLateralItem creatorName.
	html span: [html strong: ('Time to Build:' translateFor: self session user)].
	html output: selectedLateralItem printSecondsToConstruct.

	selectedLateralItem printStartDate ifNotNil: [:value | 
		html span: [html strong: ('From:' translateFor: self session user)].
		html output: value.
	].
	selectedLateralItem printEndDate ifNotNil: [:value | 
	html span: [html strong: ('To:' translateFor: self session user)].
	html output: value.
	].
	selectedLateralItem printDistributionMethod ifNotNil: [:value | 
		html span: [html strong: ('Distribution:' translateFor: self session user)].
		html output: value.
	].
	(selectedLateralItem conditionStringBlock notNil and: [selectedLateralItem conditionStringBlock notEmpty]) ifTrue: [
		html break.
		html span: [html strong: ('Condition:' translateFor: self session user)].
		html output: selectedLateralItem conditionStringBlock.
	].
	html break.
	selectedLateralItem getDescriptionItems keysAndValuesDo: [:label :value | 
		html span: [html strong: (label translateFor: self session user)].
		html output: value.
	].! !

!WABpmChartRepositoryComposite methodsFor: 'subclass responsibility' stamp: 'BrunoBB 11/19/2016 07:51'!
renderItemDescriptionSecondaryDataOn: html

"
	html span with: [html strong: ('Process Id:' translateFor: self session user)].
	html output: selectedLateralItem processId.
	html span with: [html strong: ('Version:' translateFor: self session user)].
	html output: selectedLateralItem version.
	html span with: [html strong: ('Application:' translateFor: self session user)].
	html output: selectedLateralItem applicationName.
	html span with: [html strong: ('Parent Process:' translateFor: self session user)].
	html output: selectedLateralItem parentProcessName.
"! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 16:29'!
renderItemDescriptionTitleOn: html

	html output:  selectedLateralItem name.! !

!WABpmChartRepositoryComposite methodsFor: 'subclass responsibility' stamp: 'BrunoBB 11/19/2016 07:52'!
renderLateralItemDetailsOn: html for: aLateralItem


"
	html strong with: [html output: aLateralItem processId].
	html strong with: [html output: aLateralItem version].
	html strong with: [html output: aLateralItem applicationName].
"! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 12:58'!
renderProcessDefinitionComboOn: html
	| definitionNames |

	definitionNames := (BpmProcessDefinition cacheAt: self getApplicationName ifAbsent: [^self]) keys asSortedCollection.

	self renderGenericActiveComboOn: html withList: definitionNames forVariable: 'process-name' label: ('Process' translateFor: self session user).

	(self hasSearchValueAt: 'process-name') ifFalse: [self addSearchValue: definitionNames first named: 'process-name'].! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:20'!
renderProcessFormsComboOn: html
	| forms |

	html div class: 'top-search-div'; with: [
		html label 
			attributeAt: 'for' put: 'process-forms';
			with: ('Forms' translateFor: self session user).

		forms := self getProcessFormsList.
		html select "Field Definition List" 
			attributeAt: 'id' put: 'process-forms';
			class: 'width-200px';
			list: forms;
			onChange: 'submit()';
			callback: [:value | self addSearchValue: value named: 'form-name'];
			selected: (self searchValueAt: 'form-name' ifAbsent: [forms ifNotEmpty: [forms first]]).
	].! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:13'!
renderProcessVersionsComboOn: html
	| procVersions versions |

	procVersions := BpmProcessDefinition getAllProcessesNamed: self getProcessName in: self getApplicationName.

	versions := procVersions collect: [:each | each version printString].

	self renderGenericActiveComboOn: html withList: versions forVariable: 'version' label: ('Version' translateFor: self session user).

	(self hasSearchValueAt: 'version') ifFalse: [self addSearchValue: 'All' named: 'version'].! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 06:27'!
renderReportClassesComboOn: html
	| reportTypes |

	reportTypes := AppDistributionReport getBpmReportNames collect: [:each | each translateFor: self session user].

	^self renderGenericActiveComboOn: html withList: reportTypes forVariable: 'report-type' label: ('Report Type' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 07:25'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Search Chart Report' translateFor: self session user).
			self renderReportClassesComboOn: html.
			self isApplicationComboAvailable 
				ifTrue: [self renderApplicationComboOn: html].
			self isProcessDefinitionComboAvailable
				ifTrue: [self renderProcessDefinitionComboOn: html].
			self isFieldComboAvailable 
				ifTrue: [self renderProcessVersionsComboOn: html.
							self renderProcessFormsComboOn: html].
			self isUserComboAvailable 
				ifTrue: [self renderUsersComboOn: html].
			self renderSearchButtonOn: html.
		].
	].! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 01/09/2017 06:14'!
renderSearchButtonOn: html

	html div class: 'top-search-filters-one'; 
		class: 'width-100px margin-top-20px';
		with: [
			html submitButton 
				callback: [self searchReport]; 
				with: ('Search Report' translateFor: self session user).
		].! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 07:31'!
renderUsersComboOn: html

	^self renderGenericActiveComboOn: html 
			withList: ((self session user getVisibleUsers asSortedCollection: [:a :b | a username <= b username]) collect: [:each | each username])
			forVariable: 'user-name' 
			label: ('User' translateFor: self session user)! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 07:39'!
reportsRepository

	^AppDistributionReportRepository default! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:42'!
searchReport

	searchApplied := true.
	selectedLateralItem := nil.

	self isGlobalReportSelected ifTrue: [^self showGlobalReports].

	self isApplicationReportSelected ifTrue: [^self showApplicationReports].

	self isFieldReportSelected ifTrue: [^self showFieldReports].

	self isProcessReportSelected ifTrue: [^self showProcessReports].

	self isRoleReportSelected ifTrue: [^self showRoleReports].

	self isUserReportSelected ifTrue: [^self showUserReports].! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 08:59'!
showApplicationReports

	searchResult := self reportsRepository getApplicationReportFor: self getApplicationName! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:42'!
showFieldReports

	searchResult := self reportsRepository getProcessReportFor: self getProcessName formName: self getFormName in: self getApplicationName! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 07:39'!
showGlobalReports

	searchResult := self reportsRepository getGlobalReports! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 03:28'!
showProcessReports

	searchResult := self reportsRepository getProcessReportFor: self getProcessName in: self getApplicationName! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 04:50'!
showRoleReports

	searchResult := self reportsRepository getRoleReportsFor: self getApplicationName! !

!WABpmChartRepositoryComposite methodsFor: 'other' stamp: 'BrunoBB 11/21/2016 07:31'!
showUserReports

	searchResult := self reportsRepository getUserReportsFor: self getUserName! !

SewafLateralListComposite subclass: #WAProcessDefinitionBrowser
	instanceVariableNames: 'mode categories subprocessesTree'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAProcessDefinitionBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 07/02/2015 12:37'!
categories
	^categories! !

!WAProcessDefinitionBrowser methodsFor: 'Updating' stamp: 'BrunoBB 07/02/2015 12:37'!
categories: newValue
	categories := newValue! !

!WAProcessDefinitionBrowser methodsFor: 'export' stamp: 'BrunoBB 01/13/2017 13:18'!
downloadProcessMap

	self selectedLateralItem hasSubProcesses
	ifTrue: [self downloadZipProcessMapOf: self selectedLateralItem] 
	ifFalse: [self downloadProcessMapOf: self selectedLateralItem].! !

!WAProcessDefinitionBrowser methodsFor: 'export' stamp: 'BrunoBB 01/13/2017 13:19'!
downloadProcessMapOf: aBpmProcessDefinition

	self requestContext respond: [:response | 
        response document: ((aBpmProcessDefinition getProcessMapStream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/csv'; 
                                        fileName: (aBpmProcessDefinition processName, '.xpdl'); 
                                        yourself)].! !

!WAProcessDefinitionBrowser methodsFor: 'export' stamp: 'BrunoBB 01/13/2017 13:19'!
downloadZipProcessMapOf: aBpmProcessDefinition
	| fileName stream |

	stream := aBpmProcessDefinition getProcessMapStream.
	fileName := stream gsfile name.

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'application/octet-stream'; 
                                        fileName: fileName; 
                                        yourself)].! !

!WAProcessDefinitionBrowser methodsFor: 'export' stamp: 'BrunoBB 09/13/2016 15:04'!
exportProcessDefinitionAs
	| selectedOption stream |

	selectedOption := (self componentValueAt: 'exportProcess') "the jqdialog set this value"ifNil: [^self] ifNotNil: [:value | value].

	(selectedOption = #xpdl) ifTrue: [^self downloadProcessMap].

	(selectedOption = #svg) ifFalse: [^self].

	stream := PrintStream on: String new.

	stream nextPutAll: self xmlHeader, String lf,((BizagiSvgConverter convert: selectedLateralItem xmlString) generateSVGFor: selectedLateralItem).

	self requestContext respond: [:response | 
        response document: ((stream contents asByteArray seasideMimeDocument) 
                                        mimeType: 'image/svg+xml'; 
                                        fileName: (selectedLateralItem processName, '.svg'); 
                                        yourself)].! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/15/2015 10:11'!
filterProcessDefinitionByCategory: aBpmProcessDefinitionCategory

	searchApplied := true.
	searchResult := lateralCollection select: [:each | aBpmProcessDefinitionCategory includes: each]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 06/27/2015 13:10'!
getCurrentCollection

	searchApplied ifFalse: [^lateralCollection].

	^searchResult! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/10/2015 06:37'!
getFormDefinitionList
	| allFormsNames |

	allFormsNames := OrderedCollection new.

	lateralCollection do: [:each | allFormsNames addAll: each getTaskNames].

	^self viewAllArray, allFormsNames asSet asSortedCollection

"	^#('-View All-'), (allFormsNames asSet asSortedCollection) "! !

!WAProcessDefinitionBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 06/27/2015 13:40'!
getIconNameFormItem 

	^#pageprocess32Png! !

!WAProcessDefinitionBrowser methodsFor: 'lateral assignment' stamp: 'BrunoBB 12/10/2015 06:47'!
getTextForItem: aLateralListItem

	^aLateralListItem processName! !

!WAProcessDefinitionBrowser methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'manage_processes_definitions.html'! !

!WAProcessDefinitionBrowser methodsFor: 'other' stamp: 'BrunoBB 04/13/2016 14:39'!
initialize

	super initialize.

	mode := #normal.
	searchAvailable := false.
	categories := OrderedCollection new.
	"subprocessesTree := WATree new."

	self setShowToElementNamed: 'search-area'.

	batchedList := SewafLateralBatchedList parentComponent: self.
	batchedList batchSize: self session user lateralListPagingSize;
		navigationCssClass: 'batch-div-lateral-top'.! !

!WAProcessDefinitionBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 06/05/2015 15:45'!
mode
	^mode! !

!WAProcessDefinitionBrowser methodsFor: 'Updating' stamp: 'BrunoBB 06/05/2015 15:45'!
mode: newValue
	mode := newValue! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/15/2015 10:11'!
onProcessCategoryClicked: aBpmProcessDefinitionCategory

	self hasSelectedLateralItem ifFalse: [^self filterProcessDefinitionByCategory: aBpmProcessDefinitionCategory].

	(aBpmProcessDefinitionCategory includes: selectedLateralItem)
	ifTrue: [aBpmProcessDefinitionCategory remove: selectedLateralItem]
	ifFalse: [aBpmProcessDefinitionCategory add: selectedLateralItem]! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/18/2016 13:50'!
onSubProcessSelected: artifactDefinition

	selectedObject := nil.

	searchApplied := true.
	searchResult := OrderedCollection withAll: artifactDefinition processDefinition getProcessesTreeAsCollection.

	selectedLateralItem := artifactDefinition subProcessDefinition! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/18/2016 16:20'!
onTopProcessSelected: processDefinition

	selectedObject := nil.

	searchApplied := true.
	searchResult := OrderedCollection withAll: processDefinition getProcessesTreeAsCollection.

	selectedLateralItem := processDefinition! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/16/2016 13:41'!
onTransitionSelected: aBpmTransitionDefinition

	selectedObject := aBpmTransitionDefinition! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 06/13/2015 08:39'!
registerProcessType: value

	searchValues at: 'process-type' put: value.! !

!WAProcessDefinitionBrowser methodsFor: 'delete process' stamp: 'BrunoBB 08/30/2016 13:34'!
removeProcessDefinition

	(self componentValueAt: 'removeDefinition') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].

	(selectedLateralItem getProcessesTreeAsCollection select: [:each | each canDelete]) do: [:each | each removeFromCache].
	"selectedLateralItem removeFromCache."

	batchedList remove: selectedLateralItem.
	lateralCollection remove: selectedLateralItem ifAbsent: [].

	selectedLateralItem := nil.

	self removeValueNamed: 'removeDefinition'! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 05/13/2016 13:47'!
renderCategoriesListOn: html

	html div id: 'process-category-list'; with: [
		categories do: [:each | 
			html anchor callback: [self onProcessCategoryClicked: each]; 
				class: 'category-label';
				style: 'background-color:', each color;
				with: [html output: each name]].
	].! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/15/2015 10:12'!
renderCustomItemElementOn: html forItem: aBpmProcessDefinition

	(self session user getProcessDefinitionCategoriesFor: aBpmProcessDefinition) do: [:each | 
		html div class: 'category-circle'; style: 'background-color: ', each color;
			with: [html output: each name first].
	].! !

!WAProcessDefinitionBrowser methodsFor: 'delete process' stamp: 'BrunoBB 08/30/2016 15:04'!
renderDeleteProcessDefintionOn: html
   | jQueryId |

	jQueryId := self renderJQueryConfirmationDialogOn: html forActionNamed: 'removeDefinition' actionMethod: #removeProcessDefinition.

	html div class: 'float-left margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #remove24Png); 
												title: ('Remove Process Definition' translateFor: self session user); 
												altText: ('Remove Process Definition' translateFor: self session user) ]
	]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 09/28/2015 16:52'!
renderFormDefinitionComboOn: html

	html label attributeAt: 'for' put: 'formDefinition'; with: ('Form' translateFor: self session user).

	html select "Form Definition List" class: 'search-section-width-200';
		attributeAt: 'id' put: 'formDefinition';
		list: self getFormDefinitionList;
		callback: [:value | searchValues at: 'form-type' put: value];
		selected: (searchValues at: 'form-type' ifAbsent: ['']).! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/18/2016 16:06'!
renderGatewayDefinition: artifactDefinition on: html

	html div 
		with:
			[html output: artifactDefinition printInArtifacts].
			html div with: [html strong with: [html output: '<', artifactDefinition name, '>']].
			html div with:[html output: artifactDefinition printOutArtifacts].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 12/04/2016 12:49'!
renderItemComponentOn: html

	html div class: 'width-50per float-left';with: [
		html div class: 'width-15px'; with: [
			selectedLateralItem canDelete ifTrue: [self renderDeleteProcessDefintionOn: html].
			selectedLateralItem canBeStartedByAnonymousForm ifTrue: [self renderToggleOn: html].
		].
		html div with: [
			html unorderedList with:[
				selectedLateralItem getTransitions do: [:transitionDefinition |
					html listItem with: [self renderTransitionOn: html forTransition: transitionDefinition.
												html horizontalRule.].
				].
			].
		].
	].
	html div class: 'width-45per margin-top-15px float-right margin-right-20px'; with: [self renderSelectedTransitionOn: html].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 04/10/2016 18:18'!
renderItemDescriptionAditionalDataOn: html

	html span: [html strong: ('Has Anonymous Start:' translateFor: self session user)]. 
	html output: selectedLateralItem isAnonymousStartEnabled.
	html span: [html strong: ('Can be Modified:' translateFor: self session user)]. 
	html output: selectedLateralItem canModifyPathDefinition.
	html span: [html strong: ('Has Finished Processes:' translateFor: self session user)]. 
	html output: selectedLateralItem hasFinishedProcesses.! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/18/2016 16:21'!
renderItemDescriptionSecondaryDataOn: html
	| parentName |

	html span with: [html strong: ('Process Id:' translateFor: self session user)].
	html output: selectedLateralItem processId.
	html span with: [html strong: ('Version:' translateFor: self session user)].
	html output: selectedLateralItem version.
	html span with: [html strong: ('Application:' translateFor: self session user)].
	html output: selectedLateralItem applicationName.
	html span with: [html strong: ('Parent Process:' translateFor: self session user)].
	parentName := selectedLateralItem getParentProcessName.
	parentName isEmpty 
	ifFalse: [html anchor 
		class: 'no-underline';
		callback: [self onTopProcessSelected: selectedLateralItem parentProcess]; 
		with: [html output: '@', parentName]
	].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 09/11/2016 13:44'!
renderItemDescriptionTitleOn: html
	| jQueryId options |

	html output:  selectedLateralItem processName.
	options := Array with: #('Export XPDL' #xpdl) with: #('View SVG' #svg).

	jQueryId := self renderJQuerySelectOptionDialogOn: html buttonsNames: options forActionNamed: 'exportProcess' actionMethod: #exportProcessDefinitionAs arguments: #() extent: 420@120.

	html anchor 
		class: 'cursor-pointer';
		"callback: [self downloadProcessMap]; "
		onClick: (html jQuery id: jQueryId) dialog open;
		with: [html image url: (SEWAFIconLibrary / #documentflowchart24Png); 
					title: ('Process Map' translateFor: self session user);
					altText: ('Process Map' translateFor: self session user)].! !

!WAProcessDefinitionBrowser methodsFor: 'lateral process list' stamp: 'BrunoBB 06/27/2015 13:59'!
renderLateralItemDetailsOn: html for: aLateralItem

	html strong with: [html output: aLateralItem processId].
	html strong with: [html output: aLateralItem version].
	html strong with: [html output: aLateralItem applicationName].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 12/10/2015 08:56'!
renderProcessTypeComboOn: html

	html label attributeAt: 'for' put: 'processType'; with: ('Process Type' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'processType';
		list: self viewAllArray, (lateralCollection collect: [:each | each processName]) asSet asSortedCollection;
		onChange: 'submit()';
		callback: [:value | self registerProcessType: value];
		selected: (searchValues at: 'process-type' ifAbsent: ['']).! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 04/14/2017 16:05'!
renderSearchAreaOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	self searchPanelIsRegular 
	ifTrue: [self renderSearchRegularPanelOn: html]
	ifFalse: [self renderSearchCategoriesPanelOn: html]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:14'!
renderSearchCategoriesPanelOn: html

	html form with: [ 
		html fieldSet with: [
			self renderSwitchWindowOn: html.
			html legend class: 'top-search-legend'; with: ('Search Process' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label with: ('Category Name' translateFor: self session user).
				html textInput callback: [:value | searchValues at: 'category-name' put: value].].
			self renderCategoriesListOn: html.
			html div class: 'top-search-filters-one'; with: [
				html submitButton
					style: 'margin-top: 25px';
					callback: [self searchMatchingCategories]; 
					with: ('Search' translateFor: self session user).].
		].
].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:37'!
renderSearchRegularPanelOn: html

	html form with: [ 
		html fieldSet with: [
			html legend class: 'top-search-legend'; with: ('Search Process' translateFor: self session user).
			self renderSwitchWindowOn: html.
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'processId'; with: ('Process Id' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'processId';
					callback: [:value | searchValues at: 'id' put: value].
			].
			html div class: 'top-search-div'; with: [self renderProcessTypeComboOn: html].
			html div class: 'top-search-div'; with: [self renderFormDefinitionComboOn: html].
			html div class: 'top-search-filters-two'; with: [
				self renderSearchSubmitButtonOn: html].
		].
]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/10/2016 16:19'!
renderSearchSubmitButtonOn: html

	html submitButton 
		style: 'margin-top: 35px;';
		callback: [self searchMatchingProcesses]; 
		with: ('Search' translateFor: self session user).! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 12/06/2016 04:10'!
renderSelectedTransitionOn: html
	| svgCode |

	selectedObject ifNil: [^self].

	svgCode := (XpdlSvgConverter new generateSVGForTransition: selectedObject) contents.

	html div 
		class: 'transition-artifact'; 
		with: [html html: svgCode].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/18/2016 15:41'!
renderSubprocessDefinition: artifactDefinition on: html

	html div with: [html strong with: [html output: artifactDefinition name]].

	html anchor 
		class: 'no-underline';
		callback: [self onSubProcessSelected: artifactDefinition]; 
		with: [html output: '@', artifactDefinition name]! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 07/01/2015 13:52'!
renderSwitchWindowOn: html

	html div id: 'top-search-switch-icon'; with: [
		html anchor 
			callback: [searchPanelName := (searchPanelName = #search) ifTrue: [#categories] ifFalse: [#search]];
			with: [
				html div with: [
					html image url: (SEWAFIconLibrary / #ezswitchuser16Png); 
						altText: 'Switch Window'; 
						title: 'Switch Window'.
				].
		].
	].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/21/2016 07:54'!
renderTaskDefinition: artifactDefinition on: html
	| previousFields |

	previousFields := artifactDefinition extendedValueOf: 'previousFields' ifAbsent: [nil].
	html div 
		with:[
			previousFields ifNotNil: [html output: '{', previousFields,'}']].
			html div with: [
				html strong with: [html output: artifactDefinition name].
				html output: ' (', artifactDefinition printRoleNames, ')'].
			html div with:[html output: '[', artifactDefinition printSummaryFields,']'].! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 04/10/2016 18:24'!
renderToggleOn: html
	
	html div class: 'float-left margin-left-5px'; with: [
		html anchor callback: [self toggleAnonymousStart]; 
						with: [html image url: (SEWAFIconLibrary / #actionsmailsend32Png); 
												title: ('Toggle Anonymous Start' translateFor: self session user); 
												altText: ('Toggle Anonymous Start' translateFor: self session user)]
	]! !

!WAProcessDefinitionBrowser methodsFor: 'process' stamp: 'BrunoBB 06/18/2016 15:57'!
renderTransitionOn: html forTransition: transitionDefinition

	html anchor class: 'no-underline';
		callback: [self onTransitionSelected: transitionDefinition]; 
		with: [(transitionDefinition == selectedObject) 
					ifFalse: [html output: transitionDefinition printData] 
					ifTrue: [html strong with: [html output: transitionDefinition printData]]].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 17:47'!
searchByFormType

	searchResult := lateralCollection select: [:each | each getOrderedTasksNames includes: (searchValues at: 'form-type')].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 06/27/2015 13:11'!
searchByProcessId

	searchResult := lateralCollection select: [:each | each processId printString = (searchValues at: 'id')].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 03/06/2016 17:50'!
searchByProcessType

	searchResult := lateralCollection select: [:each | each processName = (searchValues at: 'process-type')].! !

!WAProcessDefinitionBrowser methodsFor: 'categories' stamp: 'BrunoBB 12/15/2015 10:11'!
searchMatchingCategories

	categories := (BpmProcessDefinitionCategory getCategoriesFor: self session user) select: [:each | 
		(searchValues at: 'category-name' ifAbsent: ['']) match: each name].! !

!WAProcessDefinitionBrowser methodsFor: 'search area' stamp: 'BrunoBB 09/28/2015 16:48'!
searchMatchingProcesses

	searchApplied := true.

	((searchValues includesKey: 'id') and: [(searchValues at: 'id') notEmpty])
	ifTrue: [^self searchByProcessId].

	((searchValues includesKey: 'process-type') and: [(searchValues at: 'process-type') ~= self viewAllText])
	ifTrue: [^self searchByProcessType].

	((searchValues includesKey: 'form-type') and: [(searchValues at: 'form-type') ~= self viewAllText])
	ifTrue: [^self searchByFormType].

	^searchResult := lateralCollection! !

!WAProcessDefinitionBrowser methodsFor: 'other' stamp: 'BrunoBB 06/16/2016 14:03'!
selectedLateralItem: newValue

	selectedLateralItem := newValue.

	selectedObject := nil! !

!WAProcessDefinitionBrowser methodsFor: 'anonymous start' stamp: 'BrunoBB 04/10/2016 18:23'!
toggleAnonymousStart

	selectedLateralItem toggleAnonymousStart! !

!WAProcessDefinitionBrowser methodsFor: 'export' stamp: 'BrunoBB 01/13/2017 13:23'!
xmlHeader

	^'<?xml version="1.0" encoding="utf-8"?>'! !

SEWAFWebLogin subclass: #WAOrbeonBackofficeLogin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonBackofficeLogin class methodsFor: 'other' stamp: 'BrunoBB 02/08/2017 06:07'!
register
	| application |

	WAAdmin unregister: 'orbeonBackoffice'.

	application := WAAdmin register: self asApplicationAt: 'orbeonBackoffice'.
	"application preferenceAt: #scriptGeneratorClass put: JQScriptGenerator."
	application 
		preferenceAt: #sessionClass put: WABpmSession;
		addLibrary: JQDeploymentLibrary;
		addLibrary: JQUiDeploymentLibrary;
		addLibrary: JQUiLightnessTheme.! !

!WAOrbeonBackofficeLogin class methodsFor: 'other' stamp: 'BrunoBB 02/07/2017 10:49'!
unregister

	WAAdmin unregister: 'orbeonBackoffice'.! !

!WAOrbeonBackofficeLogin methodsFor: 'other' stamp: 'BrunoBB 09/05/2016 15:31'!
selectorsToInclude

	^#(basicPortalStylesCss backofficePortalCss topMenuLayoutCss)

"^#(basicPortalStylesCss backofficePortalCss leftMenuLayoutCss rightMenuLayoutCss topMenuLayoutCss)"! !

!WAOrbeonBackofficeLogin methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 07:51'!
tryLogin
	| logedUser loginMode |

	loginMode := self getGemStoneServerConfiguration loginModeFor: 'orbeon-processes-web'.
	(loginMode validateUser: name password: password) ifFalse: [^loginAttempts := loginAttempts + 1].

	logedUser := BpmUser getExistingOrNewUserNamed: name.

	logedUser isBackofficeUser ifFalse: [^loginAttempts := loginAttempts + 1].

	self session user: logedUser. 

	"self show: (WAOrbeonFormBackofficeUser on: logedUser)"

	self show: (WAProcessBackofficePortal on: logedUser)! !

!WAOrbeonBackofficeLogin methodsFor: 'other' stamp: 'BrunoBB 09/05/2016 14:51'!
updateRoot: anHtmlRoot

    super updateRoot: anHtmlRoot.

    SEWAFCssLibrary default updateRoot: anHtmlRoot.! !

SEWAFWebObjectComposite subclass: #WABkBpmUserPreference
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABkBpmUserPreference methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:06'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'user_preferences.html'! !

!WABkBpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 12/03/2016 06:16'!
renderContentOn: html

	html div id: 'user-preferences'; class: 'centered-unique-form float-left';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Lists' translateFor: self session user)].
						self renderDisplayPagingSizeOn: html.
						html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).
					].
				].
		].
	html div id: 'user-preferences-2'; class: 'centered-unique-form float-left';
		with: [html form with: [
					html fieldSet with:[
						html legend with: [html strong: ('Backcolors' translateFor: self session user)].
						self renderListBackcolorOn: html.
						html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).
					].
				].
		].! !

!WABkBpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:43'!
renderDisplayPagingSizeOn: html

	html label attributeAt: 'for' put: 'lateralPaging'; with: ('Lateral List Paging Size' translateFor: self session user).
	html textInput 
		style: 'width: 35px;';
		attributeAt: 'id' put: 'lateralPaging'; 
		callback: [:value | self setLateralPagingWith: value];
		value: self session user lateralListPagingSize.

	html label attributeAt: 'for' put: 'regularPaging'; with: ('Regular List Paging Size' translateFor: self session user).
	html textInput 
		style: 'width: 35px; display: block;';
		attributeAt: 'id' put: 'regularPaging'; 
		callback: [:value | self setRegularPagingWith: value];
		value: self session user regularListPagingSize.! !

!WABkBpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 06/11/2016 15:24'!
renderListBackcolorOn: html

	html fieldSet with:[
		html legend with: [html strong: ('Table Report' translateFor: self session user)].
		html label attributeAt: 'for' put: 'tableReport.backcolor'; with: ('Backcolor' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'tableReport.backcolor'; 
			value: self session user userOptions getTableReportBackcolor;
			callback: [:value | self session user userOptions getTableReportBackcolor: value].	 
	].
	html fieldSet with:[
		html legend with: [html strong: ('Select Table' translateFor: self session user)].
		html label attributeAt: 'for' put: 'selectTable.selectedColor'; with: ('Selected Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'selectTable.selectedColor'; 
			value: self session user userOptions getSelectTableSelectedColor;
			callback: [:value | self session user userOptions getSelectTableSelectedColor: value].	
		html label attributeAt: 'for' put: 'selectTable.nonSelectedColor'; with: ('Non Selected Color' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'selectTable.nonSelectedColor'; 
			value: self session user userOptions getSelectTableNonSelectedColor;
			callback: [:value | self session user userOptions getSelectTableNonSelectedColor: value].
	].
	html fieldSet with:[
		html legend with: [html strong: ('Boolean Table' translateFor: self session user)].
		html label attributeAt: 'for' put: 'booleanTable.backcolor'; with: ('Backcolor' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'booleanTable.backcolor'; 
			value: self session user userOptions getBooleanTableBackcolor;
			callback: [:value | self session user userOptions getBooleanTableBackcolor: value].	
	].! !

!WABkBpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:43'!
savePreferences! !

!WABkBpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:43'!
setLateralPagingWith: value

	self session user lateralListPagingSize: ([(Number fromString: value)] on: Error do: [:err | ^self])! !

!WABkBpmUserPreference methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:44'!
setRegularPagingWith: value

	self session user regularListPagingSize: ([(Number fromString: value)] on: Error do: [:err | ^self])! !

SEWAFWebObjectComposite subclass: #WABpmApplicationManager
	instanceVariableNames: 'selectedApplications appType appName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmApplicationManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:57'!
appName
	^appName! !

!WABpmApplicationManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:57'!
appName: newValue
	appName := newValue! !

!WABpmApplicationManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:57'!
appType
	^appType! !

!WABpmApplicationManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:57'!
appType: newValue
	appType := newValue! !

!WABpmApplicationManager methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 08:49'!
deleteApplication
	| application selectedApp |

	(self componentValueAt: 'deleteApplication') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].

	selectedApplications isEmpty ifTrue: [^self].
	selectedApp := selectedApplications last.
	(selectedApp size <= 9) ifTrue: [^self].

	application := AbstractApplication getAnyApplicationNamed: (selectedApp allButLast: 9) ifNone: [^self].

	application canDelete ifFalse: [^self].

	application removeFromCache! !

!WABpmApplicationManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:07'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'manage_applications.html'! !

!WABpmApplicationManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:57'!
initialize

	super initialize.

	appType := 'BPM'.
	appName := ''.
	selectedApplications := OrderedCollection new.! !

!WABpmApplicationManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:57'!
newApplication

	appName isEmpty ifTrue: [^self].

	(appType = 'BPM') ifTrue: [^(BpmApplication newNamed: appName) addToCache].

	^(OrbeonApplication newNamed: appName) addToCache! !

!WABpmApplicationManager methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 09:36'!
renderApplicationsListOn: html
	| apps |

	apps := self session user getBackofficeApplications.
	html label attributeAt: 'for' put: 'app-title'; with: ('Applications' translateFor: self session user).
	html multiSelect 
		class: 'height180';
		attributeAt: 'id' put: 'app-title'; 
		attributeAt: 'title' put: ('Applications' translateFor: self session user);
		list: (apps collect: [:each | each getApplicationNameForCombo]) asSortedCollection;
		size: apps size;
		callback: [:value | self selectedApplications: value].! !

!WABpmApplicationManager methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 09:45'!
renderContentOn: html

	html div class: 'centered-unique-form';
		with: [
			html form with: [
				html fieldSet with:[ 
					html legend with: [html strong: ('Manage Current Applications' translateFor: self session user)].
					self renderApplicationsListOn: html.
					self renderNewApplicationOn: html.
					self renderFormOperationsOn: html.
				].
			].
	].! !

!WABpmApplicationManager methodsFor: 'other' stamp: 'BrunoBB 08/31/2016 08:37'!
renderFormOperationsOn: html
	| jQueryId |

	jQueryId := self renderJQueryConfirmationDialogOn: html forActionNamed: 'deleteApplication' actionMethod: #deleteApplication.

	html submitButton 
		class: 'margin-right-20per';
		callback: [self newApplication]; 
		with: ('New Application' translateFor: self session user).

	html submitButton  
		"callback: [self deleteApplication]; "
		onClick: (html jQuery id: jQueryId) dialog open;
		with: ('Delete Application' translateFor: self session user).! !

!WABpmApplicationManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:57'!
renderNewApplicationOn: html

	Smalltalk at: #OrbeonApplication ifAbsent: [^self]. "if the Orbeon package is not installed then no need for this options"

	html label 
		attributeAt: 'for' put: 'app-type';
		with: ('Application Type' translateFor: self session user).
	html radioGroup
		callback: [:value | appType := value];
		selected: appType;
		with: [ :group |
				html label: [group radioButton value: 'BPM'. html text: 'BPM'].
				html label: [group radioButton value: 'Orbeon'. html text: 'Orbeon']].

	html label attributeAt: 'for' put: 'app-name'; with: ('Application Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'app-name'; callback: [:value | appName :=  value].! !

!WABpmApplicationManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:57'!
selectedApplications
	^selectedApplications! !

!WABpmApplicationManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:57'!
selectedApplications: newValue
	selectedApplications := newValue! !

SEWAFWebObjectComposite subclass: #WABpmRoleManager
	instanceVariableNames: 'selectedUser isAddingUser newUser isBackoffice isAdmin selectedApplication rolesBatchList usersWithSelectedRoleBatchList addUserToRoleBatchList rolesWithSelectedUserBatchList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:48'!
answer

	super answer.

	^model! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:48'!
booleanValueForUser: anOrbeonFormUser

	^selectedObject isGranted: anOrbeonFormUser! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 07/03/2016 18:29'!
columnsforMainRole

	^OrderedCollection new  
			add: ((SewafReportColumn selector: #name title: 'Rol' onClick: [:each | selectedObject := each. selectedUser := nil]) beSortable beSearchable; sortBlock: [:a :b | a name <= b name]; yourself);
			add: ((SewafReportColumn selector: #getApplicationName title: 'Application') beSortable beSearchable; sortBlock: [:a :b | a getApplicationName <= b getApplicationName]; yourself);
			add: ((SewafReportColumn selector: #isBackofficeRole title: 'Is Backoffice User') beSortable beSearchable; sortBlock: [:a :b | a isBackofficeRole printString <= b isBackofficeRole printString]; yourself);
			add: ((SewafReportColumn selector: #isAdmin title: 'Is Admin') beSortable beSearchable; sortBlock: [:a :b | a isAdmin printString <= b isAdmin printString]; yourself);
			"add: self addCurrentUserButton;"
			add: self newRemoveRolButton;
			yourself! !

!WABpmRoleManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:08'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'manage_roles.html'! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:48'!
initialize

	super initialize.

	isAddingUser := false.
	isBackoffice := false.
	isAdmin := false.
	newUser := BpmUser new.

	self initializeBatchedLists.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:48'!
initializeBatchedLists

	rolesBatchList := SewafBatchedList parentComponent: self.
	rolesBatchList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	usersWithSelectedRoleBatchList := SewafBatchedList parentComponent: self.
	usersWithSelectedRoleBatchList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	addUserToRoleBatchList := SewafBatchedList parentComponent: self.
	addUserToRoleBatchList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom-with-button'.

	rolesWithSelectedUserBatchList := SewafBatchedList parentComponent: self.
	rolesWithSelectedUserBatchList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 07/03/2016 18:31'!
initializeSewafTableForRoles
	| table |

	table := (SewafSelectTableReport parent: self)
		"rows: self searchRoles; "
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: self columnsforMainRole;
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'Roles'.! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 08/10/2016 10:41'!
initializeSewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table column|

	column := SewafReportColumn selector: #username title: 'Username'.
	column beSortable; beSearchable; sortBlock: [:a :b | a username <= b username]. 
	table := (SewafBooleanSelectTable parent: self)
		summary: 'Users to Assign';
		sortColumnSelector: #sortUsers:orderMode:;
		backcolor: self session user userOptions getBooleanTableBackcolor;
		buttonLabel: ('Assign and Close' translateFor: self session user);
		booleanSelector: #booleanValueForUser:;
		callbackSelector: #modifyUser:value:;
		columns: (OrderedCollection new add: column; 
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'Users'.! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 06/12/2016 17:03'!
initializeSewafTableForUsersWithRol
	"Table with all Users that are NOT present in the role <selectedObject> "

	| table |

	table := (SewafSelectTableReport summary: 'Users')
		"rows: selectedObject users asArray; "
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #username title: 'Username' onClick: [:each | selectedUser := each]);
						add: self newRemoveUserFromRolButton;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'UsersOfSelectedRole'.! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 06/12/2016 17:37'!
initializeSewafTableRolsOfUser
	| table |

	table := (SewafTableReport summary: 'Users')
		"rows: selectedUser roles; "
		backcolor: self session user userOptions getTableReportBackcolor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Rol');
						add: self newRemoveRolFromUserButton;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'RolesOfSelectedUser'.! !

!WABpmRoleManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:48'!
isAddingUser

   "Return the value of the instance variable 'isAddingUser'."
   ^isAddingUser! !

!WABpmRoleManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:48'!
isAddingUser: newValue

   "Modify the value of the instance variable 'isAddingUser'."
   isAddingUser := newValue! !

!WABpmRoleManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:48'!
isAdmin

   "Return the value of the instance variable 'isAdmin'."
   ^isAdmin! !

!WABpmRoleManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:48'!
isAdmin: newValue

   "Modify the value of the instance variable 'isAdmin'."
   isAdmin := newValue! !

!WABpmRoleManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:48'!
isBackoffice

   "Return the value of the instance variable 'isBackoffice'."
   ^isBackoffice! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:48'!
isBackoffice: aBoolean

	aBoolean ifFalse: [model := model asFrontofficeRole].

	aBoolean ifTrue: [model := model asBackofficeRole].

	isBackoffice := aBoolean! !

!WABpmRoleManager methodsFor: 'operations' stamp: 'BrunoBB 06/12/2016 17:41'!
modifyUser: user value: aBoolean

	isAddingUser := false.

	aBoolean ifFalse: [^self].

	usersWithSelectedRoleBatchList add: user.

	selectedObject grantUser: user.

	self closeAllInformationComponents.
	(self getTableNamed: 'UsersOfSelectedRole' ifAbsent: [^self]) 
			information: ('User added !!!!!!' translateFor: self session user)
			color: 'green'.! !

!WABpmRoleManager methodsFor: 'operations' stamp: 'BrunoBB 09/05/2016 15:47'!
newRemoveRolButton

	^(SewafReportColumn 
			renderBlock: [:each :html | | jQueryId |
				each canDelete
				ifTrue: [
					jQueryId := self renderJQueryConfirmationDialogOn: html forActionNamed: 'removeRol' actionMethod: #removeRol: arguments: (Array with: each).
					html anchor "callback: [self removeRol: each]; "
								class: 'cursor-pointer';
								onClick: (html jQuery id: jQueryId) dialog open;
								with: [html image url: (SEWAFIconLibrary / #remove24Png); 
														title: ('Remove Role' translateFor: self session user); 
														altText: ('Remove Role' translateFor: self session user).]
				]
				ifFalse: [html image url: (SEWAFIconLibrary / #stopred24Png); 
								title: ('Rol Can not be removed' translateFor: self session user);  
								altText: ('Rol Can not be removed' translateFor: self session user).
				]
			]
			title: 'DEL') 
				sortBlock: nil; 
				cssClass: 'width-6-percent';
				yourself! !

!WABpmRoleManager methodsFor: 'operations' stamp: 'BrunoBB 03/15/2016 10:48'!
newRemoveRolFromUserButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self removeRoleFromUser: each]; 
								with: [html image url: (SEWAFFileLibrary / #remove24Png); 
														title: ('Remove User Role' translateFor: self session user); 
														altText: ('Remove User Role' translateFor: self session user).]] 
				title: 'DEL') sortBlock: nil; 
			cssClass: 'width-6-percent';
			yourself! !

!WABpmRoleManager methodsFor: 'operations' stamp: 'BrunoBB 09/01/2016 13:06'!
newRemoveUserFromRolButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self removeUserFromRole: each]; 
								with: [html image url: (SEWAFFileLibrary / #remove24Png); 
														title: ('Remove User from Role' translateFor: self session user); 
														altText: ('Remove User from Role' translateFor: self session user).]] 
				title: 'DEL') sortBlock: nil; 
			cssClass: 'width-6-percent';
			yourself! !

!WABpmRoleManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:48'!
newUser

   "Return the value of the instance variable 'newUser'."
   ^newUser! !

!WABpmRoleManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:48'!
newUser: newValue

   "Modify the value of the instance variable 'newUser'."
   newUser := newValue! !

!WABpmRoleManager methodsFor: 'operations' stamp: 'BrunoBB 09/01/2016 05:33'!
removeRol: aBpmRole

	(self componentValueAt: 'removeRol') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].

	aBpmRole canDelete 
	ifFalse: [self closeAllInformationComponents.
				^(self getTableNamed: 'Roles' ifAbsent: [^self]) 
					information: ('Role can not be deleted !!!!!!' translateFor: self session user)
					color: 'red'].

	rolesBatchList remove: aBpmRole.
	
	^aBpmRole removeFromCacheInAppName: aBpmRole getApplicationName! !

!WABpmRoleManager methodsFor: 'operations' stamp: 'BrunoBB 06/12/2016 17:41'!
removeRoleFromUser: aBpmRole

	aBpmRole ungrantUser: selectedUser.

	rolesWithSelectedUserBatchList remove: aBpmRole.

	self closeAllInformationComponents.
	(self getTableNamed: 'RolesOfSelectedUser' ifAbsent: [^self]) 
			information: ('Rol removed !!!!!!' translateFor: self session user)
			color: 'green'.! !

!WABpmRoleManager methodsFor: 'operations' stamp: 'BrunoBB 06/12/2016 17:41'!
removeUserFromRole: aBpmUser

	selectedObject ungrantUser: aBpmUser.

	rolesWithSelectedUserBatchList remove: aBpmUser.

	self closeAllInformationComponents.
	(self getTableNamed: 'UsersOfSelectedRole' ifAbsent: [^self]) 
			information: ('User removed !!!!!!' translateFor: self session user)
			color: 'green'.! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 08/10/2016 10:59'!
renderAddingUserOn: html

	html div id: 'users-to-add'; class: 'default-gray-table ';
		with:[addUserToRoleBatchList hasSearchSelector 
				ifFalse: ["if <orderMode> is true --> the user list has been sorted and it is already with the correct items"
					addUserToRoleBatchList hasOrderMode 
					ifFalse: [addUserToRoleBatchList items: (BpmUser cache reject: [:each | selectedObject isGranted: each]) asArray]].

				html render: (addUserToRoleBatchList table: self sewafTableForUsers)].! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 07:54'!
renderAddRoleOn: html
   | jQueryId |

	jQueryId := self renderJQueryPopupCompositeOn: html width: 350 height: 300 composite: WANewRolePopupComponent title: 'Create Role' domainObject: nil arguments: #().

	html div class: 'float-right margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #add24Png); 
												title: ('Add Role' translateFor: self session user); 
												altText: ('Add Role' translateFor: self session user) ]
	]! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:48'!
renderAddUserButtonOn: html

	html anchor callback: [self switchAddingUser];
					with: [html image url: (SEWAFFileLibrary / #useradd24iconPng); 
											altText: ('Add User to Rol' translateFor: self session user); 
											title: ('Add User to Rol' translateFor: self session user)].! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:48'!
renderApplicationComboOn: html

	html select 
		attributeAt: 'id' put: 'application';
		list: #(' '), (self session user getBackofficeApplications collect: [:each | each getApplicationNameForCombo]) asSortedCollection; 
		callback: [:value | 
			selectedApplication :=  (value size > 9) 
				ifTrue: [self getApplicationManagerClass getAnyApplicationNamed: (value allButLast: 9)]
				ifFalse: [nil].
		];
		selected: (selectedApplication ifNotNil: [selectedApplication getApplicationNameForCombo] ifNil: ['']).! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 07:18'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow'; with: [self renderNewRoleFormOn: html].

	html div id: 'system-rols'; class: 'default-gray-table '; with:[html render: (rolesBatchList table: self sewafTableForRoles).].
	self renderAddRoleOn: html. 
	selectedObject ifNil: [^self].
	isAddingUser ifTrue: [^self renderAddingUserOn: html].
	html div id: 'add-user-button'; with: [self renderAddUserButtonOn: html].

	html div id: 'rols-and-users'; with: [
			html div id: 'rols-users'; class: 'default-gray-table ';
				with:[usersWithSelectedRoleBatchList items: selectedObject users asArray.
							html render: (usersWithSelectedRoleBatchList table: self sewafTableUsersWithRol)].
			selectedUser ifNotNil: [
				html div id: 'user-rols'; class: 'default-gray-table ';
					with:[rolesWithSelectedUserBatchList items: selectedUser roles.
								html render: (rolesWithSelectedUserBatchList table: self sewafTableRolsOfUser).]]].! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 08:33'!
renderNewRoleFormOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	html div 
		with: [html form with: [
					html fieldSet with: [
						html legend class: 'top-search-legend'; 
							with: ('Search Roles' translateFor: self session user).
						html div class: 'top-search-div'; with: [
							html label attributeAt: 'for' put: 'rolename'; with: ('Rol''s Name' translateFor: self session user).
							html textInput attributeAt: 'id' put: 'rolename'; callback: [:value | model name: value].
						].
						html div class: 'top-search-div'; with: [
							html label attributeAt: 'for' put: 'application'; with: ('Application' translateFor: self session user).
							self renderApplicationComboOn: html.
						].
						html div class: 'top-search-div'; style: 'width: 235px; margin-top: 18px;'; with: [
							html checkbox attributeAt: 'id' put: 'isadmin'; callback: [:value | self model isAdmin: value].
							html label attributeAt: 'for' put: 'isadmin'; with: ('Is Admin ?' translateFor: self session user).
							html checkbox attributeAt: 'id' put: 'isbackoffice'; callback: [:value | self isBackoffice: value].
							html label attributeAt: 'for' put: 'isbackoffice'; with: ('Is Backoffice ?' translateFor: self session user).
						].
						html div class: 'top-search-filters-one'; with: [
							html submitButton style: 'margin-top: 25px;';
								callback: [self searchRoles]; 
								with: ('Search' translateFor: self session user).
						]
					]
				]
		].! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 10:12'!
searchBy: aSymbol

	(aSymbol = #username)
	ifTrue: [isAddingUser := true.
			^addUserToRoleBatchList 
					items: (addUserToRoleBatchList items select: [:each |  | columnValue |
								columnValue := each perform: aSymbol.
								columnValue := (columnValue isKindOf: String) ifTrue: [columnValue] ifFalse:[columnValue printString].
								(self componentValueAt: 'searchValue') match: columnValue]).
	].

	(#(#getApplicationName #name #isBackofficeRole #isAdmin) includes: aSymbol)
	ifTrue: [^rolesBatchList 
					items: (rolesBatchList items select: [:each |  | columnValue |
								columnValue := each perform: aSymbol.
								columnValue := (columnValue isKindOf: String) ifTrue: [columnValue] ifFalse:[columnValue printString].
								(self componentValueAt: 'searchValue') match: columnValue])].! !

!WABpmRoleManager methodsFor: 'searching' stamp: 'BrunoBB 03/15/2016 10:48'!
searchByApplication
	| roles |

	selectedApplication ifNil: [^self].

	roles := BpmRole getRolsInApp: selectedApplication.

	model isAdmin ifTrue: [roles := roles select: [:each | each isAdmin]].
	model isBackofficeRole ifTrue: [roles := roles select: [:each | each isBackofficeRole]].

	rolesBatchList items: roles.
	
	^roles! !

!WABpmRoleManager methodsFor: 'searching' stamp: 'BrunoBB 03/15/2016 10:48'!
searchByName

	^rolesBatchList items: (self session user getVisibleRoles select: [:each | each name = model name])! !

!WABpmRoleManager methodsFor: 'searching' stamp: 'BrunoBB 03/15/2016 10:48'!
searchRoles
	| roles |

	selectedObject := nil.

	model name notEmpty ifTrue: [^self searchByName].

	selectedApplication ifNotNil: [^self searchByApplication].

	roles :=  self session user getVisibleRoles.

	model isAdmin ifTrue: [roles := roles select: [:each | each isAdmin]].
	model isBackofficeRole ifTrue: [roles := roles select: [:each | each isBackofficeRole]].

	rolesBatchList items: roles.
	
	^roles! !

!WABpmRoleManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:48'!
selectedApplication

   "Return the value of the instance variable 'selectedApplication'."
   ^selectedApplication! !

!WABpmRoleManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:48'!
selectedApplication: newValue

   "Modify the value of the instance variable 'selectedApplication'."
   selectedApplication := newValue! !

!WABpmRoleManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:48'!
selectedUser

   "Return the value of the instance variable 'selectedUser'."
   ^selectedUser! !

!WABpmRoleManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:48'!
selectedUser: newValue

   "Modify the value of the instance variable 'selectedUser'."
   selectedUser := newValue! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 06/12/2016 17:02'!
sewafTableForRoles
	| table |

	table := (self hasTableNamed: 'Roles') 
		ifTrue: [self getTableNamed: 'Roles' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForRoles].

	table selectedObject:  selectedObject.

	^table! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 06/12/2016 17:28'!
sewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (self hasTableNamed: 'Users') 
		ifTrue: [self getTableNamed: 'Users' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForUsers].

	^table! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 06/12/2016 17:38'!
sewafTableRolsOfUser
	| table |

	table := (self hasTableNamed: 'RolesOfSelectedUser') 
		ifTrue: [self getTableNamed: 'RolesOfSelectedUser' ifAbsent: []] 
		ifFalse: [self initializeSewafTableRolsOfUser].

	^table! !

!WABpmRoleManager methodsFor: 'tables' stamp: 'BrunoBB 06/12/2016 17:03'!
sewafTableUsersWithRol
	| table |

	table := (self hasTableNamed: 'UsersOfSelectedRole') 
		ifTrue: [self getTableNamed: 'UsersOfSelectedRole' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForUsersWithRol].

	table selectedObject: selectedUser.

	^table! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 08/10/2016 10:43'!
sortColumn: sortBlock orderMode: aSymbol

"	addUserToRoleBatchList items: ( (aSymbol = #asc) 
		ifTrue: [(addUserToRoleBatchList items asSortedCollection: sortBlock) reverse] 
		ifFalse: [addUserToRoleBatchList items asSortedCollection: sortBlock])."

	rolesBatchList items: ( (aSymbol = #asc) 
		ifTrue: [(rolesBatchList items asSortedCollection: sortBlock) reverse] 
		ifFalse: [rolesBatchList items asSortedCollection: sortBlock]).! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 08/10/2016 10:59'!
sortUsers: sortBlock orderMode: aSymbol

	addUserToRoleBatchList orderMode: aSymbol.
	addUserToRoleBatchList items: ( (aSymbol = #asc) 
		ifTrue: [(addUserToRoleBatchList items asSortedCollection: sortBlock) reverse] 
		ifFalse: [addUserToRoleBatchList items asSortedCollection: sortBlock]).! !

!WABpmRoleManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:48'!
switchAddingUser

	isAddingUser := isAddingUser not! !

!WABpmRoleManager methodsFor: 'operations' stamp: 'BrunoBB 02/17/2017 07:57'!
updateRole: aRole
	
	rolesBatchList add: aRole! !

SEWAFWebObjectComposite subclass: #WABpmUserManager
	instanceVariableNames: 'isAddingRol resetPasswords usersBatchedList userRolesBatchedList addRoleBatchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:51'!
booleanValueForRol: anOrbeonFormRole

	^anOrbeonFormRole isGranted: selectedObject! !

!WABpmUserManager methodsFor: 'operations' stamp: 'BrunoBB 06/13/2016 09:48'!
createNewUser
	| newUser |

	newUser := model class getExistingOrNewUserNamed: model username password: model password.

	usersBatchedList add: newUser.	

	model := BpmUser new.

	^self answer! !

!WABpmUserManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:08'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'manage_users.html'! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:51'!
initialize

	super initialize.

	isAddingRol := false.
	model := BpmUser new.
	resetPasswords := Dictionary new.

	self initializeBatchedLists.

	self setShowToElementNamed: 'search-area'. "the search-are is shown by default"! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:51'!
initializeBatchedLists

	usersBatchedList := SewafBatchedList parentComponent: self.
	usersBatchedList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	userRolesBatchedList := SewafBatchedList parentComponent: self.
	userRolesBatchedList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	addRoleBatchedList := SewafBatchedList parentComponent: self.
	addRoleBatchedList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom-with-button'.! !

!WABpmUserManager methodsFor: 'tables' stamp: 'BrunoBB 09/01/2016 05:21'!
initializeSewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (SewafSelectTableReport parent: self)
		summary: 'Users to Assign';
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		"rows: self session user getVisibleUsers; "
		columns: (OrderedCollection new  
						add: ((SewafReportColumn selector: #username title: 'Username' onClick: [:each | selectedObject := each]) beSortable; sortBlock: [:a :b | a username <= b username]; beSearchable; yourself);
						add: ((SewafReportColumn selector: #isAdmin title: 'Admin?') beSortable; sortBlock: [:a :b | a isAdmin printString <= b isAdmin printString]; beSearchable; yourself);
						add: (SewafReportColumn selector: #printResetedPassword title: 'Reseted Password');
						add: self resetPasswordButton;
						add: self removeUserButton;
						yourself);
		rowColors: #(white white);
		selectedObject: selectedObject;
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'Users'.! !

!WABpmUserManager methodsFor: 'tables' stamp: 'BrunoBB 06/13/2016 10:01'!
initializeSewafTableRolsOfUser
	| table |

	table := (SewafTableReport summary: 'Users')
		"rows: selectedObject roles; "
		backcolor: self session user userOptions getTableReportBackcolor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Role');
						add: (SewafReportColumn selector: #isAdmin title: 'Admin');
						add: (SewafReportColumn selector: #isBackofficeRole title: 'Backoffice');
						add: (SewafReportColumn selector: #getApplicationName title: 'Application');
						add: self newRemoveRolFromUserButton;
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'RolsOfSelectedUser'.! !

!WABpmUserManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:51'!
isAddingRol

   "Return the value of the instance variable 'isAddingRol'."
   ^isAddingRol! !

!WABpmUserManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:51'!
isAddingRol: newValue

   "Modify the value of the instance variable 'isAddingRol'."
   isAddingRol := newValue! !

!WABpmUserManager methodsFor: 'operations' stamp: 'BrunoBB 06/13/2016 10:03'!
modifyRole: rol value: aBoolean

	isAddingRol := false.

	aBoolean ifFalse: [^self].

	addRoleBatchedList add: selectedObject.

	rol grantUser: selectedObject.

	self closeAllInformationComponents.
	(self getTableNamed: 'RolsOfSelectedUser' ifAbsent: [^self]) 
				information: ('User Granted !!!!!!' translateFor: self session user)
				color: 'green'! !

!WABpmUserManager methodsFor: 'operations' stamp: 'BrunoBB 03/15/2016 10:51'!
newRemoveRolFromUserButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self removeRolFromUser: each]; 
								with: [html image url: (SEWAFFileLibrary / #remove24Png); 
														title: ('Remove Role from User' translateFor: self session user); 
														altText: ('Remove Role from User' translateFor: self session user).]] 
				title: 'DEL') sortBlock: nil; 
				cssClass: 'width-6-percent';
			yourself! !

!WABpmUserManager methodsFor: 'operations' stamp: 'BrunoBB 06/13/2016 10:03'!
removeRolFromUser: aBpmRole

	userRolesBatchedList remove: aBpmRole.

	aBpmRole ungrantUser: selectedObject.

	self closeAllInformationComponents.
	(self getTableNamed: 'RolsOfSelectedUser' ifAbsent: [^self]) 
				information: ('User Ungranted !!!!!!' translateFor: self session user)
				color: 'green'! !

!WABpmUserManager methodsFor: 'operations' stamp: 'BrunoBB 09/01/2016 05:17'!
removeUser: aBpmUser

	(self componentValueAt: 'removeUser') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].

	aBpmUser canDelete 
	ifFalse: [self closeAllInformationComponents.
				^(self getTableNamed: 'Users' ifAbsent: [^self]) 
					information: ('User can not be deleted !!!!!!' translateFor: self session user)
					color: 'red'].

	usersBatchedList remove: aBpmUser.

	aBpmUser removeFromCache.

	self closeAllInformationComponents.
	(self getTableNamed: 'Users' ifAbsent: [^self]) 
				information: ('User deleted !!!!!!' translateFor: self session user)
				color: 'green'! !

!WABpmUserManager methodsFor: 'operations' stamp: 'BrunoBB 09/05/2016 14:08'!
removeUserButton

	^(SewafReportColumn 
			renderBlock: [:each :html | | jQueryId |
				each canDelete 
				ifTrue: [
					jQueryId := self renderJQueryConfirmationDialogOn: html forActionNamed: 'removeUser' actionMethod: #removeUser: arguments: (Array with: each).
					html anchor "callback: [self removeUser: each]; "
								class: 'cursor-pointer';
								onClick: (html jQuery id: jQueryId) dialog open;
								with: [html image url: (SEWAFIconLibrary / #remove24Png); 
														title: ('Remove User' translateFor: self session user); 
															altText: ('Remove User' translateFor: self session user).]
				]
				ifFalse: [html image url: (SEWAFIconLibrary / #stopred24Png); 
								title: ('User Can not be removed' translateFor: self session user);  
								altText: ('User Can not be removed' translateFor: self session user).
				]
			] 
			title: 'DEL') 
				sortBlock: nil; 
				cssClass: 'width-6-percent';
			yourself! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:51'!
renderAddingRolOn: html

	html div id: 'users-to-add-to-role'; class: 'default-gray-table ';
		with:[addRoleBatchedList items: (self session user getVisibleRoles difference: selectedObject roles).
				html render: (addRoleBatchedList table: self sewafTableForRols).].! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:51'!
renderAddRolButtonOn: html

	html anchor callback: [self switchAddingUser];
					with: [html image url: (SEWAFFileLibrary / #useradd24iconPng); 
											altText: ('Add Role to User' translateFor: self session user); 
											title: ('Add Role to User' translateFor: self session user)].! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 08:23'!
renderAddUserOn: html
   | jQueryId |

	jQueryId := self renderJQueryPopupCompositeOn: html width: 350 height: 250 composite: WANewUserPopupComponent title: 'Create User' domainObject: nil arguments: #().

	html div class: 'float-right margin-left-5px'; with: [
		html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open;
						with: [html image url: (SEWAFIconLibrary / #add24Png); 
												title: ('Add User' translateFor: self session user); 
												altText: ('Add User' translateFor: self session user) ]
	]! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 02/16/2017 13:37'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow';
		with: [self renderSearchAndNewFormOn: html].
	html div id: 'users-configuration'; with: [
		html div id: 'system-users'; class: 'default-gray-table ';
			with:[html render: (usersBatchedList table: self sewafTableForUsers)].
		self renderAddUserOn: html. 
		selectedObject ifNil: [^self].
		isAddingRol ifTrue: [^self renderAddingRolOn: html].
		html div id: 'add-rol-button'; 
			with: [self renderAddRolButtonOn: html].

		html div id: 'users-and-rols'; with: [
				html div class: 'default-gray-table ';
					with:[userRolesBatchedList items: selectedObject roles.
							html render:  (userRolesBatchedList table: self sewafTableRolsOfUser).
				]
		]
	].! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 02/17/2017 07:15'!
renderSearchAndNewFormOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"

	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].

	"html div id: 'newUserForm'; class: 'float-left'; with: [self renderNewFormOn: html].

	html div class: 'top-search-vertical-line'."

	html div id: 'searchUserForm'; with: [self renderSearchFormOn: html].! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 12/02/2016 06:13'!
renderSearchFormOn: html

	html form with: [
		html fieldSet with: [
			html legend class: 'top-search-legend'; 
				with: ('Search User' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'search-username'; with: ('User Name' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'search-username'; callback: [:value | self addSearchValue: value named: 'username'].
			].
			html div class: 'top-search-filters-one'; with: [
				html submitButton 
					style: 'margin-top: 25px;';
					callback: [self searchUser]; 
					with: ('Search' translateFor: self session user)]
		]
	]! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:51'!
resetPasswordButton

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html anchor callback: [self resetPasswordOf: each]; 
								with: [html image url: (SEWAFIconLibrary / #actionseditclear24Png); 
														title: ('Reset Password' translateFor: self session user); 
														altText: ('Reset Password' translateFor: self session user).]] 
				title: 'RP') sortBlock: nil; 
				cssClass: 'width-6-percent';
			yourself! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:51'!
resetPasswordOf: anOrbeonFormUser

	resetPasswords at: anOrbeonFormUser username put: anOrbeonFormUser resetPassword! !

!WABpmUserManager methodsFor: 'tables' stamp: 'BrunoBB 07/03/2016 17:14'!
searchBy: aSymbol

	usersBatchedList 
		items: (usersBatchedList items select: [:each |  | columnValue |
					columnValue := each perform: aSymbol.
					columnValue := (columnValue isKindOf: String) ifTrue: [columnValue] ifFalse:[columnValue printString].
					(self componentValueAt: 'searchValue') match: columnValue])! !

!WABpmUserManager methodsFor: 'searching' stamp: 'BrunoBB 03/15/2016 10:51'!
searchUser

	selectedObject := nil.

	(self hasSearchValueAt: 'username') 
	ifFalse: [^usersBatchedList items: (self session user getVisibleUsers asSortedCollection: [:a : b | a username <= b username])].

	usersBatchedList items: 
		(((self searchValueAt: 'username') includes: $*)
		ifTrue: [self session user getVisibleUsers select: [:each | (self searchValueAt: 'username') match: each username]]
		ifFalse: [self session user getVisibleUsers at: (self searchValueAt: 'username') ifAbsent: [#()]])! !

!WABpmUserManager methodsFor: 'tables' stamp: 'BrunoBB 06/12/2016 12:39'!
sewafTableForRols
	"Table with all Users that are NOT present in the role <selectedObject> "

	^(SewafBooleanSelectTable parent: self)
		summary: 'Users to Assign';
		backcolor: self session user userOptions getBooleanTableBackcolor;
		buttonLabel: ('Assign and Close' translateFor: self session user);
		booleanSelector: #booleanValueForRol:;
		callbackSelector: #modifyRole:value:;
		"rows: (self session user getVisibleRoles difference: selectedObject roles); "
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: 'Role');
						add: (SewafReportColumn selector: #getApplicationName title: 'Application');
						add: (SewafReportColumn selector: #isAdmin title: 'Admin?');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!WABpmUserManager methodsFor: 'tables' stamp: 'BrunoBB 06/13/2016 09:49'!
sewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (self hasTableNamed: 'Users') 
		ifTrue: [self getTableNamed: 'Users' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForUsers].

	table selectedObject:  selectedObject.

	^table! !

!WABpmUserManager methodsFor: 'tables' stamp: 'BrunoBB 06/13/2016 10:01'!
sewafTableRolsOfUser
	| table |

	table := (self hasTableNamed: 'RolsOfSelectedUser') 
		ifTrue: [self getTableNamed: 'RolsOfSelectedUser' ifAbsent: []] 
		ifFalse: [self initializeSewafTableRolsOfUser].

	^table! !

!WABpmUserManager methodsFor: 'tables' stamp: 'BrunoBB 07/03/2016 16:14'!
sortColumn: sortBlock orderMode: aSymbol

	usersBatchedList items: ( (aSymbol = #asc) 
		ifTrue: [(usersBatchedList items asSortedCollection: sortBlock) reverse] 
		ifFalse: [usersBatchedList items asSortedCollection: sortBlock]).! !

!WABpmUserManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:51'!
switchAddingUser

	isAddingRol := isAddingRol not! !

!WABpmUserManager methodsFor: 'operations' stamp: 'BrunoBB 02/16/2017 13:45'!
updateListWith: aBpmUser

	usersBatchedList add: aBpmUser.! !

SEWAFWebObjectComposite subclass: #WAInternationalizationManager
	instanceVariableNames: 'stringKey translatedString newLanguageName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 06/23/2015 14:13'!
currentDictionaryName

	^searchValues at: 'selected-language' ifAbsent: ['']! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:08'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'internationalization.html'! !

!WAInternationalizationManager methodsFor: 'Accessing' stamp: 'BrunoBB 06/23/2015 14:19'!
newLanguageName
	^newLanguageName! !

!WAInternationalizationManager methodsFor: 'Updating' stamp: 'BrunoBB 06/23/2015 14:19'!
newLanguageName: newValue
	newLanguageName := newValue! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 12:02'!
renderAddNewTranslationOn: html

	html form with: [
		html fieldSet with:[
			html legend with: [html strong: ('Add Translation' translateFor: self session user)].
				html label attributeAt: 'for' put: 'txtToTranslate'; with: ('Text to Translate' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'txtToTranslate'; callback: [:value | stringKey := value]; with: stringKey.
				html label attributeAt: 'for' put: 'translation'; with: ('Translation' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'translation'; callback: [:value | translatedString := value]; with: translatedString.
				html submitButton callback: [self saveTranslation]; with: ('Save Translation' translateFor: self session user).
					].
				].
	html horizontalRule.! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 03/11/2016 12:02'!
renderContentOn: html

	html div id: 'internationalization'; with: [
		html form with: [ 
			html fieldSet with: [
			html legend with: [html strong: ('Languages' translateFor: self session user)].
					html label attributeAt: 'for' put: 'language'; with: ('Languages' translateFor: self session user).
					html select attributeAt: 'id' put: 'language'; class: '';
						list: (#(''), self getInternationalization currentDictionaries);
						onChange: 'submit()';
						callback: [:value | searchValues at: 'selected-language' put: value];
						selected: self currentDictionaryName.
					html label attributeAt: 'for' put: 'newLanguage'; with: ('New Language' translateFor: self session user).
					html textInput attributeAt: 'id' put: 'newLanguage'; callback: [:value | newLanguageName := value]; with: newLanguageName.
					html submitButton 
						callback: [self saveLanguage]; 
						with: ('Save Language' translateFor: self session user).
				].
			].
		html horizontalRule.
		self renderCurrentDictionaryTranslationsOn: html.].! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:49'!
renderCurrentDictionaryTranslationsOn: html
	| currentDictionary |

	searchValues at: 'selected-language' ifAbsent: [^self].

	self renderAddNewTranslationOn: html.

	currentDictionary := self getInternationalization getTranslationsOf: (searchValues at: 'selected-language').

	html div id: 'inter-current-dictionary'; with: [
		currentDictionary keys asSortedCollection do: [:key | 
			html output: key, ' | '.
			html span: (currentDictionary at: key).
			html break.
		].
	].! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:49'!
saveLanguage

	self getInternationalization addLanguage: newLanguageName trimBlanks asSymbol! !

!WAInternationalizationManager methodsFor: 'other' stamp: 'BrunoBB 02/09/2016 13:49'!
saveTranslation

	self getInternationalization
		translate: stringKey 
		as: translatedString 
		for: self currentDictionaryName! !

!WAInternationalizationManager methodsFor: 'Accessing' stamp: 'BrunoBB 06/23/2015 14:12'!
stringKey
	^stringKey! !

!WAInternationalizationManager methodsFor: 'Updating' stamp: 'BrunoBB 06/23/2015 14:12'!
stringKey: newValue
	stringKey := newValue! !

!WAInternationalizationManager methodsFor: 'Accessing' stamp: 'BrunoBB 06/23/2015 14:12'!
translatedString
	^translatedString! !

!WAInternationalizationManager methodsFor: 'Updating' stamp: 'BrunoBB 06/23/2015 14:12'!
translatedString: newValue
	translatedString := newValue! !

SEWAFWebObjectComposite subclass: #WALoginModeManager
	instanceVariableNames: 'modeType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WALoginModeManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:08'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'login_mode.html'! !

!WALoginModeManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:54'!
initialize

	super initialize.

	modeType := (self getGemStoneServerConfiguration loginModeFor: 'orbeon-processes-web') modeName! !

!WALoginModeManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:54'!
ldapLoginModeName

	^OrbeonLdapLogin modeName! !

!WALoginModeManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:54'!
loginModeNames

	^Array
		with: self ldapLoginModeName
		with: OrbeonProcessWebLocalLogin modeName! !

!WALoginModeManager methodsFor: 'Accessing' stamp: 'BrunoBB 03/15/2016 10:54'!
modeType

   "Return the value of the instance variable 'modeType'."
   ^modeType! !

!WALoginModeManager methodsFor: 'Updating' stamp: 'BrunoBB 03/15/2016 10:54'!
modeType: newValue

   "Modify the value of the instance variable 'modeType'."
   modeType := newValue! !

!WALoginModeManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:54'!
renderContentOn: html

	html div id: 'login-mode-configuration'; class: 'centered-unique-form';
		with: [self renderLoginModeOn: html].! !

!WALoginModeManager methodsFor: 'other' stamp: 'BrunoBB 06/29/2016 08:05'!
renderLdapOptionsOn: html

	self getGemStoneServerConfiguration setLdapFor: 'orbeon-processes-web'.
	html break.
	html label attributeAt: 'for' put: 'ldapIP'; with: ('Ldap IP' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'ldapIP'; callback: [:value | self getGemStoneServerConfiguration loginModeForProcessWeb ldapIP: value]; 
		with: self getGemStoneServerConfiguration ldapIpForWebProcess.
	html label attributeAt: 'for' put: 'dn'; with: ('Base Dn' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'dn'; callback: [:value | self getGemStoneServerConfiguration loginModeForProcessWeb dn: value]; 
		with: self getGemStoneServerConfiguration dnForWebProcess.
	html label attributeAt: 'for' put: 'ou'; with: ('Bind Dn' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'ou'; callback: [:value | self getGemStoneServerConfiguration loginModeForProcessWeb ou: value]; 
		with: self getGemStoneServerConfiguration ouForWebProcess.
	html label attributeAt: 'for' put: 'bindPassword'; with: ('Bind Password' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'bindPassword'; callback: [:value | self getGemStoneServerConfiguration loginModeForProcessWeb bindPassword: value]; 
		with: self getGemStoneServerConfiguration bindPasswordForWebProcess.! !

!WALoginModeManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:54'!
renderLoginModeOn: html

	html form with: [
		html fieldSet with:[
			html legend with: [html strong: ('Login Mode' translateFor: self session user)].
			html radioGroup
				callback: [:value | modeType := value];
				selected: modeType;
				with: [ :group |
					self loginModeNames do: [:each |
						html label: [ group radioButton onChange: 'submit()'; value: each.
							html text: each]]].
			(modeType = self ldapLoginModeName) 
			ifTrue: [self renderLdapOptionsOn: html]
			ifFalse: [self setLocalLoginMode].
			html submitButton callback: [self saveLoginMode]; with: ('Save Login Mode' translateFor: self session user).
		].
	].! !

!WALoginModeManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:54'!
saveLoginMode! !

!WALoginModeManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:54'!
setLocalLoginMode

	self getGemStoneServerConfiguration setLocalForProcesses! !

SEWAFWebObjectComposite subclass: #WAManageFormProcessCategory
	instanceVariableNames: 'selectedCategory batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAManageFormProcessCategory methodsFor: 'Accessing' stamp: 'BrunoBB 03/08/2016 16:25'!
batchedList
	^batchedList! !

!WAManageFormProcessCategory methodsFor: 'Updating' stamp: 'BrunoBB 03/08/2016 16:25'!
batchedList: newValue
	batchedList := newValue! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 16:34'!
categoryColorColumn

	^(SewafReportColumn 
			renderBlock: [:each :html | 
				html colorInput 
					attributeAt: 'title' put: ('Color' translateFor: self session user);
					disabled;
					value: each color.] 
			title: ('Color' translateFor: self session user)) sortBlock: nil; 
			yourself! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 01/26/2017 03:46'!
createNewCategory

	model name ifEmpty: [^self].

	model addToCacheIn: self session user username.

	batchedList add: model.

	model := BpmProcessDefinitionCategory new.! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/15/2015 10:17'!
getAllUserCategories

	^BpmProcessDefinitionCategory getCategoriesFor: self session user! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:09'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'process_categories.html'! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 07:25'!
initialize

	super initialize.

	model := BpmProcessDefinitionCategory new.

	batchedList := SewafBatchedList parentComponent: self items: self getAllUserCategories.

	batchedList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 12/14/2015 11:57'!
modifyCategory

	selectedCategory removeFromCacheFrom: self session user username.

	selectedCategory name: (self componentValueAt: 'name').
	selectedCategory color: (self componentValueAt: 'color').

	selectedCategory addToCacheIn: self session user username.! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/09/2016 11:24'!
removeCategory

	selectedCategory removeFromCacheFrom: self session user username.

	batchedList remove: selectedCategory.

	selectedCategory := nil.

	model := BpmProcessDefinitionCategory new.! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/04/2016 06:40'!
renderCategoryFormOn: html

	html div class: 'centered-unique-form float-left'; with: [
		html form 
			"class: 'height250';"
			with: [
				html fieldSet with: [
					selectedCategory 
						ifNil: [self renderNewCategoryOn: html]
						ifNotNil: [self renderSelectedCategoryOn: html].
			].
		]
	].! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/08/2016 16:27'!
renderContentOn: html

	html div with: [

		self renderCategoryFormOn: html.

		html div class: 'default-gray-table float-left';
			with:[html render: (batchedList table: self sewafTableForUserCategories).].
	].! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 14:55'!
renderNewCategoryOn: html

	html legend with: [html strong: ('New Category' translateFor: self session user)].
	html label 
		attributeAt: 'for' put: 'name'; 
		with: ('Name' translateFor: self session user).
	html textInput 
		attributeAt: 'id' put: 'name'; 
		callback: [:value | model name: value].
	html label 
		attributeAt: 'for' put: 'color'; 
		with: ('Color' translateFor: self session user).
	html colorInput 
		attributeAt: 'id' put: 'color'; 
		callback: [:value | model color: value].
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self createNewCategory]; 
		with: ('Create Category' translateFor: self session user)! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 03/02/2016 15:05'!
renderSelectedCategoryOn: html

	html legend with: [html strong: ('Selected Category' translateFor: self session user)].
	html label 
		attributeAt: 'for' put: 'name'; 
		with: ('Name' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'name';
		value: selectedCategory name;
		callback: [:value | self addValue: value named: 'name'].
	html label 
		attributeAt: 'for' put: 'color'; 
		with: ('Color' translateFor: self session user).
	html colorInput attributeAt: 'id' put: 'color';
		value: selectedCategory color; 
		callback: [:value | self addValue: value named: 'color'].
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self modifyCategory]; 
		with: ('Modify Category' translateFor: self session user).
	html submitButton 
		class: 'display-block margin-top-15px';
		callback: [self removeCategory]; 
		with: ('Remove Category' translateFor: self session user).! !

!WAManageFormProcessCategory methodsFor: 'Accessing' stamp: 'BrunoBB 10/07/2014 06:12'!
selectedCategory

   "Return the value of the instance variable 'selectedCategory'."
   ^selectedCategory! !

!WAManageFormProcessCategory methodsFor: 'Updating' stamp: 'BrunoBB 10/07/2014 06:12'!
selectedCategory: newValue

   "Modify the value of the instance variable 'selectedCategory'."
   selectedCategory := newValue! !

!WAManageFormProcessCategory methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 12:48'!
sewafTableForUserCategories

	^(SewafSelectTableReport summary: 'User Process Definition Categories')
		rows: self getAllUserCategories; "get collection elements"
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #name title: ('Category Name' translateFor: self session user) onClick: 
						[:each | (selectedCategory == each) ifTrue: [selectedCategory := nil] ifFalse: [selectedCategory := each]]);
						add: self categoryColorColumn;
						yourself);
		selectedObject: selectedCategory;
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

SEWAFWebObjectComposite subclass: #WAOrbeonFormsManager
	instanceVariableNames: 'selectedApplications selectedDefinitions batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:09'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'manage_orbeon_forms.html'! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 11:32'!
importNewApplications

	^#deprecated.
"
	^OrbeonHandler default importNewApplicationsButNoData
"! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 11:32'!
initialize

	super initialize.

	selectedApplications := #().
	selectedDefinitions := #().

	batchedList := SewafBatchedList parentComponent: self.

	batchedList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 11:32'!
renderApplicationsListOn: html
	| apps |

	apps := self session user getOrbeonBackofficeApplications.
	html multiSelect 
		attributeAt: 'title' put: ('Orbeon Applications' translateFor: self session user);
		list: (apps collect: [:each | each applicationName]) asSortedCollection;
		size: apps size;
		callback: [:value | self selections: value].! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 11/20/2016 10:35'!
renderContentOn: html

	html div id: 'orbeon-list-application'; class: 'centered-unique-form';
		with: [
			html form with: [
				html fieldSet with:[ 
					html legend with: [html strong: ('Available Orbeon Applications' translateFor: self session user)].
					html div id: 'applications-list'; with: [self renderApplicationsListOn: html].
					html div id: 'forms-operations'; with: [self renderFormOperationsOn: html]].
			]
	].

	html div id: 'orbeon-definitions-list'; class: 'default-gray-table ';
		with: [self renderFormDefinitionsOn: html].! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 11:32'!
renderFormDefinitionsOn: html

	selectedDefinitions ifNil: [^self].

	html render: (batchedList table: self sewafTableForOrbeonFormDefinitions).! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 11:32'!
renderFormOperationsOn: html

	html submitButton callback: [self showFormDefinitions]; with: ('Show Form Definitions' translateFor: self session user).

"These two operation are deprecated since there a Orbeon Persistence Layer now and synchronization is 100% with Orbeon "

"	html submitButton callback: [self importNewApplications]; with: ('Import New Applications' translateFor: self session user).
	html submitButton callback: [self updateSelectedApplications]; with: ('Update Selected Applications' translateFor: self session user)."! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 11:32'!
selections: value

	selectedApplications := value! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 12:42'!
sewafTableForOrbeonFormDefinitions

	^(SewafTableReport summary: 'Orbeon Form Definitions')
		rows: selectedDefinitions; "get collection elements"
		backcolor: self session user userOptions getTableReportBackcolor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #applicationName title: 'Application');
						add: (SewafReportColumn selector: #formName title: 'Form');
						add: (SewafReportColumn selector: #version title: 'Version');
						add: (SewafReportColumn selector: #createdTime title: 'Created');
						add: (SewafReportColumn selector: #modifiedTime title: 'Modified');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 11:32'!
showFormDefinitions

	selectedDefinitions := OrderedCollection new.
	selectedApplications do: [:eachApp | | app |
		app := self getOrbeonApplicationClass applicationNamed: eachApp.
		selectedDefinitions addAll: app getLastDefinitions.
		].

	batchedList items: selectedDefinitions.! !

!WAOrbeonFormsManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 11:32'!
updateSelectedApplications
	| appToUpdate |

	^#deprecated.
"
	appToUpdate := ((selectedApplications collect: [:each | self getApplicationManagerClass applicationNamed: each ifNone: [nil]])
							select: [:each | each notNil]).

	appToUpdate do: [:eachApp | OrbeonHandler default updateApplicationButNotDataOf: eachApp].

	^self
"! !

SEWAFWebObjectComposite subclass: #WAOrbeonRadarComposite2
	instanceVariableNames: 'searchCollectionResult batchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonRadarComposite2 methodsFor: 'Accessing' stamp: 'BrunoBB 06/03/2016 15:48'!
batchedList
	^batchedList! !

!WAOrbeonRadarComposite2 methodsFor: 'Updating' stamp: 'BrunoBB 06/03/2016 15:48'!
batchedList: newValue
	batchedList := newValue! !

!WAOrbeonRadarComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:53'!
getFreeTransitions

	selectedObject ifNil: [^#()].

	^selectedObject getAllAvailableTaskAssignments! !

!WAOrbeonRadarComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:55'!
getProcessWithFreeTransitions

	^selectedObject getAllAvailableTaskAssignments! !

!WAOrbeonRadarComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/03/2016 16:59'!
initialize

	super initialize.

	searchCollectionResult := OrderedCollection new.

	batchedList := SewafBatchedList parentComponent: self.

	batchedList batchSize: self session user regularListPagingSize;
		navigationCssClass: 'batch-div-bottom';
		isBottomBatch: true.! !

!WAOrbeonRadarComposite2 methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 14:53'!
searchCollectionResult
	^searchCollectionResult! !

!WAOrbeonRadarComposite2 methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 14:53'!
searchCollectionResult: newValue
	searchCollectionResult := newValue! !

WAOrbeonRadarComposite2 subclass: #WAOrbeonRadarProcessComposite2
	instanceVariableNames: 'assignmentBatchedList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonRadarProcessComposite2 methodsFor: 'process state' stamp: 'brunobb 12/17/2017 17:16'!
abortSelectedProcess

	(self componentValueAt: 'abortSelectedProcess') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].

	^selectedObject abortProcess: self session user! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/01/2016 13:46'!
createFilledFormsColumn

	^(SewafReportColumn selector: #printRunningArtifacts title: ('Filled Forms' translateFor: self session user))
		cssClass: 'max-width-td';
		yourself! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 16:08'!
getFormDefinitions
	| definitions |

	definitions := Set new.

	self selectedProcessDefinition do: [:each | definitions addAll: each getTaskNames].

	^#(''), definitions asArray

 "(self selectedApplication getLastDefinitions collect: [:each | each formName]) asArray"! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/03/2016 14:59'!
getFormFields
	| selectedProcess selectedTask fieldList |

	selectedProcess := self getProcessDefinitionOrNil.
	selectedProcess ifNil: [^#()].
	selectedTask := self getTaskOrNil.
	selectedTask ifNil: [^#()].

	fieldList := selectedProcess getFieldNamesOfTask: selectedTask name.

	^(fieldList remove: 'assignmentOop[s]' ifAbsent: []; 
			remove: 'k[s]' ifAbsent: []; 
			remove: 's[s]' ifAbsent: [];
			remove: 'oop[s]' ifAbsent: [];
			remove: 'uuid[s]' ifAbsent: [];
			yourself) asSortedCollection! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/03/2016 10:43'!
getProcessDefinitionOrNil
	| definitions |

	definitions := BpmProcessDefinition getAllProcessesNamed: self getProcessType in: self getSelectedApplication.

	^definitions ifNotEmpty: [definitions last] ifEmpty: [nil]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 15:53'!
getProcessType

	^self searchValueAt: 'process-type' ifAbsent: ['']! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 15:39'!
getSelectedApplication

	^self searchValueAt: 'application' ifAbsent: ['']! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 15:54'!
getSelectedFormDefinition

	^self searchValueAt: 'form-definition' ifAbsent: ['']! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 15:53'!
getSelectedFormField

	^self searchValueAt: 'form-field' ifAbsent: ['']! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 15:54'!
getSelectedFormFieldValue

	^self searchValueAt: 'field-value' ifAbsent: ['']! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 15:54'!
getSelectedFormFieldValue2

	^self searchValueAt: 'field-value-2' ifAbsent: ['']! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/03/2016 10:57'!
getTaskOrNil
	"The receiver answer the current selected task (orbeon form definition or st model) or nil"

	^self getProcessDefinitionOrNil
		ifNil: [nil]
		ifNotNil: [:procDefinition | procDefinition getTaskNamed: self getSelectedFormDefinition ifNone: [nil]]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'monitor_processes.html'! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
hasFormDefinition

	^(searchValues includesKey: 'form-definition') and: [(searchValues at: 'form-definition') notEmpty]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
hasFormField

	^(searchValues includesKey: 'form-field') and: [(searchValues at: 'form-field') notEmpty]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
hasProcessId

	^(searchValues includesKey: 'id') and: [(searchValues at: 'id') notEmpty]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
hasSelectedApplication

	^(searchValues includesKey: 'application') and: [(searchValues at: 'application') notEmpty]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/11/2016 13:04'!
initialize

	super initialize.

	searchCollectionResult := OrderedCollection new.

	assignmentBatchedList := SewafBatchedList parentComponent: self.

	self setShowToElementNamed: 'search-area'.

	assignmentBatchedList batchSize: self session user regularListPagingSize;
		navigationCssClass: 'batch-div-bottom';
		isBottomBatch: true.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 12/20/2015 14:54'!
onApplicationChanged: appName

	searchValues 
		removeKey: 'form-definition' ifAbsent: [];
		removeKey: 'form-field' ifAbsent: [];
		at: 'application' put: appName.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 12/20/2015 14:54'!
onCheckboxFinishedChanged: aBoolean

	searchValues at: 'filter-finished' put: aBoolean! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 12/20/2015 14:54'!
onFormDefinitionChanged: definitionName

	searchValues at: 'form-definition' put: definitionName! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 12/20/2015 14:54'!
onFormFieldChanged: fieldName

	searchValues at: 'form-field'  put: fieldName.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 12/20/2015 14:54'!
onProcessIdChanged: value

	searchValues at: 'id' put: value! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'process state' stamp: 'brunobb 12/17/2017 17:01'!
pauseSelectedProcess

	(self componentValueAt: 'pauseSelectedProcess') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].


	^selectedObject pauseProcess: self session user! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 05/31/2016 15:52'!
registerProcessType: value

	self addSearchValue: value named: 'process-type'.
	self removeSearchValueNamed: 'form-type'.
	self removeSearchValueNamed: 'field-name'.
	self removeSearchValueNamed: 'field-value'.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'process state' stamp: 'brunobb 12/17/2017 17:50'!
renderAbortStateIconOn: html
   | jQueryId |

	jQueryId := self renderJQueryConfirmationDialogOn: html title: 'Abort Process' forActionNamed: 'abortSelectedProcess' actionMethod: #abortSelectedProcess.

	selectedObject isAborted ifFalse: [
		html div class: 'float-left margin-left-5px'; with: [
			html anchor
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open; 
					with: [html image url: (SEWAFIconLibrary / #symboldelete24Png); 
											title: ('Abort Process' translateFor: self session user); 
											altText: ('Abort Process' translateFor: self session user)]
		]
	].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 03/04/2016 12:10'!
renderApplicationComboOn: html

	html label attributeAt: 'for' put: 'application'; with: ('Application' translateFor: self session user).
	html select "Process Definition List"
		attributeAt: 'id' put: 'application'; 
		list: (#(''), (self session user getBackofficeApplications collect: [:each | each applicationName]) asSortedCollection);
		onChange: 'submit()';
		selected: (searchValues at: 'application' ifAbsent: ['']);
		callback: [:value | searchValues at: 'application' put: value].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'process state' stamp: 'brunobb 12/17/2017 16:50'!
renderChangeProcessStateFormOn: html

	html div class: 'display-inline-flex margin-left-10px margin-top-10px'; with: [

		self renderPauseStateIconOn: html.
		self renderResumeStateIconOn: html.
		self renderAbortStateIconOn: html.

		html anchor class: 'margin-left-20px margin-top-5px';
			target: '_blank';
			callback: [self requestContext redirectTo: self getGemStoneServerConfiguration baseUrlDocumentation, 'states/process-states.html'];
			with: [
				html image url: (SEWAFIconLibrary / #helpicon16Png); 
					altText: 'Help on Process State'; 
					title: 'Help on Process State'.
		]

	].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'brunobb 12/15/2017 12:17'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow'; with: [self renderSearchOptionsOn: html].

	batchedList items: searchCollectionResult.
	html div id: 'process-instances'; class: 'default-gray-table ';
		with:[html render: (batchedList table: self sewafTableForRunningFormProcesses).].

	searchCollectionResult isEmpty ifTrue: [^self].
	selectedObject ifNil: [^self].

	self renderChangeProcessStateFormOn: html.

	assignmentBatchedList items: selectedObject userAssignments.
	html div id: 'process-assignments'; class: 'default-gray-table ';
		with:[html render: (assignmentBatchedList table: self sewafTableForProcessAssignments)].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 06/03/2016 11:43'!
renderFilterValuesAndButtonOn: html
	| procDef fieldType |

	procDef := self getProcessDefinitionOrNil.
	procDef ifNil: [^self].

	fieldType := (procDef getTypeOfFieldNamed: self getSelectedFormField) ifNil: [^self renderOneFilterOn: html]  ifNotNil: [:type | type].

	((OrderedCollection with: String with: Boolean) includes: fieldType) ifTrue: [^self renderOneFilterOn: html].

	^self renderTwoFitersOn: html! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 05/30/2016 17:45'!
renderFormDefinitionComboOn: html

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'formDefinitions';
			with: ('Form Definition' translateFor: self session user).

		html select attributeAt: 'id' put: 'formDefinitions'; "Process Definition List"
			list: self getFormDefinitions;
			onChange: 'submit()';
			callback: [:value | self onFormDefinitionChanged: value];
			selected: (searchValues at: 'form-definition' ifAbsent: [' ']).].


	self renderFormFieldsComboOn: html. "render fields of the selected form definition"! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:13'!
renderFormFieldsComboOn: html

	html div class: 'top-search-div'; with: [
		html label 
			attributeAt: 'for' put: 'formFields'; 
			class: 'search-section-float-left'; with: ('Form Fields' translateFor: self session user).
		html select attributeAt: 'id' put: 'formFields';
			class: 'search-section-float-left';"Process Definition List"
			list: (#(''), self getFormFields) asSortedCollection;
			onChange: 'submit()';
			callback: [:value | self onFormFieldChanged: value];
			selected: (searchValues at: 'form-field' ifAbsent: ['']).
	].

	self hasFormField
	ifTrue: [self renderFilterValuesAndButtonOn: html]
	ifFalse: [html div class: 'top-search-filters-one'; with: [self renderSubmitButtonOn: html class: 'margin-top-20px']]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 05/31/2016 16:34'!
renderIsFinishedOn: html

	html div class: 'top-search-div width-100px'; with: [
		html label: [ 
			html checkbox class: 'margin-top-20px float-left';
				value: (searchValues at: 'filter-finished' ifAbsent: [false]);
				callback: [ :value | self onCheckboxFinishedChanged: value ].
		html text: ('Finished ?' translateFor: self session user).].
	].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:36'!
renderOneFilterOn: html

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'filterOne';
			class: 'search-section-float'; with: ('Field Value' translateFor: self session user).

		html textInput attributeAt: 'id' put: 'filterOne';
			value: self getSelectedFormFieldValue;
			class: 'search-section-float search-section-width-200';
			callback: [:value | searchValues at: 'field-value' put: value].
	].

	html div class: 'top-search-filters-two'; with:[ 
		html submitButton 
			class: 'search-section-float search-section-width-100 margin-top-35px';
			callback: [self searchMatchingProcesses]; 
			with: ('Search' translateFor: self session user)].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'process state' stamp: 'brunobb 12/17/2017 17:51'!
renderPauseStateIconOn: html
   | jQueryId |

	jQueryId := self renderJQueryConfirmationDialogOn: html title: 'Pause Process' forActionNamed: 'pauseSelectedProcess' actionMethod: #pauseSelectedProcess.

	selectedObject isPaused ifFalse: [
		html div class: 'float-left margin-left-5px'; with: [
			html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open; 
					with: [html image url: (SEWAFIconLibrary / #pause24Png); 
											title: ('Pause Process' translateFor: self session user); 
											altText: ('Pause Process' translateFor: self session user)]
		]
	].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 05/31/2016 16:33'!
renderProcessIdOn: html

	html div class: 'top-search-div width-100px'; with: [
		html label attributeAt: 'for' put: 'id'; with: ('Id' translateFor: self session user).
		html textInput attributeAt: 'id' put: 'id';
			callback: [:value | self onProcessIdChanged: value];
			with: (searchValues at: 'id' ifAbsent: ['']).
	].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 05/31/2016 16:01'!
renderProcessTypeComboOn: html
	| definitionsNames |

	definitionsNames  := (BpmProcessDefinition getAllVersionsIn: self getSelectedApplication) collect: [:each | each processName].

	html div class: 'top-search-div'; with: [
		html label 
			attributeAt: 'for' put: 'processType';
			with: ('Process Type' translateFor: self session user).

		html select "Process Definition List"
			attributeAt: 'id' put: 'processType';
			list: #(''), definitionsNames;
			onChange: 'submit()';
			callback: [:value | self registerProcessType: value];
			selected: (self getProcessType).
	].

	self getProcessType ifNotEmpty: [:value | self renderFormDefinitionComboOn: html]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'process state' stamp: 'brunobb 12/17/2017 17:51'!
renderResumeStateIconOn: html
   | jQueryId |

	jQueryId := self renderJQueryConfirmationDialogOn: html title: 'Resume Process' forActionNamed: 'resumeSelectedProcess' actionMethod: #resumeSelectedProcess.

	selectedObject isRunning ifFalse: [
		html div class: 'float-left margin-left-5px'; with: [
			html anchor 
					class: 'cursor-pointer';
					onClick: (html jQuery id: jQueryId) dialog open; 
					with: [html image url: (SEWAFIconLibrary / #continue24Png); 
											title: ('Resume Process' translateFor: self session user); 
											altText: ('Resume Process' translateFor: self session user)]
		]
	].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:37'!
renderSearchOptionsOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"
	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].
	html form with: [ 
		html fieldSet with: [
			html legend class: 'top-search-legend'; with: ('Search Options' translateFor: self session user).
			self renderProcessIdOn: html.
			"self renderIsFinishedOn: html."
			html div class: 'top-search-div'; with: [self renderApplicationComboOn: html].
			self hasSelectedApplication 
			ifTrue: [self renderProcessTypeComboOn: html]
			ifFalse: [html div class: 'top-search-filters-two'; 
								class: 'margin-top-20px float-left width-100px'; 
								with: [self renderSubmitButtonOn: html]].

		].
	].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 11/06/2016 06:25'!
renderSubmitButtonOn: html

	^self renderSubmitButtonOn: html class: nil! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 11/06/2016 06:25'!
renderSubmitButtonOn: html class: className

	html submitButton
			class: className;
			callback: [self searchProcessId]; 
			with: ('Search' translateFor: self session user).! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'search area' stamp: 'BrunoBB 01/09/2017 06:37'!
renderTwoFitersOn: html


	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'filterTwo';
			class: 'search-section-float'; with: ('Start' translateFor: self session user).

		html textInput attributeAt: 'id' put: 'filterTwo';
			class: 'search-section-float search-section-width-200';
			callback: [:value | searchValues at: 'field-value' put: value].
	].

	html div class: 'top-search-div'; with: [
		html label attributeAt: 'for' put: 'filterOne';
			class: 'search-section-float'; with: ('End' translateFor: self session user).

		html textInput attributeAt: 'id' put: 'filterOne';
			class: 'search-section-float search-section-width-200';
			callback: [:value | searchValues at: 'field-value-2' put: value].
	].

	html div class: 'top-search-filters-two'; with:[ 
		html submitButton class: 'search-section-float search-section-width-100 margin-top-35px';
						callback: [self searchMatchingProcessesRange]; with: ('Search' translateFor: self session user)].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'process state' stamp: 'brunobb 12/17/2017 17:17'!
resumeSelectedProcess

	(self componentValueAt: 'resumeSelectedProcess') "the jqdialog set this value"
	ifNil: [^self]
	ifNotNil: [:aBoolean | aBoolean ifFalse: [^self]].

	^selectedObject resumeProcess: self session user! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'searching' stamp: 'BrunoBB 06/13/2016 11:16'!
searchByApplication
	| app |

	selectedObject := nil.
	self hasSelectedApplication ifFalse: [^self].
	self hasFormDefinition ifTrue: [^self searchByApplicationAndFormDefinition].

	app := self searchValueAt: 'application'.
	searchCollectionResult :=
		app ifNotNil: [BpmRunningTasksMatrix 
								getAllAvailableTaskAssignmentsIn: 
									(OrderedCollection with: 
										(self getApplicationManagerClass getAnyApplicationNamed: app ifNone: [#()])).]
		ifNil: [#()].

	searchCollectionResult := searchCollectionResult collect: [:each | each process].

	searchValues 
		removeKey: 'form-definition' ifAbsent: [];
		removeKey: 'form-field' ifAbsent: [].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'searching' stamp: 'BrunoBB 06/13/2016 11:13'!
searchByApplicationAndFormDefinition
	| application |
	 "searchCollectionResult := OrbeonFormProcessDefinition getProcessInstancesOf: self getSelectedApplication ofFormNamed: self getSelectedFormDefinition."

	application := self getApplicationManagerClass getAnyApplicationNamed: (self searchValueAt: 'application') ifNone: [nil].
	application ifNil: [^searchCollectionResult := #()].

	searchCollectionResult := BpmRunningTasksMatrix getAllAvailableTaskAssignmentsIn: (OrderedCollection with: application).

	searchCollectionResult := (searchCollectionResult select: [:each | each process hasTaskNamed: self getSelectedFormDefinition])
											collect: [:each | each process]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'searching' stamp: 'BrunoBB 06/03/2016 14:27'!
searchMatchingProcesses
	| assignments |

	selectedObject := nil.
	self hasProcessId ifTrue: [^self searchProcessId].

	(self hasSelectedApplication and:[self hasFormDefinition not]) 
	ifTrue: [^self searchByApplication].

	(self hasSelectedApplication and:[self hasFormDefinition and:[self hasFormField not]])
	ifTrue: [^self searchByApplicationAndFormDefinition].

	assignments := BpmProcessDefinition getAssignmentsIn: self getSelectedApplication 
							processName: self getProcessType 
							formName: self getSelectedFormDefinition 
							fieldName: self getSelectedFormField
							withValue: self getSelectedFormFieldValue.

	searchCollectionResult := (assignments collect: [:each | each process]) asArray.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'searching' stamp: 'BrunoBB 06/04/2016 10:06'!
searchMatchingProcessesRange
	| assignments |

	selectedObject := nil.
	self hasProcessId ifTrue: [^self searchProcessId].

	(self hasSelectedApplication and:[self hasFormDefinition not]) 
	ifTrue: [^self searchByApplication].

	(self hasSelectedApplication and:[self hasFormDefinition and:[self hasFormField not]])
	ifTrue: [^self searchByApplicationAndFormDefinition].

	assignments := BpmProcessDefinition getAssignmentsIn: self getSelectedApplication 
							processName: self getProcessType 
							formName: self getSelectedFormDefinition 
							fieldName: self getSelectedFormField
							initialValue: self getSelectedFormFieldValue
							endValue: self getSelectedFormFieldValue2.

	searchCollectionResult := (assignments collect: [:each | each process]) asArray.! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'searching' stamp: 'BrunoBB 06/03/2016 15:40'!
searchProcessId
	| id contextApplications |

	selectedObject := nil.
	self hasProcessId ifFalse: [^self hasSelectedApplication ifTrue:[self searchByApplication] ifFalse:[searchCollectionResult := #()]].

	id := [Integer fromString: (searchValues at: 'id')] on: Error do: [:err | 0].

	contextApplications := 
		(self session user getBackofficeApplications 
			collect: [:each | 
				BpmProcessDefinition cacheAt: each applicationName ifAbsent: [nil]]) 
		select: [:each | each notNil].

	searchCollectionResult := (BpmProcessDefinition getProcessInstanceWithId: id onApplications: contextApplications) 
										ifNil: [#()] 
										ifNotNil: [:object | OrderedCollection with: object].

	searchValues 
		removeKey: 'form-definition' ifAbsent: [];
		removeKey: 'form-field' ifAbsent: [];
		removeKey: 'application' ifAbsent: [].! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 02/25/2016 12:38'!
selectedApplication

	^self getApplicationManagerClass 
			getAnyApplicationNamed: (searchValues at: 'application') 
			ifNone: [self getOrbeonApplicationClass new]! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
selectedFormDefinition

	^self selectedApplication definitionNamed: (searchValues at: 'form-definition')! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/31/2016 16:06'!
selectedProcessDefinition

	^BpmProcessDefinition getAllProcessesNamed: self getProcessType in: self getSelectedApplication! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 12:48'!
sewafTableForProcessAssignments

	^(SewafSelectTableReport parent: self)
		summary: 'Process Assignments';
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #creationDate title: ('Creation Date' translateFor: self session user));
						add: (SewafReportColumn selector: #assignationDate title: ('Assigned Date' translateFor: self session user));
						add: (SewafReportColumn selector: #printUserName title: ('Responsible' translateFor: self session user));
						add: (SewafReportColumn selector: #taskEndDate title: ('End Date' translateFor: self session user));
						add: (SewafReportColumn selector: #getRoleName title: ('Role' translateFor: self session user));
						add: self createFilledFormsColumn;
						yourself);
		rowColors: #(white white);
		selectedObject: selectedObject;
		rowPeriod: 1;
		yourself! !

!WAOrbeonRadarProcessComposite2 methodsFor: 'other' stamp: 'brunobb 12/15/2017 11:18'!
sewafTableForRunningFormProcesses

	^(SewafSelectTableReport parent: self)
		summary: 'Radar for Processes';
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #applicationName title: ('Application' translateFor: self session user) onClick: [:each | selectedObject := each]);
						add: (SewafReportColumn selector: #processName title: ('Name' translateFor: self session user));
						add: (SewafReportColumn selector: #processId title: ('Process Id' translateFor: self session user));
						add: (SewafReportColumn selector: #printRunningArtifacts title: ('Current Tasks' translateFor: self session user));
						add: (SewafReportColumn selector: #hasFinalized title: ('Finished' translateFor: self session user));
						add: (SewafReportColumn selector: #creatorName title: ('Creator' translateFor: self session user));
						add: (SewafReportColumn selector: #createdTime title: ('Creation Time' translateFor: self session user));
						add: (SewafReportColumn selector: #printCurrentRols title: ('Roles' translateFor: self session user));
						add: (SewafReportColumn selector: #stateName title: ('State' translateFor: self session user));
						yourself);
		rowColors: #(white white);
		selectedObject: selectedObject;
		rowPeriod: 1;
		yourself! !

WAOrbeonRadarComposite2 subclass: #WAOrbeonRadarUserComposite2
	instanceVariableNames: 'usersBatchedList listType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/13/2016 10:59'!
assignUserTo: aBpmTaskAssignment

	"another user could be take the process already"
	aBpmTaskAssignment checkIfIsStillAvailableToTake
	ifFalse: [^self canNotTakeAssignment: aBpmTaskAssignment]. 

	selectedObject take: aBpmTaskAssignment.

	self closeAllInformationComponents.
	(self getTableNamed: 'Tasks' ifAbsent: [^self]) 
		information: ('Task Assigned !!!!!!' translateFor: self session user)
		color: 'green'.! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/13/2016 11:03'!
assignUserTo: aBpmTaskAssignment value: aBoolean
	"1- Create an aBpmTaskAssignment.
	2- Add the new assignment of 1) to process <anBpmProcessInstance>.
	3- Associate the Assignment with the Process.
	4- The user <aBpmUser> take the assignment <aBpmTaskAssignment>"

	aBoolean ifFalse: [^self].

	(listType = 'Current Tasks') ifTrue: [^self  unassignUserFrom: aBpmTaskAssignment].

	(listType = 'Possible Tasks') ifTrue: [^self assignUserTo: aBpmTaskAssignment].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/01/2016 14:18'!
buttonLabel

	(listType = 'Possible Tasks') ifTrue: [^'Take Task'].

	(listType = 'Current Tasks') ifTrue: [^'Untake Task'].

	^''! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/13/2016 10:34'!
canNotTakeAssignment: aBpmTaskAssignment

	self closeAllInformationComponents.
	(self getTableNamed: 'Tasks' ifAbsent: [^self]) 
		information: ('The Task has been already Taken by other user !!!!!!' translateFor: self session user)
		color: 'red'.! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 07:29'!
columnsForUsers

	^OrderedCollection new  
			add: ((SewafReportColumn 
						selector: #username 
						title: ('Username' translateFor: self session user) 
						onClick: [:each | selectedObject := each])
						beSortable
						beSearchable;
						sortBlock: [:a :b | a username <= b username]);
			add: (SewafReportColumn 
						selector: #isAdmin 
						title: ('Admin?' translateFor: self session user));
						yourself;
			yourself! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/01/2016 14:12'!
elements

	^ #('Current Tasks' 'Possible Tasks' 'Finished Tasks')! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
getProcessWithFreeTransitions

	^selectedObject getAllAvailableTaskAssignments! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 05/30/2016 10:28'!
getSelectedUserAssignments

	^selectedObject getCurrentAssigments asOrderedCollection! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/01/2016 14:19'!
getSelectedUserFinishedAssignments

	^selectedObject getFinishedAssigments asOrderedCollection! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/01/2016 14:19'!
getTransitionList

	(listType = 'Possible Tasks') ifTrue: [^self getProcessWithFreeTransitions].

	(listType = 'Current Tasks') ifTrue: [^self getSelectedUserAssignments].

	^self getSelectedUserFinishedAssignments! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'monitor_users.html'! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 07:01'!
initialize

	super initialize.

	listType := 'Current Tasks'.

	self setShowToElementNamed: 'search-area'.

	usersBatchedList := SewafBatchedList parentComponent: self.

	usersBatchedList batchSize: self session user regularListPagingSize;
		navigationCssClass: 'batch-div-bottom';
		isBottomBatch: true.! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/13/2016 10:39'!
initializeSewafTableForTasks
	| table |

	table := (SewafBooleanSelectTable parent: self)
		summary: 'Free Processes';
		backcolor: self session user userOptions getBooleanTableBackcolor;
		"buttonTitle: ('Perform Action' translateFor: self session user);"
		booleanSelector: #isAssignedToProcess:;
		callbackSelector: #assignUserTo:value:;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #processId title: ('Process Id' translateFor: self session user));
						add: (SewafReportColumn selector: #processName title: ('Process Name' translateFor: self session user));
						add: (SewafReportColumn selector: #printRunningArtifacts title: ('Current Tasks' translateFor: self session user));
						add: (SewafReportColumn selector: #printCurrentRols title: ('Roles' translateFor: self session user));
						add: (SewafReportColumn selector: #creatorName title: ('Creator' translateFor: self session user));
						add: (SewafReportColumn selector: #assignedUserNames title: ('Assigned Users' translateFor: self session user));
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'Tasks'.! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 07:45'!
initializeSewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (SewafSelectTableReport parent: self)
		summary: 'Users to Assign';
		selectedColor: self session user userOptions getSelectTableSelectedColor;
		nonSelectedColor: self session user userOptions getSelectTableNonSelectedColor;
		columns: self columnsForUsers;
		rowColors: #(white white);
		selectedObject: selectedObject;
		rowPeriod: 1;
		yourself.

	^self addSewafTable: table named: 'Users'.! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
isAssignedToProcess: anOrbeonFormUser

	^false! !

!WAOrbeonRadarUserComposite2 methodsFor: 'Accessing' stamp: 'BrunoBB 12/20/2015 14:54'!
listType

   "Return the value of the instance variable 'listType'."
   ^listType! !

!WAOrbeonRadarUserComposite2 methodsFor: 'Updating' stamp: 'BrunoBB 12/20/2015 14:54'!
listType: newValue

   "Modify the value of the instance variable 'listType'."
   listType := newValue! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/13/2016 10:29'!
onRadioButtonChanged: value

	listType := value.
	batchedList currentPage: 1.

	self closeAllInformationComponents.! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
onUsernameChanged: value

	searchValues at: 'username' put: value! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 06:59'!
renderContentOn: html

	html div id: 'top-search-area'; class: 'top-search-area-box-shadow'; 
		with: [self renderSearchOptionsOn: html].

	html div id: 'radar'; with: [
		html div id: 'radar-users'; class: 'default-gray-table ';
				with:[self renderUsersListOn: html].

		selectedObject ifNil: [^self].

		html div id: 'radar-processes-list'; class: 'default-gray-table ';
			with:[self renderTableWithTasksOn: html.]
	].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/02/2016 15:03'!
renderOptionListOn: html

	html radioGroup
		callback: [:value | self onRadioButtonChanged: value];
		selected: listType;
		with: [ :group |
			self elements do: [ :each |
				html label: [ 
					group radioButton onChange: 'submit()'; value: each.
					html text: each ].] ].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 01/09/2017 06:37'!
renderSearchOptionsOn: html

	self renderShowHideWindowIconOn: html. "show/hide search area"
	(self isEnabledToShowElementNamed: 'search-area') ifFalse: [^self].
	html form with: [ 
		html fieldSet with: [
			html legend class: 'top-search-legend'; with: ('Search Options' translateFor: self session user).
			html div class: 'top-search-div'; with: [
				html label attributeAt: 'for' put: 'username'; with: ('Username' translateFor: self session user).
				html textInput attributeAt: 'id' put: 'username';
					callback: [:value | self onUsernameChanged: value]; 
					with: (searchValues at: 'username' ifAbsent: ['']).
			].
			html div class: 'top-search-filters-two'; class: 'margin-top-20px float-left width-100px'; with: [self renderSubmitButtonOn: html].
			html div class: 'top-search-div'; class: 'margin-top-15px width-400px'; with: [self renderOptionListOn: html].
		].
	].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 05/30/2016 11:01'!
renderSubmitButtonOn: html

	html submitButton 
		callback: [self searchUsername]; with: ('Search' translateFor: self session user).! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/03/2016 15:49'!
renderTableWithTasksOn: html

	batchedList items: self getTransitionList.

	html render: (batchedList table: self sewafTableForUserTasks).! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 07:39'!
renderUsersListOn: html

	html render: (usersBatchedList table: self sewafTableForUsers).! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 07:33'!
searchBy: aSymbol

	usersBatchedList 
		items: (usersBatchedList items select: [:each |  | columnValue |
					columnValue := each perform: aSymbol.
					columnValue := (columnValue isKindOf: String) ifTrue: [columnValue] ifFalse:[columnValue printString].
					(self componentValueAt: 'searchValue') match: columnValue]).! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 07:39'!
searchUsername
	| username |

	selectedObject := nil.
	searchCollectionResult := OrderedCollection new.

	username := searchValues at: 'username' ifAbsent: ''.

	usersBatchedList items: (self session user getVisibleUsers select: [:each | username match: each username]).! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 12/20/2015 14:54'!
setRadioButton! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/12/2016 12:42'!
sewafTableForFinishedTasks

	^(SewafTableReport parent: self)
		summary: 'Free Processes';
		backcolor: self session user userOptions getTableReportBackcolor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #processId title: ('Process Id' translateFor: self session user));
						add: (SewafReportColumn selector: #processName title: ('Process Name' translateFor: self session user));
						add: (SewafReportColumn selector: #printRunningArtifacts title: ('Current Tasks' translateFor: self session user));
						add: (SewafReportColumn selector: #printCurrentRols title: ('Roles' translateFor: self session user));
						add: (SewafReportColumn selector: #creatorName title: ('Creator' translateFor: self session user));
						add: (SewafReportColumn selector: #assignedUserNames title: ('Assigned Users' translateFor: self session user));
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/13/2016 10:38'!
sewafTableForTasks
	| table |

	table := (self hasTableNamed: 'Tasks') 
		ifTrue: [self getTableNamed: 'Tasks' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForTasks].

	table buttonLabel: self buttonLabel.

	^table! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 07:26'!
sewafTableForUsers
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (self hasTableNamed: 'Users') 
		ifTrue: [self getTableNamed: 'Users' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForUsers].

	^table! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 06/03/2016 15:49'!
sewafTableForUserTasks

	listType = 'Finished Tasks' ifTrue: [
		batchedList navigationCssClass: 'batch-div-bottom'. "the finished tasks list does NOT have buttons --> the style is changed"
		^self sewafTableForFinishedTasks].

	batchedList navigationCssClass: 'batch-div-bottom-with-button'. "the following list does HAVE buttons --> the style is changed"

	(listType = 'Current Tasks') ifTrue: [^self sewafTableForTasks].

	(listType = 'Possible Tasks') ifTrue: [^self sewafTableForTasks].! !

!WAOrbeonRadarUserComposite2 methodsFor: 'other' stamp: 'BrunoBB 07/04/2016 07:41'!
sortColumn: sortBlock orderMode: aSymbol

	usersBatchedList items: ((aSymbol = #asc) 
		ifTrue: [(usersBatchedList items asSortedCollection: sortBlock) reverse] 
		ifFalse: [usersBatchedList items asSortedCollection: sortBlock]
	)! !

!WAOrbeonRadarUserComposite2 methodsFor: 'free transitions' stamp: 'BrunoBB 06/13/2016 11:03'!
unassignUserFrom: aBpmTaskAssignment
	"The receiver unassing the assignment <aBpmTaskAssignment> from the selected user <selectedObject>"

	aBpmTaskAssignment isTaken ifFalse: [
		self closeAllInformationComponents.
		^(self getTableNamed: 'Tasks' ifAbsent: [^self]) 
			information: ('The Task has been already untaken by the user !!!!!!' translateFor: self session user)
			color: 'red'.].

	selectedObject untake: aBpmTaskAssignment.

	self closeAllInformationComponents.
	(self getTableNamed: 'Tasks' ifAbsent: [^self]) 
		information: ('Task Unassigned !!!!!!' translateFor: self session user)
		color: 'green'.! !

!WAOrbeonRadarUserComposite2 methodsFor: 'Accessing' stamp: 'BrunoBB 07/04/2016 06:58'!
usersBatchedList
	^usersBatchedList! !

!WAOrbeonRadarUserComposite2 methodsFor: 'Updating' stamp: 'BrunoBB 07/04/2016 06:58'!
usersBatchedList: newValue
	usersBatchedList := newValue! !

SEWAFWebObjectComposite subclass: #WAServerConfigurationManager
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAServerConfigurationManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'server_setup.html'! !

!WAServerConfigurationManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:59'!
renderContentOn: html

	html div id: 'server-configuration'; class: 'centered-unique-form'; with: [
		self session user isBackofficeUserAndAdmin 
		ifTrue: [self renderServerConfigurationFormOn: html]
		ifFalse: [self renderServerConfigurationViewOn: html].
	]! !

!WAServerConfigurationManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:59'!
renderServerConfigurationFormOn: html

	html form with: [
		html fieldSet with:[
			html legend with: [html strong: ('Servers Configuration' translateFor: self session user)].
					self renderServerConfigurationSettingOn: html.
					].
				].! !

!WAServerConfigurationManager methodsFor: 'other' stamp: 'brunobb 07/27/2017 13:00'!
renderServerConfigurationSettingOn: html

	html label attributeAt: 'for' put: 'databaseIP'; with: ('Database IP' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'databaseIP'; 
			callback: [:value | self getOrbeonDatabaseConfiguration databaseIP: value]; 
			with: self getOrbeonDatabaseConfiguration databaseIP.
	html label attributeAt: 'for' put: 'databaseUser'; with: ('Database User' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'databaseUser'; 
			callback: [:value | self getOrbeonDatabaseConfiguration databaseUser: value]; 
			with: self getOrbeonDatabaseConfiguration databaseUser.
	html label attributeAt: 'for' put: 'databasePassword'; with: ('Database Password' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'databasePassword'; 
			callback: [:value | self getOrbeonDatabaseConfiguration databasePassword: value]; 
			with: self getOrbeonDatabaseConfiguration databasePassword.
	html label attributeAt: 'for' put: 'orbeonIP'; with: ('Orbeon IP' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'orbeonIP'; 
			callback: [:value | self getOrbeonWebServerConfiguration orbeonIP: value]; 
			with: self getOrbeonWebServerConfiguration orbeonIP.
	html label attributeAt: 'for' put: 'gemstoneIP'; with: ('GemStone/S IP' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'gemstoneIP'; 
			callback: [:value | self getGemStoneServerConfiguration gemstoneIP: value]; 
			with: self getGemStoneServerConfiguration gemstoneIP.
	html label attributeAt: 'for' put: 'baseUrl'; with: ('URL Base Documentation' translateFor: self session user).
	html textInput attributeAt: 'id' put: 'baseUrl'; 
			callback: [:value | self getGemStoneServerConfiguration baseUrlDocumentation: value]; 
			with: self getGemStoneServerConfiguration baseUrlDocumentation.
	html submitButton callback: [self savePreferences]; with: ('Save Preferences' translateFor: self session user).! !

!WAServerConfigurationManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:59'!
renderServerConfigurationViewOn: html

	html label with: 'Database IP'.
	html textInput 
		callback: [:value | self getOrbeonDatabaseConfiguration databaseIP: value]; 
		readonly: true; 
		with: self getOrbeonDatabaseConfiguration databaseIP.
	html label with: 'Database User'.
	html textInput 
		callback: [:value | self getOrbeonDatabaseConfiguration databaseUser: value]; 
		readonly: true; 
		with: self getOrbeonDatabaseConfiguration databaseUser.
	html label with: 'Database Password'.
	html textInput 
		callback: [:value | self getOrbeonDatabaseConfiguration databasePassword: value]; 
		readonly: true; 
		with: self getOrbeonDatabaseConfiguration databasePassword.
	html label with: 'Orbeon IP'.
	html textInput 
		callback: [:value | self getOrbeonWebServerConfiguration orbeonIP: value]; 
		readonly: true; 
		with: self getOrbeonWebServerConfiguration orbeonIP.
	html label with: 'GemStone/S IP'.
	html textInput 
		callback: [:value | self getGemStoneServerConfiguration gemstoneIP: value]; 
		readonly: true; 
		with: self getGemStoneServerConfiguration gemstoneIP.! !

!WAServerConfigurationManager methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:59'!
savePreferences! !

SEWAFWebObjectComposite subclass: #WAUserAndRolesExportBrowser
	instanceVariableNames: 'exportedDataBatchList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 10:14'!
downloadSystemRoleStructure

	self requestContext respond: [:response | 
        response document: ((self session user printSystemRoleStructure asByteArray seasideMimeDocument) 
										mimeType: 'application/csv'; 
										fileName: 'configuration.csv'; 
										yourself).
	].! !

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'export_users_&_roles.html'! !

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 16:58'!
initialize

	super initialize.

	self initializeBatchedLists.! !

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 16:58'!
initializeBatchedLists

	exportedDataBatchList := SewafBatchedList parentComponent: self.
	exportedDataBatchList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 16:32'!
initializeSewafTableForGrantConfiguration
	| table |

	table := (SewafTableReport summary: 'GrantConfigurartion')
		"rows: selectedUser roles; "
		backcolor: self session user userOptions getTableReportBackcolor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #applicationName title: 'Application');
						add: (SewafReportColumn selector: #applicationType title: 'Type');
						add: (SewafReportColumn selector: #username title: 'Username');
						add: (SewafReportColumn selector: #roleName title: 'Role');
						add: (SewafReportColumn selector: #roleType title: 'Role Type');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	self addSewafTable: table named: 'GrantConfigurartion'.
	^table! !

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 10:15'!
renderContentOn: html

	html div id: 'imported-data'; class: 'padding-top-1px'; with: [
			html div class: 'default-gray-table float-left';
				with:[exportedDataBatchList items: (self componentValueAt: 'organization' ifAbsent: [self addValue: self session user getSystemRoleStructure named: 'organization'.]).
						html render:  (exportedDataBatchList table: self initializeSewafTableForGrantConfiguration).].
		].

	html div with: [self renderCSVDownloadOn: html].! !

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 17:54'!
renderCSVDownloadOn: html

	html div class: 'centered-unique-form float-left';
		with: [
				html form multipart; 
					class: 'height180';
					with: [
						html fieldSet with:[
							html legend with: [html strong: ('Import Users & Roles from CSV file' translateFor: self session user)].
							self renderHelpOn: html.
							self renderDownloadComponentOn: html.]]].! !

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'BrunoBB 07/23/2016 16:25'!
renderDownloadComponentOn: html

	html submitButton class: 'display-block';
			callback: [self downloadSystemRoleStructure.]; 
			with: ('Download System Role Configuration' translateFor: self session user).! !

!WAUserAndRolesExportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 17:34'!
renderHelpOn: html

	html div class: 'import-csv-info';
		with: [html output: 'All Role''s Grants are grouped by Applicaton.'. html break.
				html output: 'The CSV format is the same as the Import Process'. html break.].

	html break.! !

SEWAFWebObjectComposite subclass: #WAUserAndRolesImportBrowser
	instanceVariableNames: 'importedDataBatchList importedConfigurationBatchList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 09/03/2016 12:15'!
applyImportedConfiguration

	importedConfigurationBatchList items do: [:each | each applyConfiguration].

	self sewafTableForGrantConfiguration information: 'The Configuration has been imported !!' color: 'green'.! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'import_users_&_roles.html'! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 09/03/2016 10:45'!
importConfiguration
	"The receiver iterate over instance variable <componentValues>. <eachRow> is line where values are separated by ';'.
	1- application name, 2- application type, 3- role name, 4- role type, 5- user name"
	| configurations application |

	configurations := OrderedCollection new.
	componentValues do: [:eachRow | | csvData app appType user role roleType |
		csvData := eachRow subStrings: ';'.
		app := (csvData at: 1) trimBlanks.
		appType := (csvData at: 2) trimBlanks.
		role := (csvData at: 3) trimBlanks.
		roleType := (csvData at: 4) trimBlanks.
		user := (csvData at: 5) trimBlanks.
		application := ((appType = 'O') ifTrue: [OrbeonApplication] ifFalse: [BpmApplication]) newNamed: app. 
		[application addToCache] on: Exception do: [:ex | ].

		configurations add: 
			(BpmUserGrantConfiguration 
				for: (BpmUser getExistingOrNewUserNamed: user)
				app: application
				role: (((roleType = 'F') ifTrue: [BpmFrontOfficeRole] ifFalse: [BpmBackofficeRole]) createNewOrGetExisting: role in: app)
			).
		].
	importedConfigurationBatchList items: configurations.

	"configurations do: [:each | each applyConfiguration]"! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 09/03/2016 12:09'!
importCSVString: csvString
	"The receiver separate the contents of <csvString> by String lf.  
	And each line is put as aString in <componentValues> variable.
	key: 1 value: first line, key: n value: line n
	Each line is separated by ';' "
	| rows |

	self initializeComponentValues.
	rows := csvString subStrings: String lf.
	(rows size = 1) ifTrue: [^self sewafTableForImportedData information: 'Wrong File Format' color: 'red'].
	"first row are titles"
	"where <key> is a counter (1,2,3,..,n) and <eachRow> is a string of values separated by ; 
	(application; application type; role; username)"
	(rows allButFirst reject: [:each | each trimBlanks isEmpty])  
		keysAndValuesDo: [:key :eachRow | | csvValues |
			csvValues := eachRow subStrings: ';'.
			(csvValues size = 5)
			ifTrue: [self addValue: eachRow named: key]
			ifFalse: [self initializeComponentValues.
				^self sewafTableForImportedData information: 'Wrong File Format' color: 'red'].
		].

	self sewafTableForImportedData information: 'File Processed' color: 'green'.
	importedConfigurationBatchList items: OrderedCollection new! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 12:38'!
initialize

	super initialize.

	self initializeBatchedLists.! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 13:11'!
initializeBatchedLists

	importedDataBatchList := SewafBatchedList parentComponent: self.
	importedDataBatchList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.

	importedConfigurationBatchList := SewafBatchedList parentComponent: self.
	importedConfigurationBatchList batchSize: self session user regularListPagingSize;
		isBottomBatch: true;
		navigationCssClass: 'batch-div-bottom'.! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 13:42'!
initializeSewafTableForGrantConfiguration
	| table |

	table := (SewafTableReport summary: 'GrantConfigurartion')
		"rows: selectedUser roles; "
		backcolor: self session user userOptions getTableReportBackcolor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #applicationName title: 'Application');
						add: (SewafReportColumn selector: #applicationType title: 'Type');
						add: (SewafReportColumn selector: #username title: 'Username');
						add: (SewafReportColumn selector: #roleName title: 'Role');
						add: (SewafReportColumn selector: #roleType title: 'Role Type');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	self addSewafTable: table named: 'GrantConfigurartion'.
	^table! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 12:46'!
initializeSewafTableForImportedData
	| table |

	table := (SewafTableReport summary: 'ImportedData')
		"rows: selectedUser roles; "
		backcolor: self session user userOptions getTableReportBackcolor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #printString title: 'Data');
						yourself);
		rowColors: #(white white);
		rowPeriod: 1;
		yourself.

	self addSewafTable: table named: 'ImportedData'.
	^table! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/19/2016 12:15'!
receiveFile: aFile
	"The receiver store the file <aFile> temporary directory -temp-"
    | stream |

    stream := (FileDirectory default directoryNamed: 'tmp') "create the temporary file"
        assureExistence;
        forceNewFileNamed: aFile fileName.
    [ stream binary; nextPutAll: aFile rawContents ]  "push contents"
        ensure: [ stream close ].

	self importCSVString: aFile rawContents asString.! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 10:14'!
renderApplyImportedDataOn: html

	importedConfigurationBatchList items notEmpty
	ifTrue: [
		html submitButton 
				callback: [self applyImportedConfiguration]; 
				with: ('3. Apply Configuration' translateFor: self session user).
	].! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 09/03/2016 12:42'!
renderContentOn: html

	self renderCSVUploadOn: html.

	html div id: 'imported-data'; class: 'padding-top-1px width-70per float-right'; with: [
			html div class: 'default-gray-table float-left width-25per';
				with:[importedDataBatchList items: componentValues asOrderedCollection.
						html render:  (importedDataBatchList table: self sewafTableForImportedData).].
			html div class: 'default-gray-table float-right width-75per';
							with:["importedConfigurationBatchList items: configurations."
									html render:  (importedConfigurationBatchList table: self sewafTableForGrantConfiguration).]
		].! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 09/03/2016 12:40'!
renderCSVUploadOn: html

	html div class: 'centered-unique-form float-left width-28per';
		with: [
				html form multipart; 
					class: 'height350';
					with: [
						html fieldSet with:[
							html legend with: [html strong: ('Import Users & Roles from CSV file' translateFor: self session user)].
							self renderHelpOn: html.
							self renderUploadComponentOn: html.
							self renderProcessDataOn: html.
							self renderApplyImportedDataOn: html.]]].! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 09/01/2016 09:07'!
renderHelpOn: html

	html div class: 'import-csv-info';
		with: [html output: 'All names are case sensitive.'. html break.
				html output: 'The CSV format is: '. html break.
				html output: 'Application Name; Application Type; Role; Role Type;Username.'. html break.
				html output: 'For more import information go to the manual (click help "O" on top right). '. html break.].

	html break.! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 10:14'!
renderProcessDataOn: html

	componentValues notEmpty
	ifTrue: [
		html submitButton class: 'display-block';
				callback: [self importConfiguration]; 
				with: ('2. Import Configuration' translateFor: self session user).
	].! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 06/20/2016 10:14'!
renderUploadComponentOn: html

	html label attributeAt: 'for' put: 'selectFile'; with: ('Select CSV File' translateFor: self session user).
	html fileUpload attributeAt: 'id' put: 'selectFile'; 
		callback: [ :value | self receiveFile: value]. "the user upload the CSV file"
	html submitButton: '1. View File'! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 09/03/2016 11:31'!
sewafTableForGrantConfiguration
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (self hasTableNamed: 'GrantConfigurartion') 
		ifTrue: [self getTableNamed: 'GrantConfigurartion' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForGrantConfiguration].

	^table! !

!WAUserAndRolesImportBrowser methodsFor: 'other' stamp: 'BrunoBB 09/03/2016 11:30'!
sewafTableForImportedData
	"Table with all Users that are NOT present in the role <selectedObject> "
	| table |

	table := (self hasTableNamed: 'ImportedData') 
		ifTrue: [self getTableNamed: 'ImportedData' ifAbsent: []] 
		ifFalse: [self initializeSewafTableForImportedData].

	^table! !

SEWAFWebObjectComposite subclass: #WAXpdlImporterBrowser
	instanceVariableNames: 'orbeonApplications orbeonApplication upload processNode reader numberOfProcess uploadProcesses selectedUploads processesNames fileFormats invalidFormatError packageFile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAXpdlImporterBrowser commentStamp: '' prior: 0!
<numberOfProcess> hold the numbers of processes to be uploaded. If the value is 4 --> could be 2 processes already uploaded and 2 empty forms!

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/09/2015 10:23'!
addNewProcessForm

	numberOfProcess := numberOfProcess + 1.! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'BrunoBB 12/09/2015 10:23'!
checkFilesFormatOf: pathFileArray

	pathFileArray do: [:eachPathFile | | file contents |
		file := FileStream fileNamed: eachPathFile.
		contents := file contents.
		file close.
		[XMLDOMParser parse: contents] 
			on: Error 
			do: [:err | fileFormats at: (eachPathFile subStrings: '/') last put: err description.]].

	^fileFormats isEmpty! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'BrunoBB 08/30/2016 14:08'!
createBpmProcessDefinitionFrom: aBpmProcessGenerator
	| messages subMenu processes topProcesses |

	"create the BpmProcessDefinition"
	processes := (aBpmProcessGenerator generateAllProcess collect: [:each | each addToCache]) asArray.
	topProcesses := processes select: [:each | each isTopProcess].
	topProcesses ifEmpty: [^self].
	"redirect from the current page the process definition page"
	messages := OrderedCollection new.

	subMenu := mainPanel selectSubTabNamed: 'List Processes Definitions' inMenu: 'Processes' ifNone: [^nil].

	messages 
		add: (MessageSend receiver: mainPanel selector: #openDefinitionsManager);
		add: (MessageSend receiver: mainPanel selector: #setSearchApplied);
		add: (MessageSend receiver: mainPanel selector: #lateralCollection: arguments: (Array with: topProcesses));
		add: (MessageSend receiver: mainPanel selector: #searchResult: arguments: (Array with: topProcesses));
		add: (MessageSend receiver: mainPanel selector: #selectedLateralItem: argument: topProcesses first).

	subMenu addMessagesToSend: messages.! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 11:50'!
fileFormats
	^fileFormats! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 11:50'!
fileFormats: newValue
	fileFormats := newValue! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'brunobb 10/15/2017 20:19'!
generateMapperDictionary
	| dictionary |

	dictionary := Dictionary new.

	selectedUploads keysAndValuesDo: [:index :xpdlFileName |
		dictionary at: xpdlFileName put: (self getApplicationManagerClass getAnyApplicationNamed: (uploadProcesses at: index)).
	].

	^dictionary! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'brunobb 10/15/2017 20:17'!
getApplicationFor: xpdlPackage
	| appName |

	appName := (uploadProcesses at: (selectedUploads keyAtValue: xpdlPackage fileName ifAbsent: [Error signal])).

	^self getApplicationManagerClass getAnyApplicationNamed: appName! !

!WAXpdlImporterBrowser methodsFor: 'other' stamp: 'brunobb 07/27/2017 06:10'!
gitbookUrl

	^self getGemStoneServerConfiguration baseUrlDocumentation, 'define_new_process.html'! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'BrunoBB 04/10/2016 15:29'!
importBizagiFiles
	| appDictionary fileArray generator |

	appDictionary := Dictionary new.
	fileArray := OrderedCollection new.

	1 to: numberOfProcess do: [:index | | fileName shortName |
		fileName := selectedUploads at: index.
		shortName := fileName allButLast: (FileDirectory extensionFor: fileName) size + 1.
		appDictionary at: shortName put: (uploadProcesses at: index).
		fileArray add: ((FileDirectory default directoryNamed: 'tmp') pathName, '/', fileName)].

	(self checkFilesFormatOf: fileArray) ifFalse: [^self].
	"ERROR handler"
	reader := XPDLReader2 forFiles: fileArray asArray.

	generator := BpmProcessGenerator on: reader xpdlPackages.

	generator xpdlPackages do: [:eachPackage | 
		eachPackage pools do: [:eachPool | 
			generator mapProcess: eachPool getName toApplication: (self getApplicationFor: eachPackage).
		].
	].

	reader getImportWarningReportWith: self generateMapperDictionary.

	"If false (no warnings) -> the processes definition are created and stored"
	reader hasWarnings ifFalse: [^self createBpmProcessDefinitionFrom: generator].

	self show: ((WABizagiImportReport parent: self)
						warnings: reader importReport;
						yourself).! !

!WAXpdlImporterBrowser methodsFor: 'other' stamp: 'BrunoBB 12/01/2016 07:42'!
initialize

	super initialize.

	numberOfProcess := 1. "hold the numbers of processes to be uploaded. If the value is 4 --> could be 2 processes already uploaded and 2 empty forms"

	"these two instances variables only hold data of uploaded processes"
	uploadProcesses := Dictionary new. "the <key> is the index (1,2,3,4,...) of the process and <value> is the name of the application"
	selectedUploads := Dictionary new. "the <key> is the index (1,2,3,4,...) of the process and <value> is the name of the XPDL file"

	"processesNames := Dictionary new."

	fileFormats := Dictionary new. "to check if files are well formated"! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 11:50'!
invalidFormatError
	^invalidFormatError! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 11:50'!
invalidFormatError: newValue
	invalidFormatError := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
numberOfProcess
	^numberOfProcess! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
numberOfProcess: newValue
	numberOfProcess := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
orbeonApplication
	^orbeonApplication! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
orbeonApplication: newValue
	orbeonApplication := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
orbeonApplications
	^orbeonApplications! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
orbeonApplications: newValue
	orbeonApplications := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 11:50'!
packageFile
	^packageFile! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 11:50'!
packageFile: newValue
	packageFile := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
processesNames
	^processesNames! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
processesNames: newValue
	processesNames := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
processNode
	^processNode! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
processNode: newValue
	processNode := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
reader
	^reader! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
reader: newValue
	reader := newValue! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/09/2015 11:46'!
receiveFile: aFile index: index
	"The receiver store the file <aFile> temporary directory -temp- and add the file name of <aFile> at collection <selectedUploads> index <index>"
    | stream |

    stream := (FileDirectory default directoryNamed: 'tmp') "create the temporary file"
        assureExistence;
        forceNewFileNamed: aFile fileName.
    [ stream binary; nextPutAll: aFile rawContents ]  "push contents"
        ensure: [ stream close ].

	selectedUploads at: index put: aFile fileName. "map index with fileName"! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/02/2016 03:36'!
removeImportProcessForm

	uploadProcesses removeKey: numberOfProcess ifAbsent: [].
	selectedUploads removeKey: numberOfProcess ifAbsent: [].

	(numberOfProcess > 1) ifTrue: [numberOfProcess := numberOfProcess - 1].! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/09/2015 10:23'!
renderAddNewImportFormButtonOn: html

	html anchor callback: [self addNewProcessForm];
					with: [html image url: (SEWAFIconLibrary / #textplusiconPng); 
								altText: ('Add New Import Process Form' translateFor: self session user); 
								title: ('Add New Import Process Form' translateFor: self session user)].! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/01/2016 07:44'!
renderContentOn: html

	html div id: 'import-forms'; with: [
		1 to: numberOfProcess do: [:index |
			self renderFormToUploadProcessOn: html index: index].

		html div id: 'add-new-import-form';
			with: [html div id: 'add-new-form-button'; with: [self renderAddNewImportFormButtonOn: html].
					html div id: 'remove-new-form-button'; with: [self renderRemoveImportFormButtonOn: html].
					self renderImportAllButtonOn: html].

	]! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/01/2016 09:11'!
renderEmptyUploadFormOn: html index: index
	| appId |

	appId := 'orbeonApp-', index printString.

	html div class: 'centered-unique-form float-left';
		with: [
				html form multipart; 
					"class: 'height300';"
					with: [
						html fieldSet with:[
							html legend with: [html strong: ('XPDL Upload Form' translateFor: self session user)].
							html label attributeAt: 'for' put: appId; with: ('Application' translateFor: self session user).
							html select list: (#('-'), (orbeonApplications collect: [:each | each applicationName])) asSortedCollection; 
								attributeAt: 'id' put: appId;
								title: ('Available Form Applications' translateFor: self session user);
								onChange: 'submit()';
								callback: [:value | uploadProcesses at: index put: value ];
								selected: (uploadProcesses at: index ifAbsent: [nil]).
							self renderUploadComponentOn: html index: index]]].! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/01/2016 09:03'!
renderFormToUploadProcessOn: html index: index
	"The receiver render a form to upload a XPDL process with index <index>"

	(index > selectedUploads size)
	ifTrue: [self renderEmptyUploadFormOn: html index: index]
	ifFalse: [self renderInformationFormOn: html index: index]! !

!WAXpdlImporterBrowser methodsFor: 'import' stamp: 'BrunoBB 09/01/2016 14:28'!
renderImportAllButtonOn: html
	| cssClass jQueryId |

	jQueryId := self renderJQueryInformationDialogOn: html title: 'BPM Process' information: ('XPDL import is about to start. If succeed the imported Process/es Definition/s will be shown. If fail an error report will be shown.' translateFor: self session user) buttonLabel: ('Proceed' translateFor: self session user) actionMethod: #importBizagiFiles.
	cssClass := (numberOfProcess = 1) ifTrue: ['import-all-button-1'] ifFalse: ['import-all-button-2'].

	html div class: cssClass; with: [
		(selectedUploads size = numberOfProcess) ifFalse: [^self].
					html anchor 
						class: 'cursor-pointer';
						onClick: (html jQuery id: jQueryId) dialog open;
						"callback: [self importBizagiFiles];"
						with: [html image url: (SEWAFFileLibrary / #actionsdocumentsaveasiconPng); 
								altText: ('Import All Files' translateFor: self session user); 
								title: ('Import All Files' translateFor: self session user)].
	]! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/02/2016 04:08'!
renderInformationFormOn: html index: index
	| appId fileId |

	appId := 'orbeonApp-', index printString.
	fileId := 'fileName-', index printString.

	html div class: 'information-xpdl-import float-left';
		with: [
				html div with: [
					html output with: [html strong: ('Uploaded File' translateFor: self session user)].
				].
				html div class: 'margin-top-10px'; with: [
					html span with: [html strong: ('Application:' translateFor: self session user)].
					html output: (uploadProcesses at: index ifAbsent: [nil]).
				].
				html div class: 'margin-top-10px'; with: [
					html span with: [html strong: ('FileName:' translateFor: self session user)].
					html output: (selectedUploads at: index ifAbsent: [nil]).
				].
		].! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 12/02/2016 04:03'!
renderRemoveImportFormButtonOn: html

	"at least one import form has to be rendered"
	((selectedUploads size > 0) or: [numberOfProcess > 1]) ifFalse: [^self]. 

	html anchor callback: [self removeImportProcessForm];
					with: [html image url: (SEWAFIconLibrary / #delete132Png); 
								altText: ('Remove Import Process Form' translateFor: self session user); 
								title: ('Remove Import Process Form' translateFor: self session user)].! !

!WAXpdlImporterBrowser methodsFor: 'upload' stamp: 'BrunoBB 03/26/2016 09:53'!
renderUploadComponentOn: html index: index

	((index ~= 1) and: [(selectedUploads includesKey: index - 1) not]) ifTrue: [^self]. "the previous file was NOT uploaded"

	(selectedUploads includesKey: index)
	ifFalse: [
		html label attributeAt: 'for' put: 'selectFile'; with: ('Select File' translateFor: self session user).
		html fileUpload attributeAt: 'id' put: 'selectFile'; 
			callback: [ :value | self receiveFile: value index: index]. "the user upload the XPDL file"
		html submitButton: ('Send File [' translateFor: self session user), index printString, ']']
	ifTrue:[html strong with: [html paragraph with: (selectedUploads at: index)].
			(fileFormats includesKey: (selectedUploads at: index)) "file format error"
			ifTrue: [html paragraph class: 'error-text';
				with: (fileFormats at: (selectedUploads at: index))].
			invalidFormatError notNil ifTrue: [html paragraph class: 'error-text'; with: invalidFormatError].
	].! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
selectedUploads
	^selectedUploads! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
selectedUploads: newValue
	selectedUploads := newValue! !

!WAXpdlImporterBrowser methodsFor: 'other' stamp: 'BrunoBB 06/12/2016 12:42'!
sewafImportReportTable: anOrderedCollection

	^(SewafTableReport summary: 'XPDL Import Report')
		rows: anOrderedCollection; "get collection elements"
		backcolor: self session user userOptions getTableReportBackcolor;
		columns: (OrderedCollection new  
						add: (SewafReportColumn selector: #type title: 'Type');
						add: (SewafReportColumn selector: #title title: 'Title');
						add: (SewafReportColumn selector: #description title: 'Description');
						yourself);
		rowColors: #(white lightgray);
		rowPeriod: 1;
		yourself! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 12/09/2015 10:23'!
upload
	^upload! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 12/09/2015 10:23'!
upload: newValue
	upload := newValue! !

!WAXpdlImporterBrowser methodsFor: 'Accessing' stamp: 'BrunoBB 01/21/2016 11:50'!
uploadProcesses
	^uploadProcesses! !

!WAXpdlImporterBrowser methodsFor: 'Updating' stamp: 'BrunoBB 01/21/2016 11:50'!
uploadProcesses: newValue
	uploadProcesses := newValue! !

SEWAFApplicationPortal subclass: #WAProcessBackofficePortal
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBPMWebBackoffice'!

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 07/21/2016 10:23'!
applicationIcon

	^SEWAFIconLibrary / #applicationsettings32Png! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 06/27/2015 09:32'!
applicationName

	^'Flow Backoffice'! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/19/2016 17:44'!
exportUsersAndRoles

	(arena isKindOf: WAUserAndRolesExportBrowser)
	ifTrue: [^arena].

	^WAUserAndRolesExportBrowser parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 03/14/2016 10:35'!
getDefinitionCollection

	^self session user getAllProcessDefinition! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/19/2016 17:44'!
importUsersAndRoles

	(arena isKindOf: WAUserAndRolesImportBrowser)
	ifTrue: [^arena].

	^WAUserAndRolesImportBrowser parent: self! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 06/05/2015 06:17'!
initialize

	super initialize.

	self initializeNavigation.! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'brunobb 11/05/2017 13:42'!
initializeNavigation
	| subMenu1 subMenu2 subMenu3 subMenu4 subMenu5 |

	navigation := SewafPortalMenu new iconLibrary: SEWAFIconLibrary.
	subMenu1 := (SewafSubMenuItem label: 'Processes' icon: #process32Png)
		set24Icon: #process24Png;
		addItem: (SewafCommandItem label: 'List Processes Definitions' command: #openDefinitionsManager);
		addItem: (SewafCommandItem label: 'Define New Process' command: #openBizagiManager);
		addItem: (SewafCommandItem label: 'Monitor Processes' command: #openProcessRadar);
		addItem: (SewafCommandItem label: 'Process Categories' command: #openProcessCategoryManager);
		yourself.
	subMenu2 := (SewafSubMenuItem label: 'Applications' icon: #forms32Png)
		set24Icon: #forms24Png;
		addItem: (SewafCommandItem label: 'Manage Applications' command: #openApplicationManager);
		addItem: (SewafCommandItem label: 'Available Orbeon Forms' command: #openFormManager);
		yourself.
	"only backoffice global admin can manage calendar (which are global to all applications)"
	self session user isBackofficeUserAndAdmin ifTrue: [subMenu2 addItem: (SewafCommandItem label: 'Manage Calendars' command: #openCalendarManager)].
	subMenu3 := (SewafSubMenuItem label: 'Users & Roles' icon: #usersettings32Png)
		set24Icon: #usersettings24Png;
		addItem: (SewafCommandItem label: 'Monitor Users' command: #openUsersRadar);
		addItem: (SewafCommandItem label: 'Manage Users' command: #openUsersManager);
		addItem: (SewafCommandItem label: 'Manage Roles' command: #openRolesManager);
		addItem: (SewafCommandItem label: 'Import' command: #importUsersAndRoles);
		addItem: (SewafCommandItem label: 'Export' command: #exportUsersAndRoles);
		yourself.
	subMenu4 := (SewafSubMenuItem label: 'Charts' icon: #chart32Png)
		set24Icon: #chart24Png;
		addItem: (SewafCommandItem label: 'Global Charts' command: #openGlobalCharts);
		addItem: (SewafCommandItem label: 'Applications Charts' command: #openBpmApplicationsCharts);
		addItem: (SewafCommandItem label: 'Processes Charts' command: #openBpmProcessCharts);
		addItem: (SewafCommandItem label: 'Roles Charts' command: #openBpmRoleCharts);
		addItem: (SewafCommandItem label: 'Users Charts' command: #openBpmUserCharts);
		addItem: (SewafCommandItem label: 'Charts Repository' command: #openBpmChartsRepository);
		yourself.
	subMenu5 := (SewafSubMenuItem label: 'Configuration' icon: #homeserver32Png)
		set24Icon: #homeserver24Png;
		addItem: (SewafCommandItem label: 'User Preferences' command: #showUserPreferences);
		addItem: (SewafCommandItem label: 'Server Setup' command: #openServerSetup);
		addItem: (SewafCommandItem label: 'Login Mode' command: #openLoginMode);
		addItem: (SewafCommandItem label: 'Change Password' command: #openChangePassword);
		addItem: (SewafCommandItem label: 'Set Language' command: #openLanguageConfiguration);
		addItem: (SewafCommandItem label: 'Internationalization' command: #openInternationalizationManager);
		yourself.
	navigation addItem: subMenu2;
		addItem: subMenu1;
		addItem: subMenu3;
		addItem: subMenu4;
		addItem: subMenu5.! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 08/12/2016 08:39'!
isBackoffice

	^true! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 16:11'!
lateralCollection: aCollection

	arena ifNotNil: [arena lateralCollection: aCollection].! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 02/03/2016 09:43'!
logout

	self session logout.	
	self session unregister.
	self requestContext redirectTo: (self getGemStoneServerConfiguration gemstoneIP, '/orbeonBackoffice')! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 08/31/2016 10:08'!
openApplicationManager

	(arena isKindOf: WABpmApplicationBrowser)
	ifTrue: [^arena].

	^WABpmApplicationBrowser parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 03/05/2016 09:50'!
openBizagiManager

	(arena isKindOf: WAXpdlImporterBrowser)
	ifTrue: [^arena].

	^WAXpdlImporterBrowser new orbeonApplications: self session user getVisibleApplications.! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 11/01/2016 05:06'!
openBpmApplicationsCharts

	(arena isKindOf: WABpmApplicationChartComposite)
	ifTrue: [^arena].

	^WABpmApplicationChartComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 11/18/2016 09:19'!
openBpmChartsRepository

	(arena isKindOf: WABpmChartRepositoryComposite)
	ifTrue: [^arena].

	^WABpmChartRepositoryComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 11/01/2016 09:16'!
openBpmProcessCharts

	(arena isKindOf: WABpmProcessChartComposite)
	ifTrue: [^arena].

	^WABpmProcessChartComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 11/08/2016 07:19'!
openBpmRoleCharts

	(arena isKindOf: WABpmRoleChartComposite)
	ifTrue: [^arena].

	^WABpmRoleChartComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 11/08/2016 07:19'!
openBpmUserCharts

	(arena isKindOf: WABpmUserChartComposite)
	ifTrue: [^arena].

	^WABpmUserChartComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 02/07/2017 16:20'!
openCalendarManager

	(arena isKindOf: WABpmCalendarManager)
	ifTrue: [^arena].

	^WABpmCalendarManager parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/03/2016 05:55'!
openChangePassword

	(arena isKindOf: WAChangeUserPasswordComposite)
	ifTrue: [^arena].

	^WAChangeUserPasswordComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/18/2016 13:38'!
openDefinitionsManager
	| subComponent |

	(arena isKindOf: WAProcessDefinitionBrowser)
	ifTrue: [arena mode: #normal.
		^arena parent: self].

	subComponent := WAProcessDefinitionBrowser parent: self collection: self getDefinitionCollection.
	
	subComponent mode: #normal.

	^subComponent! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 03/15/2016 11:32'!
openFormManager

	(arena isKindOf: WAOrbeonFormsManager)
	ifTrue: [^arena].

	^WAOrbeonFormsManager parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 10/31/2016 08:55'!
openGlobalCharts

	(arena isKindOf: WABpmGlobalChartComposite)
	ifTrue: [^arena].

	^WABpmGlobalChartComposite parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/23/2015 13:30'!
openInternationalizationManager

	(arena isKindOf: WAInternationalizationManager)
	ifTrue: [^arena].

	^WAInternationalizationManager parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/03/2016 10:07'!
openLanguageConfiguration

	(arena isKindOf: WASetUserLanguage)
	ifTrue: [^arena].

	^WASetUserLanguage parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 03/15/2016 10:54'!
openLoginMode

	(arena isKindOf: WALoginModeManager)
	ifTrue: [^arena].

	^WALoginModeManager parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 06/30/2015 14:12'!
openProcessCategoryManager

	(arena isKindOf: WAManageFormProcessCategory)
	ifTrue: [^arena].

	^WAManageFormProcessCategory parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/20/2015 15:23'!
openProcessRadar

	(arena isKindOf: WAOrbeonRadarProcessComposite2)
	ifTrue: [^arena].

	^WAOrbeonRadarProcessComposite2 parent: self! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 03/15/2016 10:48'!
openRolesManager

	(arena isKindOf: WABpmRoleManager)
	ifTrue: [^arena].

	^WABpmRoleManager parent: self on: BpmFrontOfficeRole new.! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 03/15/2016 10:59'!
openServerSetup

	(arena isKindOf: WAServerConfigurationManager)
	ifTrue: [^arena].

	^(WAServerConfigurationManager parent: self)
		yourself! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 03/15/2016 10:51'!
openUsersManager

	(arena isKindOf: WABpmUserManager)
	ifTrue: [^arena].

	^WABpmUserManager parent: self on: BpmUser new.! !

!WAProcessBackofficePortal methodsFor: 'subcomponents' stamp: 'BrunoBB 12/20/2015 14:56'!
openUsersRadar

	(arena isKindOf: WAOrbeonRadarUserComposite2)
	ifTrue: [^arena].

	^WAOrbeonRadarUserComposite2 parent: self! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 16:21'!
searchResult: aCollection

	arena ifNotNil: [arena searchResult: aCollection].! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 16:09'!
selectedLateralItem: anObject

	arena ifNotNil: [arena selectedLateralItem: anObject].! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 09/05/2016 15:31'!
selectorsToInclude

	"^#(basicPortalStylesCss backofficePortalCss leftMenuLayoutCss rightMenuLayoutCss topMenuLayoutCss)"

	^#(basicPortalStylesCss backofficePortalCss topMenuLayoutCss)! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 04/10/2016 16:20'!
setSearchApplied

	arena ifNotNil: [arena searchApplied: true].! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 03/15/2016 10:44'!
showUserPreferences

	^WABkBpmUserPreference new! !

!WAProcessBackofficePortal methodsFor: 'style' stamp: 'BrunoBB 09/05/2016 14:31'!
style2

	^super style,
'/* START: BACK OFFICE STYLES */
#add-new-import-form {
  display: inline-flex;
  margin-top: 10px;
}
#add-new-form-button {
  padding: 10px;
}
#add-rol-button {
  float: left;
  margin-top: 20px;
}
#add-user-button {
  float: left;
  margin-top: 40px;
}
#applications-list {
  float: left;
  margin-left: 10px;
}
#applications-list select {
  width: 300px;
}
#forms-operations {
  float: left;
  width: 200px;
}
#forms-operations input {
  border-radius: 10px;
  margin-left: 10px;
  margin-bottom: 10px;
}
.import-all-button-1 {
  padding: 10px;
}
.import-all-button-2 {
  margin-top: 10px;
  margin-left: 10px;
}
.import-csv-info {
  background-color: beige;
  padding: 10px;
  border-radius: 15px;
  border: 2px solid green;
}
#import-forms {
  overflow-y: auto;
  display: inline-block;
  width: 100%;
  bottom: 0px;
  position: absolute;
  max-height: 100%;
  top: 112px;
}
#internationalization {
}
#internationalization fieldset {
  border: medium none;
}
#internationalization label, #internationalization input, #internationalization select {
  width: 200px;
  border-radius: 10px;
  margin-right: 15px;
}
#inter-current-dictionary {
  height: 480px;
  margin-left: auto;
  margin-right: auto;
  width: 90%;
  overflow-y: auto;
}
#inter-current-dictionary output {
  color: #66650B;
}
#inter-current-dictionary span {
  color: rgb(14, 79, 101);
}
#orbeon-definitions-list {
  padding-top: 10px;
  float: left;
}
#orbeon-list-application {
  padding-top: 20px;
  float: left;
}
#radar {
  display: inline-flex;
}
#remove-new-form-button {
  padding-top: 10px;
}
#rols-users {
  padding-bottom: 20px;
}
#rols-and-users {
  float: left;
  display: inline-flex;
}
#system-rols {
  display: inline-flex;
  float: left;
}
#system-users {
  display: inline-flex;
  float: left;
}
#users-and-rols {
  float: left;  
}
#users-configuration {
}
#user-rols {
}
#users-to-add-to-role {
  float: left;
}
#users-to-add-to-role input {
  border-radius: 10px;
}
#users-to-add-to-role input[type="submit"] {
  margin-top: 20px;
}
.transition-condition {
  padding-top: 20px;
  padding-bottom: 20px;
  padding-left: 40px;
  padding-right: 40px;
  background-color: lightgray;
  border-radius: 30px;
}
.transition-def-artifact {
    padding-top: 20px;
    padding-left: 40px;
    padding-right: 40px;
    background-color: #868686;
    border-radius: 10px;
}
/* END: BACK OFFICE STYLES */
'! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 09/05/2016 15:44'!
updateRoot: anHtmlRoot

    super updateRoot: anHtmlRoot.

    SEWAFCssLibrary default updateRoot: anHtmlRoot.

	anHtmlRoot stylesheet url: (SEWAFCssLibrary / layout cssFileName).
"
'http://192.168.29.142:8787/files/SEWAFCssLibrary/main.css'
"! !

!WAProcessBackofficePortal methodsFor: 'other' stamp: 'BrunoBB 11/19/2016 12:00'!
versionName

	^'2016 q4 v3.3.0'! !
